! Added module to KGEC for the calculation of other properties based on KG
! 
! Copyright (C) 2017- Lazaro Calderin and Valentin Karasiev
! 
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 

module kgepsilon2

use kinds, ONLY    : DP
use qevars, ONLY   : pi
use kgecvars, ONLY : nw, wgrid, de
use kgsigma1, ONLY : sigma1, sigma1_atrace, &
                      sigma1_intra, sigma1_degen, sigma1_inter, &
                      sigma1_atrace_intra, &
                      sigma1_atrace_degen, &
                      sigma1_atrace_inter

implicit none


   private

   ! \epsilon_2 and its decomposition in intra-bands, degeneracies and 
   ! inter-bands contributions
   real(DP), allocatable, public :: epsilon2(:,:,:)       
   real(DP), allocatable, public :: epsilon2_intra(:,:,:)  
   real(DP), allocatable, public :: epsilon2_degen(:,:,:)  
   real(DP), allocatable, public :: epsilon2_inter(:,:,:) 

   ! Average traces
   real(DP), allocatable, public :: epsilon2_atrace(:)    
   real(DP), allocatable, public :: epsilon2_atrace_intra(:)     
   real(DP), allocatable, public :: epsilon2_atrace_degen(:)     
   real(DP), allocatable, public :: epsilon2_atrace_inter(:)     

   public :: epsilon2_tensor,                         &   
             epsilon2_atrace_sub,                     &
             epsilon2_tensor_decomp,                  &
             epsilon2_atrace_decomp


  integer :: iw, ix, ierr

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon2_tensor()

   ! dielectric tensor ( imaginary part )
   allocate( epsilon2(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor','allocating epsilon2', ABS(ierr) )

   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2(1:3,1:3, iw) = 4.0d0 * pi * sigma1( 1:3, 1:3, iw)  / wgrid(iw)
   enddo

   ! traces
   
   allocate( epsilon2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor',&
                  'allocating epsilon2_atrace', ABS(ierr) )

   epsilon2_atrace(:) = & 
       ( epsilon2(1,1,:) + epsilon2(2,2,:) + epsilon2(3,3,:) ) / 3.0_dp

end subroutine epsilon2_tensor

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon2_tensor_decomp()

   ! dielectric tensor ( imaginary part ) intra-band contribution
   allocate( epsilon2_intra(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_intra', ABS(ierr) )
   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2_intra(1:3,1:3, iw) = &
              4.0d0 * pi * sigma1_intra( 1:3, 1:3, iw)  / wgrid(iw)
   enddo

   ! Traces

   allocate( epsilon2_atrace_intra(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_atrace_intra', ABS(ierr) )

   epsilon2_atrace_intra(:) = & 
       ( epsilon2_intra(1,1,:) + epsilon2_intra(2,2,:) &
                               + epsilon2_intra(3,3,:) ) / 3.0_dp


   ! dielectric tensor ( imaginary part ) degeneracies contribution

   allocate( epsilon2_degen(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_degen', ABS(ierr) )
   do iw = 0, nw

      if ( wgrid(iw) > de ) &
         epsilon2_degen(1:3,1:3, iw) = &
              4.0d0 * pi * sigma1_degen( 1:3, 1:3, iw)  / wgrid(iw)
   enddo

   ! Traces

   allocate( epsilon2_atrace_degen(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_atrace_degen', ABS(ierr) )

   epsilon2_atrace_degen(:) = & 
       ( epsilon2_degen(1,1,:) + epsilon2_degen(2,2,:) &
                              + epsilon2_degen(3,3,:) ) / 3.0_dp

   ! dielectric tensor ( imaginary part ) inter-band contribution

   allocate( epsilon2_inter(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_inter', ABS(ierr) )

   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2_inter(1:3,1:3, iw) = &
              4.0d0 * pi * sigma1_inter( 1:3, 1:3, iw)  / wgrid(iw)
   enddo

   ! Traces

   allocate( epsilon2_atrace_inter(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_atrace_inter', ABS(ierr) )

   epsilon2_atrace_inter(:) = & 
       ( epsilon2_inter(1,1,:) + epsilon2_inter(2,2,:) &
                               + epsilon2_inter(3,3,:) ) / 3.0_dp

   allocate( epsilon2(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2', ABS(ierr) )

   epsilon2 = epsilon2_intra + epsilon2_degen  + epsilon2_inter

   allocate( epsilon2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon2_atrace', ABS(ierr) )

   epsilon2_atrace = epsilon2_atrace_intra + epsilon2_atrace_degen & 
                    + epsilon2_atrace_inter


end subroutine epsilon2_tensor_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon2_atrace_sub

   ! dielectric tensor ( imaginary part )
   allocate( epsilon2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace',&
                  'allocating epsilon2_atrace', ABS(ierr) )

   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2_atrace(iw) = 4.0d0 * pi * sigma1_atrace( iw )  / wgrid(iw)
   enddo

end subroutine epsilon2_atrace_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon2_atrace_decomp()

  ! dielectric tensor ( imaginary part ) intra-band contribution

   allocate( epsilon2_atrace_intra(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon2_atrace_intra', ABS(ierr) )

   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2_atrace_intra(iw) = 4.0d0 * pi * sigma1_atrace_intra( iw )  / wgrid(iw)
   enddo

   ! dielectric tensor ( imaginary part ) degeneracies contribution

   allocate( epsilon2_atrace_degen(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon2_atrace_degen', ABS(ierr) )

   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2_atrace_degen(iw) = 4.0d0 * pi * sigma1_atrace_degen( iw )  / wgrid(iw)
   enddo

   ! dielectric tensor ( imaginary part ) inter-band contribution

   allocate( epsilon2_atrace_inter(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon2_atrace_inter', ABS(ierr) )

   do iw = 0, nw
      if ( wgrid(iw) > de ) &
         epsilon2_atrace_inter(iw) = &
                            4.0d0 * pi * sigma1_atrace_inter( iw )  / wgrid(iw)
   enddo

   ! Total traces


   allocate( epsilon2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon2_atrace', ABS(ierr) )

   epsilon2_atrace = epsilon2_atrace_intra + epsilon2_atrace_degen &
                                           + epsilon2_atrace_inter


end subroutine epsilon2_atrace_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end module kgepsilon2

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgsigma2
! \sigma_2

use kinds, ONLY    : DP
use qevars
use kgecvars, ONLY : deltarep, deltawidth, nw, wmin, wmax, wgrid, dw, sa, sg, &
                     psi_grad_psi, de, sigma2_notintra,                       &
                     nbnds_local, nbnds_per_process, nbnds_per_group,         &
                     my_rank, my_rank_old, my_group
use parallel

implicit none
 
   private

   ! Internal units : atomic Ha
   ! Note on multipliying by the prefactor 2 / omega for sigma2 in a.u.
   ! - The 2 went into the wg ( the combined fermi-dirac and k-weighting factor)
   
   ! Gradient matrix elements needed as input
   ! complex(DP), allocatable    :: psi_grad_psi(:,:,:,:)

   ! \sigma_2 and its decomposition in intra bands, degenerate and inter bands 
   ! contributions

   real(DP), allocatable, public :: sigma2(:,:,:)
   real(DP), allocatable, public :: sigma2_intra(:,:,:)        
   real(DP), allocatable, public :: sigma2_inter(:,:,:)  
   real(DP), allocatable, public :: sigma2_degen(:,:,:)  

   ! Average traces
   real(DP), allocatable, public :: sigma2_atrace(:)
   real(DP), allocatable, public :: sigma2_atrace_intra(:)     
   real(DP), allocatable, public :: sigma2_atrace_degen(:)     
   real(DP), allocatable, public :: sigma2_atrace_inter(:)     

   public :: sigma2_sub, sigma2_decomp, sigma2_atrace_sub, &
             sigma2_atrace_decomp


   ! Private variables

   real(DP) :: aux, aux2, ee, eem, eep, maux(3,3)

   integer :: ios , ierr ! Input and memory allocation error status variables

   integer :: iw                          ! Frequency index
   integer :: ik, ib1, ib2, ibb1          ! counters on k-points and bands
   integer :: ig                          ! counter on plane waves
   integer :: ix1, ix2                    ! labels x, y an z

   real(DP) :: focc, dfde


   contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine frequency_grid()
   !
   ! Frequency grid
   !

      dw   = ( wmax - wmin ) / dble(nw)  ! Frecuency step

      allocate( wgrid(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma2','allocating wgrid', abs(ierr))
      
      ! Frequency grid in eV
      do iw = 0, nw
         wgrid(iw) = wmin + iw * dw
      enddo


      write(stdout,*) '    Frequency grid:'
      write(stdout,*) "       Frequency step (eV)    :", dw
      write(stdout,*) "       Frequency steps        :", nw
      write(stdout,'(a, f10.4,a,f10.4 )') &
                 "        Frequency range (eV)   :", wgrid(0),  ' to ',wgrid(nw)

     ! Change units to Ha
     wgrid = wgrid / AUTOEV
     dw    = dw    / AUTOEV

   end subroutine frequency_grid


   !===========================================================================
   !                 Full conductivity tensor \sigma_2
   !===========================================================================
   !

   subroutine sigma2_sub

      allocate( sigma2(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2','allocating sigma2', ABS(ierr) )
 
      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux  = 0.5_dp                 ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                    !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2
      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                   if ( sigma2_notintra .and. ib2 == ib1 ) cycle   

                   ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                   eem = ee - wgrid(iw)                       ! in Ha
                   eep = ee + wgrid(iw)                       ! in Ha

                   if ( ib1 == ib2 .or. abs(ee) <=  de ) then
                      focc = 1.0_DP/(dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP )
                      dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss*2.0_DP
                   endif

                   if ( abs(ee) > de ) &
                      dfde = ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                      maux(ix2,ix1) = maux(ix2,ix1)                            &
                                 + dfde                                        &
                                  *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                          *    psi_grad_psi(ix2,ib2,ibb1,ik)  )&
                                          * (    eem/( eem*eem + sa*sa )       &
                                               - eep/( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1
      enddo ! ix2

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

      sigma2(1:3,1:3,iw) = - aux * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma2_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2','allocating sigma1_atrace', ABS(ierr))

    
      sigma2_atrace(0:nw) = ( sigma2(1,1,0:nw) + & 
                              sigma2(2,2,0:nw) + &
                              sigma2(3,3,0:nw) ) / 3.0_DP


   end subroutine sigma2_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_decomp

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux  = 0.5_dp                 ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                    !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      ! Intra bands contribution

      allocate( sigma2_intra(1:3,1:3,0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2','allocating sigma2_intra',ABS(ierr))
 
      do iw = 0, nw
         eem = wgrid(iw)

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP/( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP )
                  dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))&
                                            *   psi_grad_psi(ix2,ib1,ibb1,ik) )&
                                     * ( eem/( eem*eem + sa*sa ) )

               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_intra(1:3,1:3,iw) = - maux(1:3,1:3) / omega

      enddo ! iw
      ! End intra bands contribution


      ! Degeneracies contribution
      allocate( sigma2_degen(1:3,1:3,0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2','allocating sigma2_degen',ABS(ierr))

      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     focc =  1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                     dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     maux(ix2,ix1) = maux(ix2,ix1)                             &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                            *   psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                     * ( eem/( eem*eem + sa*sa ) - &
                                         eep/( eep*eep + sa*sa ) )
                   endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_degen(1:3,1:3,iw) = - aux * maux(1:3,1:3) / omega

      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma2_inter(1:3,1:3,0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2','allocating sigma2_inter',ABS(ierr))

      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle 

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <= de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  dfde = ( wg(ib2,ik) - wg(ib1,ik) )/ee

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                           *     psi_grad_psi(ix2,ib2,ibb1,ik))&
                                             * (   eem/( eem*eem + sa*sa )     &
                                                 - eep/( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo    ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_inter(1:3,1:3,iw) = - aux * maux(1:3,1:3) / omega

      enddo ! iw


      allocate( sigma2(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2','allocating sigma2', ABS(ierr) )
      sigma2 = sigma2_degen + sigma2_inter

      allocate( sigma2_atrace_degen(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2','allocating sigma2_atrace_degen', &
                                                                      ABS(ierr))
      allocate( sigma2_atrace_inter(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2','allocating sigma2_atrace_inter', &
                                                                      ABS(ierr))

      sigma2_atrace_degen(0:nw) = ( sigma2_degen(1,1,0:nw) + &
                    sigma2_degen(2,2,0:nw) + sigma2_degen(3,3,0:nw) )/3.0_DP
      sigma2_atrace_inter(0:nw) = ( sigma2_inter(1,1,0:nw) + &
                    sigma2_inter(2,2,0:nw) + sigma2_inter(3,3,0:nw) )/3.0_DP

      allocate( sigma2_atrace(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2','allocating sigma2_atrace', &
                                                                      ABS(ierr))

      sigma2_atrace = sigma2_atrace_degen + sigma2_atrace_inter


   end subroutine sigma2_decomp


   !============================================================================
   !             Average trace of \sigma_2 = tr(sigma2)/3
   !============================================================================


   subroutine sigma2_atrace_sub

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux  = 0.5_dp                 ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                    !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      allocate( sigma2_atrace(0:nw), STAT=ierr )
      if(ierr/=0) call errore('kgcond','allocating sigma2_atrace', abs(ierr))

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd
              
                  if ( sigma2_notintra .and. ib2 == ib1 ) cycle  

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if ( ib1 == ib2 .or. abs(ee) <=  de ) then
                     focc = 1.0_DP / (dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP)
                     dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif

                  if ( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                     aux2 = aux2                                               &
                            + dfde                                             &
                                * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )     &
                                 *        psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                  * (   eem/( eem*eem + sa*sa )                &
                                      - eep/( eep*eep + sa*sa ) )

              enddo ! ib2
              enddo ! ib1

           enddo ! ik

        enddo    ! ix1

        call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
        call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

        sigma2_atrace(iw) = - aux * aux2 / (3.0_DP * omega)

      enddo ! iw

   end subroutine sigma2_atrace_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_atrace_decomp

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux  = 0.5_dp                 ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                    !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      ! Intra bands contribution
      allocate( sigma2_atrace_intra(0:nw), STAT=ierr )
      if(ierr/=0) &
        call errore('kgsigma2','allocating sigma2_atrace_intra', abs(ierr))

      do iw = 0, nw
         eem = wgrid(iw)
         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group


                   focc =1.0_DP / ( dexp(( et(ib1,ik) - e_f )/degauss)+1.0_DP)
                   dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                   aux2 = aux2                                                 &
                            +   dfde                                           &
                                * conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )     &
                                  *       psi_grad_psi( ix1,ib1,ibb1,ik )      &
                                   * ( eem/( eem*eem + sa*sa )  )               

               enddo ! ib1
            enddo ! ik
         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_atrace_intra(iw) = - aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End intra bands contribution

      ! Degeneracies contribution
      allocate( sigma2_atrace_degen(0:nw), STAT=ierr )
      if(ierr/=0) call errore('kgsigma2','allocating sigma2_atrace', &
                                                                      abs(ierr))

      do iw = 0, nw
         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if ( abs(ee) <= de ) then
                     focc =1.0_DP / ( dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP)
                     dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     aux2 = aux2                                               &
                            +   dfde                                           &
                                * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )     &
                                  *       psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                   * ( eem/( eem*eem + sa*sa )                 &
                                       -eep/( eep*eep + sa*sa ) )

                 endif

               enddo ! ib2
               enddo ! ib1
            enddo ! ik
         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_atrace_degen(iw) = - aux * aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma2_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma2','allocating sigma2_atrace_inter', &
                                                                      abs(ierr))

      do iw = 0, nw
         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <=  de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  aux2 = aux2                                                  &
                         + dfde                                                &
                             * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )        &
                                *      psi_grad_psi( ix1,ib2,ibb1,ik )         &
                                  * ( eem/( eem*eem + sa*sa )                  &
                                      - eep/( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo ! ib1
            enddo ! ik
         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_atrace_inter(iw) = - aux * aux2 / (3.0_DP * omega)

      enddo ! iw


      allocate( sigma2_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2','allocating sigma2_atrace', &
                                                                     ABS(ierr) )

      sigma2_atrace = sigma2_atrace_degen + sigma2_atrace_inter

   end subroutine sigma2_atrace_decomp

end module kgsigma2

module kgrrae
!
! Calculation of refraction, reflection and absoption coefficients,
! and EELS.
!
use kinds,      only : DP
use qevars,     only : pi, C_AU
use kgecvars,   only : nw, wgrid
use kgepsilon1, only : epsilon1_atrace
use kgepsilon2, only : epsilon2_atrace

implicit none

   private

   real(DP), allocatable, public :: reflection(:), absorption(:), &
                                    n_real(:), n_imag(:), eels(:)

   real(DP), allocatable :: epsilon_module(:)

   public :: rrae

contains

subroutine rrae 

    allocate( reflection(0:nw) )
    allocate( absorption(0:nw) )
    allocate( n_real(0:nw) )
    allocate( n_imag(0:nw) )
    allocate( epsilon_module(0:nw) )
    allocate( eels(0:nw) )    

    epsilon_module = sqrt(   epsilon1_atrace * epsilon1_atrace &
                           + epsilon2_atrace * epsilon2_atrace )

    ! Refraction index ( real part )
    n_real = sqrt( 0.5_dp * ( epsilon_module + epsilon1_atrace) )

    ! Refraction index ( imaginary part ) 
    n_imag = sqrt( 0.5_dp * ( epsilon_module - epsilon1_atrace  ) )

   ! Reflection
   reflection = &
         ( ( 1.0_dp - n_real ) * ( 1.0_dp - n_real ) + n_imag * n_imag ) &
       / ( ( 1.0_dp + n_real ) * ( 1.0_dp + n_real ) + n_imag * n_imag )

    ! Absorpttion
    !absorption = 4.0_dp * pi * sigma1_atrace / n_real / C_AU
    absorption = wgrid * epsilon2_atrace / n_real / C_AU

    ! Electron Energy Loss Spectrum
    eels = epsilon2_atrace / (epsilon_module * epsilon_module )

end subroutine rrae

end module kgrrae

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module apawgm
   ! Atomic Projector Augmented Waves Gradient Matrix elements (apawgm)
   ! Variables and subroutines for the calculation of the matrix elements of the gradient operator
   ! \nabla over atomic wave functions and pseudo wave functions.
   ! For PAW sets only
   !
   ! < \phi_i | \nabla | \phi_j >  is stored in the atwfc_grad_atwfc() matrix
   ! < \hat{\phi}_i | \nabla | \hat{\phi}_j >  in the pswfc_grad_pswfc() matrix

   use kinds, ONLY : DP

   ! Atomic Data
   USE atom,           ONLY : msh, rgrid
   !USE paw_onecenter,  ONLY : PAW_potential
   !USE paw_symmetry,   ONLY : PAW_symmetrize_ddd
   USE uspp_param,     ONLY : upf, nh, nhm, nbetam

   ! Real Space Unit cell
   USE ions_base,  ONLY : nat, ityp, tau, ntyp => nsp
   use cell_base,  ONLY : tpiba, tpiba2, omega

   use constants, ONLY : pi

   use qevars, ONLY : stdout

   implicit none
   private

   logical :: use_real_spherical_harm = .true.
   complex(DP), allocatable, public :: DG(:,:,:), psi_norm_correction_at(:,:)

   integer, public :: n_pro_type_tot, n_pro_tot

   integer, allocatable, public :: p_index_type(:), p_index_type_all(:),&
                                   p_index(:), plm_index(:,:,:), &
                                   p_index_row_start(:), p_index_row_end(:)
   logical :: indexes_set=.false.

   real(DP), allocatable :: Rd(:,:,:), R(:,:,:), pRd(:,:,:), pR(:,:,:)
   complex(DP) :: I_r(0:3,-3:3,0:3,-3:3,1:3), I_theta(0:3,-3:3,0:3,-3:3,1:3), I_phi(0:3,-3:3,0:3,-3:3,1:3)

   integer    :: it, l, lp, m, mp ! counters for types of atoms, angular momentum and magnetic quantum number
   integer    :: ierr

#ifdef __KGDEBUG
   integer ir
   character*256 filename
#endif   

   ! Public subroutines
   public :: use_real_spherical_harm, awfc_grad_awfc, check_p_pswfc, & 
             diff_awfc_grad_awfc, psi_norm_correction_paw_at, agm_free_memory

   ! Public variables
   !public ::atwfc_grad_atwf, pswfc_grad_pswfc, DG, psi_norm_correction_at
   !public :: n_pro_type_tot

 contains

     subroutine Rmatrices()
     ! Radial integrals R and pR defined as:
     ! R(it,p,p')  = \int_0^\infty r   R_{l(p)}(r) R_{l'(p')}(r) dr
     ! pR(it,p,p') = \int_0^\infty r^2 R_{l(p})(r) \frac{dR_{l'(p')}(r)}{dr} dr
     ! it = counter on atom types, p,p'= counter on projectors,
     ! l(p),l(p')= angular momentum of the p and p' projectors
     ! Notice that pswfc and aewfc are r*R or r* \pseudo R

     implicit none
!     real(DP), allocatable :: Rd(:,:,:,:), R(:,:,:,:), pRd(:,:,:,:), pR(:,:,:,:)

        integer               :: it     ! counter for type of atoms
        integer               :: ip, jp ! counter for projectors
        integer               :: ir     ! counter for radial grid points

        real(DP), allocatable :: dRdr(:), integrand(:)
        real(DP) :: integral

        !character(len=1024) :: filename

        allocate( Rd(1:ntyp,1:nbetam,1:nbetam), R(1:ntyp,1:nbetam,1:nbetam), &
                  pRd(1:ntyp,1:nbetam,1:nbetam), pR(1:ntyp,1:nbetam,1:nbetam), &
                                                                     STAT=ierr )
        if (ierr/=0) call errore('kgec:Rmatrices','allocating Rd, pRd, &
                                                           and/or pR',ABS(ierr))

        ! Radial integrals for all electron atomic orbitals

        do it = 1, ntyp

           if (.not.upf(it)%has_wfc) &
              call errore( 'kgec:vm','AE wavefunctions not in file', 1 )
           allocate( integrand(1:rgrid(it)%mesh), STAT=ierr )
           if (ierr/=0) call errore('kgec:Rmatrices','allocating integrand', &
                                                                      ABS(ierr))

           do ip=1, upf(it)%nbeta
              do jp=1, upf(it)%nbeta
                 integrand(1:rgrid(it)%mesh) = &
                                            upf(it)%aewfc(1:rgrid(it)%mesh,ip) &
                                            * upf(it)%aewfc(1:rgrid(it)%mesh,jp)

                 do ir=1, rgrid(it)%mesh
                    if ( rgrid(it)%r(ir) .gt. 0.0_DP ) &
                       integrand(ir) = integrand(ir)/rgrid(it)%r(ir)
                 enddo
                 call simpson(rgrid(it)%mesh, integrand, rgrid(it)%rab,integral)
                 R(it,ip,jp) = integral

              enddo
           enddo
           deallocate(integrand)
        enddo

        do it = 1, ntyp
           allocate( integrand(1:rgrid(it)%mesh), dRdr(1:rgrid(it)%mesh), &
                                                                     STAT=ierr )
           if (ierr/=0) call errore('kgec:Rmatrices','allocating &
                                               integrand and/or dRdr',ABS(ierr))

           do jp=1, upf(it)%nbeta
              call radial_gradient( upf(it)%aewfc(1:rgrid(it)%mesh,jp), &
                                                dRdr(1:rgrid(it)%mesh), &
                                          rgrid(it)%r, rgrid(it)%mesh, 0)

              do ir=1, rgrid(it)%mesh
                 if ( rgrid(it)%r(ir) .gt. 0.0_DP ) then
                    dRdr(ir) = dRdr(ir) - upf(it)%aewfc(ir,jp)/rgrid(it)%r(ir)
                 endif
              enddo

              do ip=1, upf(it)%nbeta

!                 write(filename,"('R_',i3.3,'_dRdr_',i3.3,'.dat')") ip,jp
!                 open(11,file=filename,action='write')
!                 do ir=1, rgrid(it)%mesh
!		             write(11,'(4e16.6)') rgrid(it)%r(ir), upf(it)%aewfc(ir,ip),dRdr(ir), upf(it)%aewfc(ir,ip)*dRdr(ir)
!                 enddo
!                 close(11)

                 integrand(1:rgrid(it)%mesh) = &
                                            upf(it)%aewfc(1:rgrid(it)%mesh,ip) &
                                            * dRdr(1:rgrid(it)%mesh)
                 call simpson(rgrid(it)%mesh, integrand, rgrid(it)%rab,integral)
                 Rd(it,ip,jp) = integral
              enddo
           enddo
           deallocate(integrand, dRdr)
        enddo


        ! Radial integrals for all electron atomic pseudo orbitals

        do it = 1, ntyp

           allocate( integrand(1:rgrid(it)%mesh), STAT=ierr )
           if (ierr/=0) call errore('kgec:Rmatrices','allocating integrand', &
                                                                      ABS(ierr))

           do ip=1, upf(it)%nbeta
              do jp=1, upf(it)%nbeta
                 integrand(1:rgrid(it)%mesh) = &
                                             upf(it)%pswfc(1:rgrid(it)%mesh,ip) &
                                           * upf(it)%pswfc(1:rgrid(it)%mesh,jp)
                 do ir=1, rgrid(it)%mesh
                    if ( rgrid(it)%r(ir) .gt. 0.0_DP ) &
                       integrand(ir) = integrand(ir)/rgrid(it)%r(ir)
                 enddo
                 call simpson(rgrid(it)%mesh, integrand, rgrid(it)%rab,integral)
                 pR(it,ip,jp) = integral
              enddo
           enddo

           deallocate(integrand)
        enddo


        do it = 1, ntyp
           allocate( integrand(1:rgrid(it)%mesh), dRdr(1:rgrid(it)%mesh), &
                                                                     STAT=ierr )
           if (ierr/=0) call errore('kgec','allocating integrand and or dRdr',&
                                                                     ABS(ierr))

           do jp=1, upf(it)%nbeta

              call radial_gradient( upf(it)%pswfc(1:rgrid(it)%mesh,jp), &
                                                dRdr(1:rgrid(it)%mesh), &
                                           rgrid(it)%r, rgrid(it)%mesh, 1)

              do ir=1, rgrid(it)%mesh
                 if ( rgrid(it)%r(ir) .gt. 0.0_DP ) then
                    dRdr(ir) = dRdr(ir) - upf(it)%pswfc(ir,jp)/rgrid(it)%r(ir)
                 endif
              enddo


              do ip=1, upf(it)%nbeta

!                  write(filename,"('pR_',i3.3,'_dpRdr_',i3.3,'.dat')") ip,jp
!                  open(11,file=filename,action='write')
!                  do ir=1, rgrid(it)%mesh
!		             write(11,'(4e16.6)') rgrid(it)%r(ir), upf(it)%pswfc(ir,ip),dRdr(ir),upf(it)%pswfc(ir,ip)*dRdr(ir)
!                  enddo
!                  close(11)

                 integrand(1:rgrid(it)%mesh) = &
                     upf(it)%pswfc(1:rgrid(it)%mesh,ip) * dRdr(1:rgrid(it)%mesh)
                 call simpson( rgrid(it)%mesh, integrand, rgrid(it)%rab, integral )
                 pRd(it,ip,jp) = integral

              enddo ! jp
           enddo ! ip

           deallocate(integrand,dRdr)
        enddo ! it

#ifdef __KGDEBUG

        open(222,file='R-pR.dat',action='write')
        write(222,*) &
        "l    l'     \int_0^\infty r ( R_l R_l' - \~R_l \~R_l' ) dr"
        do it = 1, ntyp
           do jp=1, upf(it)%nbeta
              do ip=1, upf(it)%nbeta
                 write(222,*) ip,jp, R(it,ip,jp)-pR(it,ip,jp)
              enddo
           enddo
        enddo
        close(222)

        open(222,file='Rd-pRd.dat',action='write')
        write(222,*) &
        "l    l'    \int_0^\infty r^2 ( R_l dR_l'/dr - \~R_l d \~R_l'/dr ) dr "
        do it = 1, ntyp
           do jp=1, upf(it)%nbeta
              do ip=1, upf(it)%nbeta
                 write(222,*) ip,jp, Rd(it,ip,jp)-pRd(it,ip,jp)
              enddo
           enddo
        enddo
        close(222)

#endif

     end subroutine Rmatrices


     subroutine check_p_pswfc()
     implicit none

        integer               :: it     ! counter on type of atoms
        integer               :: ip, jp ! counter on projectors

        real(DP), allocatable :: integrand(:)
        real(DP) :: integral

        write(stdout,*) ""
        write(stdout,'(A)') "     Checking the duality of projectors and pseudo orbitals:"


        do it = 1, ntyp

           write(stdout,*)      "     Atom type:", it
           write(stdout,'(A)')  &
           '      projector  l     pswfc     l      < proj | pswfc >'

           allocate( integrand(1:rgrid(it)%mesh), STAT=ierr )
           if (ierr/=0) call errore('kgec:Rmatrices','allocating integrand',ABS(ierr))

           do ip=1, upf(it)%nbeta
              do jp=1, upf(it)%nbeta

!exp(-rgrid(it)%r( 1:rgrid(it)%mesh ))*
!upf(it)%beta(1:rgrid(it)%mesh,ip)=sin( 2*Pi*ip/rgrid(it)%r( rgrid(it)%mesh )*rgrid(it)%r(1:rgrid(it)%mesh) )
!upf(it)%pswfc(1:rgrid(it)%mesh,jp)=sin( 2*Pi*jp/rgrid(it)%r( rgrid(it)%mesh )*rgrid(it)%r(1:rgrid(it)%mesh) )

#ifdef __KGDEBUG

                 write(filename,"('proj-pswfc_', i3.3 ,'_', i3.3 , '.dat')" ) &
                                                                           ip,jp
                 open( 12, file = filename, action = 'write' )
                 do ir=1, rgrid(it)%mesh
                    write(12,'(3e16.6)') rgrid(it)%r(ir), &
                                       upf(it)%beta(ir,ip)* upf(it)%pswfc(ir,jp)
                 enddo
                 close(12)

#endif

                 integrand(1:rgrid(it)%mesh) = & 
                                             upf(it)%beta(1:rgrid(it)%mesh,ip) &
                                            * upf(it)%pswfc(1:rgrid(it)%mesh,jp)
                 call simpson( rgrid(it)%mesh, integrand, rgrid(it)%rab, integral )

                 if ( upf(it)%lll(ip) == upf(it)%lll(jp) ) then
                    write(stdout,'(6x,1I4,7x,I1, 4x , 1I4,7x,I1, 9x, f10.6)') &
                         ip,upf(it)%lll(ip),jp,upf(it)%lll(jp), integral
                 else
                    write(stdout,'(6x,1I4,7x,I1, 4x , 1I4,7x,I1, 9x, A)') &
                         ip,upf(it)%lll(ip),jp,upf(it)%lll(jp), &
                         '  0.0_DP    (orthogonal by angular momentum)'
                 endif

              enddo
           enddo
           deallocate(integrand)
        enddo

     end subroutine check_p_pswfc


     subroutine Imatrices_csh
     ! I matrices using complex spherical harmonics
     implicit none

         I_r     = (0.0_DP,0.0_DP)
         I_theta = (0.0_DP,0.0_DP)
         I_phi   = (0.0_DP,0.0_DP)

         I_r(1,-1,0,0,1) = cmplx( 1.0_DP/sqrt(6.0_DP), 0.0_DP )
         I_r(1,1,0,0,1) = cmplx( -1.0_DP/sqrt(6.0_DP), 0.0_DP )
         I_r(0,0,1,-1,1) = cmplx( 1.0_DP/sqrt(6.0_DP), 0.0_DP )
         I_r(2,-2,1,-1,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,0,1,-1,1) = cmplx( -1.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_r(2,-1,1,0,1) = cmplx( 1.0_DP/sqrt(10.0_DP), 0.0_DP )
         I_r(2,1,1,0,1) = cmplx( -1.0_DP/sqrt(10.0_DP), 0.0_DP )
         I_r(0,0,1,1,1) = cmplx( -1.0_DP/sqrt(6.0_DP), 0.0_DP )
         I_r(2,0,1,1,1) = cmplx( 1.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_r(2,2,1,1,1) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(1,-1,2,-2,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(3,-3,2,-2,1) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(3,-1,2,-2,1) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(1,0,2,-1,1) = cmplx( 1.0_DP/sqrt(10.0_DP), 0.0_DP )
         I_r(3,-2,2,-1,1) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,0,2,-1,1) = cmplx( -3.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(1,-1,2,0,1) = cmplx( -1.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_r(1,1,2,0,1) = cmplx( 1.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_r(3,-1,2,0,1) = cmplx( 3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(3,1,2,0,1) = cmplx( -3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(1,0,2,1,1) = cmplx( -1.0_DP/sqrt(10.0_DP), 0.0_DP )
         I_r(3,0,2,1,1) = cmplx( 3.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(3,2,2,1,1) = cmplx( -1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(1,1,2,2,1) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(3,1,2,2,1) = cmplx( 1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,3,2,2,1) = cmplx( -3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(2,-2,3,-3,1) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(2,-1,3,-2,1) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,-2,3,-1,1) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,0,3,-1,1) = cmplx( 3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(2,-1,3,0,1) = cmplx( -3.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(2,1,3,0,1) = cmplx( 3.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(2,0,3,1,1) = cmplx( -3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(2,2,3,1,1) = cmplx( 1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,1,3,2,1) = cmplx( -1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,2,3,3,1) = cmplx( -3.0_DP/sqrt(42.0_DP), 0.0_DP )

         I_r(1,-1,0,0,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(6.0_DP) )
         I_r(1,1,0,0,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(6.0_DP) )
         I_r(0,0,1,-1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(6.0_DP) )
         I_r(2,-2,1,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(5.0_DP) )
         I_r(2,0,1,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(30.0_DP) )
         I_r(2,-1,1,0,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(10.0_DP) )
         I_r(2,1,1,0,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(10.0_DP) )
         I_r(0,0,1,1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(6.0_DP) )
         I_r(2,0,1,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(30.0_DP) )
         I_r(2,2,1,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(5.0_DP) )
         I_r(1,-1,2,-2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(5.0_DP) )
         I_r(3,-3,2,-2,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(42.0_DP) )
         I_r(3,-1,2,-2,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(70.0_DP) )
         I_r(1,0,2,-1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(10.0_DP) )
         I_r(3,-2,2,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(7.0_DP) )
         I_r(3,0,2,-1,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(210.0_DP) )
         I_r(1,-1,2,0,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(30.0_DP) )
         I_r(1,1,2,0,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(30.0_DP) )
         I_r(3,-1,2,0,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(105.0_DP) )
         I_r(3,1,2,0,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(105.0_DP) )
         I_r(1,0,2,1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(10.0_DP) )
         I_r(3,0,2,1,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(210.0_DP) )
         I_r(3,2,2,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(7.0_DP) )
         I_r(1,1,2,2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(5.0_DP) )
         I_r(3,1,2,2,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(70.0_DP) )
         I_r(3,3,2,2,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(42.0_DP) )
         I_r(2,-2,3,-3,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(42.0_DP) )
         I_r(2,-1,3,-2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(7.0_DP) )
         I_r(2,-2,3,-1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(70.0_DP) )
         I_r(2,0,3,-1,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(105.0_DP) )
         I_r(2,-1,3,0,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(210.0_DP) )
         I_r(2,1,3,0,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(210.0_DP) )
         I_r(2,0,3,1,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(105.0_DP) )
         I_r(2,2,3,1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(70.0_DP) )
         I_r(2,1,3,2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(7.0_DP) )
         I_r(2,2,3,3,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(42.0_DP) )

         I_r(1,0,0,0,3) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(2,-1,1,-1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(0,0,1,0,3) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(2,0,1,0,3) = cmplx( 2.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(2,1,1,1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(3,-2,2,-2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(1,-1,2,-1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(3,-1,2,-1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(1,0,2,0,3) = cmplx( 2.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(3,0,2,0,3) = cmplx( 3.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_r(1,1,2,1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(3,1,2,1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,2,2,2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,-2,3,-2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,-1,3,-1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,0,3,0,3) = cmplx( 3.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_r(2,1,3,1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,2,3,2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )

         I_theta(0,0,1,-1,1) = cmplx( -1.0_DP/sqrt(24.0_DP), 0.0_DP )
         I_theta(2,-2,1,-1,1) = cmplx( -1.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_theta(2,0,1,-1,1) = cmplx( -1.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_theta(2,-1,1,0,1) = cmplx( -1.0_DP/sqrt(10.0_DP), 0.0_DP )
         I_theta(2,1,1,0,1) = cmplx( 1.0_DP/sqrt(10.0_DP), 0.0_DP )
         I_theta(0,0,1,1,1) = cmplx( 1.0_DP/sqrt(24.0_DP), 0.0_DP )
         I_theta(2,0,1,1,1) = cmplx( 1.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_theta(2,2,1,1,1) = cmplx( 1.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_theta(1,-1,2,-2,1) = cmplx( 1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(3,-3,2,-2,1) = cmplx( 1.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_theta(3,-1,2,-2,1) = cmplx( 2.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(1,0,2,-1,1) = cmplx( -1.0_DP/sqrt(40.0_DP), 0.0_DP )
         I_theta(3,-2,2,-1,1) = cmplx( 1.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_theta(3,0,2,-1,1) = cmplx( -6.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_theta(1,-1,2,0,1) = cmplx( -3.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_theta(1,1,2,0,1) = cmplx( 3.0_DP/sqrt(30.0_DP), 0.0_DP )
         I_theta(3,-1,2,0,1) = cmplx( -6.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_theta(3,1,2,0,1) = cmplx( 6.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_theta(1,0,2,1,1) = cmplx( 1.0_DP/sqrt(40.0_DP), 0.0_DP )
         I_theta(3,0,2,1,1) = cmplx( 6.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_theta(3,2,2,1,1) = cmplx( -1.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_theta(1,1,2,2,1) = cmplx( -1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(3,1,2,2,1) = cmplx( -2.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,3,2,2,1) = cmplx( -1.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_theta(2,-2,3,-3,1) = cmplx( -3.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(2,-1,3,-2,1) = cmplx( 1.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_theta(0,0,3,-1,1) = cmplx( 7.0_DP/sqrt(336.0_DP), 0.0_DP )
         I_theta(2,-2,3,-1,1) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,0,3,-1,1) = cmplx( -13.0_DP/sqrt(1680.0_DP), 0.0_DP )
         I_theta(2,-1,3,0,1) = cmplx( -12.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_theta(2,1,3,0,1) = cmplx( 12.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_theta(0,0,3,1,1) = cmplx( -7.0_DP/sqrt(336.0_DP), 0.0_DP )
         I_theta(2,0,3,1,1) = cmplx( 13.0_DP/sqrt(1680.0_DP), 0.0_DP )
         I_theta(2,2,3,1,1) = cmplx( -4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,1,3,2,1) = cmplx( -1.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_theta(2,2,3,3,1) = cmplx( 3.0_DP/sqrt(168.0_DP), 0.0_DP )

         I_theta(0,0,1,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(24.0_DP) )
         I_theta(2,-2,1,-1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(80.0_DP) )
         I_theta(2,0,1,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(30.0_DP) )
         I_theta(2,-1,1,0,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(10.0_DP) )
         I_theta(2,1,1,0,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(10.0_DP) )
         I_theta(0,0,1,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(24.0_DP) )
         I_theta(2,0,1,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(30.0_DP) )
         I_theta(2,2,1,1,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(80.0_DP) )
         I_theta(1,-1,2,-2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(20.0_DP) )
         I_theta(3,-3,2,-2,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(42.0_DP) )
         I_theta(3,-1,2,-2,2) = cmplx( 0.0_DP, -2.0_DP/sqrt(70.0_DP) )
         I_theta(1,0,2,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(40.0_DP) )
         I_theta(3,-2,2,-1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(112.0_DP) )
         I_theta(3,0,2,-1,2) = cmplx( 0.0_DP, 6.0_DP/sqrt(210.0_DP) )
         I_theta(1,-1,2,0,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(30.0_DP) )
         I_theta(1,1,2,0,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(30.0_DP) )
         I_theta(3,-1,2,0,2) = cmplx( 0.0_DP, -6.0_DP/sqrt(105.0_DP) )
         I_theta(3,1,2,0,2) = cmplx( 0.0_DP, -6.0_DP/sqrt(105.0_DP) )
         I_theta(1,0,2,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(40.0_DP) )
         I_theta(3,0,2,1,2) = cmplx( 0.0_DP, 6.0_DP/sqrt(210.0_DP) )
         I_theta(3,2,2,1,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(112.0_DP) )
         I_theta(1,1,2,2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(20.0_DP) )
         I_theta(3,1,2,2,2) = cmplx( 0.0_DP, -2.0_DP/sqrt(70.0_DP) )
         I_theta(3,3,2,2,2) = cmplx( 0.0_DP, 1.0_DP/sqrt(42.0_DP) )
         I_theta(2,-2,3,-3,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(168.0_DP) )
         I_theta(2,-1,3,-2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(28.0_DP) )
         I_theta(0,0,3,-1,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(336.0_DP) )
         I_theta(2,-2,3,-1,2) = cmplx( 0.0_DP, 4.0_DP/sqrt(70.0_DP) )
         I_theta(2,0,3,-1,2) = cmplx( 0.0_DP, 13.0_DP/sqrt(1680.0_DP) )
         I_theta(2,-1,3,0,2) = cmplx( 0.0_DP, -12.0_DP/sqrt(210.0_DP) )
         I_theta(2,1,3,0,2) = cmplx( 0.0_DP, -12.0_DP/sqrt(210.0_DP) )
         I_theta(0,0,3,1,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(336.0_DP) )
         I_theta(2,0,3,1,2) = cmplx( 0.0_DP, 13.0_DP/sqrt(1680.0_DP) )
         I_theta(2,2,3,1,2) = cmplx( 0.0_DP, 4.0_DP/sqrt(70.0_DP) )
         I_theta(2,1,3,2,2) = cmplx( 0.0_DP, -1.0_DP/sqrt(28.0_DP) )
         I_theta(2,2,3,3,2) = cmplx( 0.0_DP, 3.0_DP/sqrt(168.0_DP) )

         I_theta(2,-1,1,-1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(0,0,1,0,3) = cmplx( 2.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_theta(2,0,1,0,3) = cmplx( -2.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(2,1,1,1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(3,-2,2,-2,3) = cmplx( -2.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_theta(1,-1,2,-1,3) = cmplx( -3.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(3,-1,2,-1,3) = cmplx( 8.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(1,0,2,0,3) = cmplx( 6.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(3,0,2,0,3) = cmplx( -6.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_theta(1,1,2,1,3) = cmplx( -3.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(3,1,2,1,3) = cmplx( 8.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,2,2,2,3) = cmplx( -2.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_theta(2,-2,3,-2,3) = cmplx( 4.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_theta(2,-1,3,-1,3) = cmplx( -16.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,0,3,0,3) = cmplx( 12.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_theta(2,1,3,1,3) = cmplx( -16.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,2,3,2,3) = cmplx( 4.0_DP/sqrt(7.0_DP), 0.0_DP )

         I_phi(0,0,1,-1,1) = cmplx( 3.0_DP/sqrt(24.0_DP), 0.0_DP )
         I_phi(2,-2,1,-1,1) = cmplx( -5.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_phi(0,0,1,1,1) = cmplx( -3.0_DP/sqrt(24.0_DP), 0.0_DP )
         I_phi(2,2,1,1,1) = cmplx( 5.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_phi(1,-1,2,-2,1) = cmplx( 5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(3,-3,2,-2,1) = cmplx( -7.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_phi(1,0,2,-1,1) = cmplx( 5.0_DP/sqrt(40.0_DP), 0.0_DP )
         I_phi(3,-2,2,-1,1) = cmplx( -7.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_phi(1,0,2,1,1) = cmplx( -5.0_DP/sqrt(40.0_DP), 0.0_DP )
         I_phi(3,2,2,1,1) = cmplx( 7.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_phi(1,1,2,2,1) = cmplx( -5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(3,3,2,2,1) = cmplx( 7.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_phi(2,-2,3,-3,1) = cmplx( 21.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(2,-1,3,-2,1) = cmplx( 7.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_phi(0,0,3,-1,1) = cmplx( 7.0_DP/sqrt(336.0_DP), 0.0_DP )
         I_phi(2,0,3,-1,1) = cmplx( 35.0_DP/sqrt(1680.0_DP), 0.0_DP )
         I_phi(0,0,3,1,1) = cmplx( -7.0_DP/sqrt(336.0_DP), 0.0_DP )
         I_phi(2,0,3,1,1) = cmplx( -35.0_DP/sqrt(1680.0_DP), 0.0_DP )
         I_phi(2,1,3,2,1) = cmplx( -7.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_phi(2,2,3,3,1) = cmplx( -21.0_DP/sqrt(168.0_DP), 0.0_DP )

         I_phi(0,0,1,-1,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(24.0_DP) )
         I_phi(2,-2,1,-1,2) = cmplx( 0.0_DP, -5.0_DP/sqrt(80.0_DP) )
         I_phi(0,0,1,1,2) = cmplx( 0.0_DP, -3.0_DP/sqrt(24.0_DP) )
         I_phi(2,2,1,1,2) = cmplx( 0.0_DP, -5.0_DP/sqrt(80.0_DP) )
         I_phi(1,-1,2,-2,2) = cmplx( 0.0_DP, -5.0_DP/sqrt(20.0_DP) )
         I_phi(3,-3,2,-2,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(42.0_DP) )
         I_phi(1,0,2,-1,2) = cmplx( 0.0_DP, -5.0_DP/sqrt(40.0_DP) )
         I_phi(3,-2,2,-1,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(112.0_DP) )
         I_phi(1,0,2,1,2) = cmplx( 0.0_DP, -5.0_DP/sqrt(40.0_DP) )
         I_phi(3,2,2,1,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(112.0_DP) )
         I_phi(1,1,2,2,2) = cmplx( 0.0_DP, -5.0_DP/sqrt(20.0_DP) )
         I_phi(3,3,2,2,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(42.0_DP) )
         I_phi(2,-2,3,-3,2) = cmplx( 0.0_DP, -21.0_DP/sqrt(168.0_DP) )
         I_phi(2,-1,3,-2,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(28.0_DP) )
         I_phi(0,0,3,-1,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(336.0_DP) )
         I_phi(2,0,3,-1,2) = cmplx( 0.0_DP, -35.0_DP/sqrt(1680.0_DP) )
         I_phi(0,0,3,1,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(336.0_DP) )
         I_phi(2,0,3,1,2) = cmplx( 0.0_DP, -35.0_DP/sqrt(1680.0_DP) )
         I_phi(2,1,3,2,2) = cmplx( 0.0_DP, -7.0_DP/sqrt(28.0_DP) )
         I_phi(2,2,3,3,2) = cmplx( 0.0_DP, -21.0_DP/sqrt(168.0_DP) )

    end subroutine Imatrices_csh


    subroutine Imatrices_rsh
    ! I matrices using Real Spherical Harmonics

         I_r     = (0.0_DP,0.0_DP)
         I_theta = (0.0_DP,0.0_DP)
         I_phi   = (0.0_DP,0.0_DP)

         I_r(0,0,1,1,1) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(1,-1,2,-2,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(1,0,2,1,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(1,1,0,0,1) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(1,1,2,0,1) = cmplx( -1.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(1,1,2,2,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-2,1,-1,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-2,3,-3,1) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(2,-2,3,-1,1) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,-1,3,-2,1) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,0,1,1,1) = cmplx( -1.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(2,0,3,1,1) = cmplx( 6.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(2,1,1,0,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,1,3,0,1) = cmplx( -3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(2,1,3,2,1) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,2,1,1,1) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,2,3,1,1) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,2,3,3,1) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(3,-3,2,-2,1) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(3,-2,2,-1,1) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,-1,2,-2,1) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,0,2,1,1) = cmplx( -3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(3,1,2,0,1) = cmplx( 6.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(3,1,2,2,1) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,2,2,1,1) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,3,2,2,1) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )

         I_r(0,0,1,-1,2) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(1,-1,0,0,2) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(1,-1,2,0,2) = cmplx( -1.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(1,-1,2,2,2) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(1,0,2,-1,2) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(1,1,2,-2,2) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-2,1,1,2) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-2,3,1,2) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,-2,3,3,2) = cmplx( -3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(2,-1,1,0,2) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-1,3,0,2) = cmplx( -3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(2,-1,3,2,2) = cmplx( -1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,0,1,-1,2) = cmplx( -1.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(2,0,3,-1,2) = cmplx( 6.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(2,1,3,-2,2) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,2,1,-1,2) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,2,3,-3,2) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(2,2,3,-1,2) = cmplx( 1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,-3,2,2,2) = cmplx( 3.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_r(3,-2,2,1,2) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,-1,2,0,2) = cmplx( 6.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_r(3,-1,2,2,2) = cmplx( 1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,0,2,-1,2) = cmplx( -3.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_r(3,1,2,-2,2) = cmplx( -1.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,2,2,-1,2) = cmplx( -1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,3,2,-2,2) = cmplx( -3.0_DP/sqrt(42.0_DP), 0.0_DP )

         I_r(0,0,1,0,3) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(1,-1,2,-1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(1,0,0,0,3) = cmplx( 1.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_r(1,0,2,0,3) = cmplx( 2.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(1,1,2,1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-2,3,-2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(2,-1,1,-1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,-1,3,-1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,0,1,0,3) = cmplx( 2.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_r(2,0,3,0,3) = cmplx( 3.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_r(2,1,1,1,3) = cmplx( 1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_r(2,1,3,1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(2,2,3,2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,-2,2,-2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_r(3,-1,2,-1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,0,2,0,3) = cmplx( 3.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_r(3,1,2,1,3) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_r(3,2,2,2,3) = cmplx( 1.0_DP/sqrt(7.0_DP), 0.0_DP )

         I_theta(0,0,1,1,1) = cmplx( 1.0_DP/sqrt(12.0_DP), 0.0_DP )
         I_theta(0,0,3,1,1) = cmplx( -7.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(1,-1,2,-2,1) = cmplx( 1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(1,0,2,1,1) = cmplx( 1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(1,1,2,0,1) = cmplx( -3.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(1,1,2,2,1) = cmplx( 1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(2,-2,1,-1,1) = cmplx( 1.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_theta(2,-2,3,-3,1) = cmplx( 3.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(2,-2,3,-1,1) = cmplx( -4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,-1,3,-2,1) = cmplx( 1.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_theta(2,0,1,1,1) = cmplx( 1.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(2,0,3,1,1) = cmplx( 13.0_DP/sqrt(840.0_DP), 0.0_DP )
         I_theta(2,1,1,0,1) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(2,1,3,0,1) = cmplx( -12.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_theta(2,1,3,2,1) = cmplx( 1.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_theta(2,2,1,1,1) = cmplx( 1.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_theta(2,2,3,1,1) = cmplx( -4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,2,3,3,1) = cmplx( 3.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(3,-3,2,-2,1) = cmplx( 1.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_theta(3,-2,2,-1,1) = cmplx( -1.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_theta(3,-1,2,-2,1) = cmplx( 2.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,0,2,1,1) = cmplx( 6.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_theta(3,1,2,0,1) = cmplx( -12.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_theta(3,1,2,2,1) = cmplx( 2.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,2,2,1,1) = cmplx( -1.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_theta(3,3,2,2,1) = cmplx( 1.0_DP/sqrt(42.0_DP), 0.0_DP )

         I_theta(0,0,1,-1,2) = cmplx( 1.0_DP/sqrt(12.0_DP), 0.0_DP )
         I_theta(0,0,3,-1,2) = cmplx( -7.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(1,-1,2,0,2) = cmplx( -3.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(1,-1,2,2,2) = cmplx( -1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(1,0,2,-1,2) = cmplx( 1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(1,1,2,-2,2) = cmplx( 1.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_theta(2,-2,1,1,2) = cmplx( 1.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_theta(2,-2,3,1,2) = cmplx( -4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,-2,3,3,2) = cmplx( -3.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(2,-1,1,0,2) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(2,-1,3,0,2) = cmplx( -12.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_theta(2,-1,3,2,2) = cmplx( -1.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_theta(2,0,1,-1,2) = cmplx( 1.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(2,0,3,-1,2) = cmplx( 13.0_DP/sqrt(840.0_DP), 0.0_DP )
         I_theta(2,1,3,-2,2) = cmplx( 1.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_theta(2,2,1,-1,2) = cmplx( -1.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_theta(2,2,3,-3,2) = cmplx( 3.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_theta(2,2,3,-1,2) = cmplx( 4.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,-3,2,2,2) = cmplx( 1.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_theta(3,-2,2,1,2) = cmplx( -1.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_theta(3,-1,2,0,2) = cmplx( -12.0_DP/sqrt(210.0_DP), 0.0_DP )
         I_theta(3,-1,2,2,2) = cmplx( -2.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,0,2,-1,2) = cmplx( 6.0_DP/sqrt(105.0_DP), 0.0_DP )
         I_theta(3,1,2,-2,2) = cmplx( 2.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,2,2,-1,2) = cmplx( 1.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_theta(3,3,2,-2,2) = cmplx( -1.0_DP/sqrt(42.0_DP), 0.0_DP )

         I_theta(0,0,1,0,3) = cmplx( 2.0_DP/sqrt(3.0_DP), 0.0_DP )
         I_theta(1,-1,2,-1,3) = cmplx( 3.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(1,0,2,0,3) = cmplx( 6.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(1,1,2,1,3) = cmplx( 3.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(2,-2,3,-2,3) = cmplx( 4.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_theta(2,-1,1,-1,3) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(2,-1,3,-1,3) = cmplx( 16.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,0,1,0,3) = cmplx( -2.0_DP/sqrt(15.0_DP), 0.0_DP )
         I_theta(2,0,3,0,3) = cmplx( 12.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_theta(2,1,1,1,3) = cmplx( -1.0_DP/sqrt(5.0_DP), 0.0_DP )
         I_theta(2,1,3,1,3) = cmplx( 16.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(2,2,3,2,3) = cmplx( 4.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_theta(3,-2,2,-2,3) = cmplx( -2.0_DP/sqrt(7.0_DP), 0.0_DP )
         I_theta(3,-1,2,-1,3) = cmplx( -8.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,0,2,0,3) = cmplx( -6.0_DP/sqrt(35.0_DP), 0.0_DP )
         I_theta(3,1,2,1,3) = cmplx( -8.0_DP/sqrt(70.0_DP), 0.0_DP )
         I_theta(3,2,2,2,3) = cmplx( -2.0_DP/sqrt(7.0_DP), 0.0_DP )

         I_phi(0,0,1,1,1) = cmplx( 3.0_DP/sqrt(12.0_DP), 0.0_DP )
         I_phi(0,0,3,1,1) = cmplx( 7.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(1,-1,2,-2,1) = cmplx( 5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(1,0,2,1,1) = cmplx( 5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(1,1,2,2,1) = cmplx( 5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(2,-2,1,-1,1) = cmplx( -5.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_phi(2,-2,3,-3,1) = cmplx( 21.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(2,-1,3,-2,1) = cmplx( 7.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_phi(2,0,3,1,1) = cmplx( 35.0_DP/sqrt(840.0_DP), 0.0_DP )
         I_phi(2,1,3,2,1) = cmplx( 7.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_phi(2,2,1,1,1) = cmplx( -5.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_phi(2,2,3,3,1) = cmplx( 21.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(3,-3,2,-2,1) = cmplx( -7.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_phi(3,-2,2,-1,1) = cmplx( -7.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_phi(3,2,2,1,1) = cmplx( -7.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_phi(3,3,2,2,1) = cmplx( -7.0_DP/sqrt(42.0_DP), 0.0_DP )

         I_phi(0,0,1,-1,2) = cmplx( 3.0_DP/sqrt(12.0_DP), 0.0_DP )
         I_phi(0,0,3,-1,2) = cmplx( 7.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(1,-1,2,2,2) = cmplx( -5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(1,0,2,-1,2) = cmplx( 5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(1,1,2,-2,2) = cmplx( 5.0_DP/sqrt(20.0_DP), 0.0_DP )
         I_phi(2,-2,1,1,2) = cmplx( -5.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_phi(2,-2,3,3,2) = cmplx( -21.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(2,-1,3,2,2) = cmplx( -7.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_phi(2,0,3,-1,2) = cmplx( 35.0_DP/sqrt(840.0_DP), 0.0_DP )
         I_phi(2,1,3,-2,2) = cmplx( 7.0_DP/sqrt(28.0_DP), 0.0_DP )
         I_phi(2,2,1,-1,2) = cmplx( 5.0_DP/sqrt(80.0_DP), 0.0_DP )
         I_phi(2,2,3,-3,2) = cmplx( 21.0_DP/sqrt(168.0_DP), 0.0_DP )
         I_phi(3,-3,2,2,2) = cmplx( -7.0_DP/sqrt(42.0_DP), 0.0_DP )
         I_phi(3,-2,2,1,2) = cmplx( -7.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_phi(3,2,2,-1,2) = cmplx( 7.0_DP/sqrt(112.0_DP), 0.0_DP )
         I_phi(3,3,2,-2,2) = cmplx( 7.0_DP/sqrt(42.0_DP), 0.0_DP )

    end subroutine Imatrices_rsh


    subroutine awfc_grad_awfc( )
    ! Gradient matrix elements over atomic orbitals     (awfc_grad_awfc)
    ! Gradient matrix elements over atomic pseudorbital (pswfc_grad_pswfc)

    ! Not in used replaced by diff_* to minimize the problem with spurious
    ! oscillations in the atomic waves and projectors 
    
     implicit none

        integer :: it, ip1, ip2
        integer :: il1, il2, im1, im2, ipall1, ipall2
        
        complex(DP), allocatable ::atwfc_grad_atwfc(:,:,:), pswfc_grad_pswfc(:,:,:)

        if (use_real_spherical_harm) then 
           call Imatrices_rsh
        else
           call Imatrices_csh
        endif 

        call Rmatrices
        call set_indexes

        allocate( atwfc_grad_atwfc( 1:3, 1:n_pro_type_tot, 1:n_pro_type_tot ), STAT=ierr )
        if (ierr/=0) call errore('kgec:awfc_grad_awfc','allocating atwfc_grad_atwfc',ABS(ierr))

        allocate( pswfc_grad_pswfc( 1:3, 1:n_pro_type_tot, 1:n_pro_type_tot ), STAT=ierr )
        if (ierr/=0) call errore('kgec:awfc_grad_awfc','allocating pswfc_gradpstwfc',ABS(ierr))

       ! Matrix elements of the gradient operator over the atomic orbitals (atwfc_grad_atwfc)
       ! stored on collective counters on projectors (beta or kb in QE) ordered by type of atoms as
       ! in becp (=<beta|\psi>), which inherites that from vkb (see init_us_2.f90)


        do it = 1, ntyp

            do ip1 = 1, upf(it)%nbeta
               il1 = upf(it)%lll(ip1)

               do im1 = -il1, il1
                  ipall1 = plm_index( it, ip1, im1)

                  do ip2 = 1, upf(it)%nbeta
                     il2 = upf(it)%lll(ip2)

                     do im2 = -il2, il2
                        ipall2 = plm_index( it, ip2, im2)

                        atwfc_grad_atwfc( 1:3, ipall2, ipall1 ) = &
                          Rd(it,ip2,ip1) * I_r(il2,im2,il1,im1,1:3) &
                           + R(it,ip2,ip1) * (   I_theta(il2,im2,il1,im1,1:3) &
                                               + I_phi  (il2,im2,il1,im1,1:3)   )

                     enddo
                  enddo

               enddo
            enddo

        enddo


        ! Matrix elements of the gradient operator over the atomic pseudo orbitals (pswfc_grad_pswfc)
        ! storaged on collective counters on projectors (beta or kb in QE) ordered by type of atoms as
        ! in becp (=<beta|\psi>), which inherites that from vkb (see init_us_2.f90)

        do it  = 1, ntyp

           do ip1 = 1, upf(it)%nbeta
              il1 = upf(it)%lll(ip1)

              do im1 = -il1, il1
                 ipall1 = plm_index( it, ip1, im1 )

                 do ip2 = 1, upf(it)%nbeta
                    il2 = upf(it)%lll(ip2)

                    do im2 = -il2, il2
                       ipall2 = plm_index( it, ip2, im2 )

                       pswfc_grad_pswfc( 1:3, ipall2, ipall1 ) = &
                          pRd(it,ip2,ip1) * I_r(il2,im2,il1,im1,1:3) &
                            + pR(it,ip2,ip1) * (   I_theta(il2,im2,il1,im1,1:3) &
                                                 + I_phi  (il2,im2,il1,im1,1:3)   )

                    enddo
                 enddo

              enddo
           enddo

        enddo


#ifdef __KGDEBUG

        open(11,file="Dx.dat",action='write')
        write(11,*) "#  <\phi|\nabla_x|\phi> - <\~\phi|nabla_x|\~\phi> "
        open(12,file="Dy.dat",action='write')
        write(12,*) " # <\phi|\nabla_y|\phi> - <\~\phi|nabla_y|\~\phi> "
        open(13,file="Dz.dat",action='write')
        write(13,*) " # <\phi|\nabla_z|\phi> - <\~\phi|nabla_z|\~\phi> "



        do it  = 1, ntyp

           do ip2 = 1, upf(it)%nbeta
              il2 = upf(it)%lll(ip2)

              do im2 = -il2, il2
                 ipall2 = plm_index( it, ip2, im2 )


                 do ip1 = 1, upf(it)%nbeta
                    il1 = upf(it)%lll(ip1)

                    do im1 = -il1, il1
                       ipall1 = plm_index( it, ip1, im1 )

                       write(11,'(2i4,2x,(2g14.6))') ipall1, ipall2, atwfc_grad_atwfc( 1, ipall1, ipall2 ) - pswfc_grad_pswfc( 1, ipall1, ipall2 )
                       write(12,'(2i4,2x,(2g14.6))') ipall1, ipall2, atwfc_grad_atwfc( 2, ipall1, ipall2 ) - pswfc_grad_pswfc( 2, ipall1, ipall2 )
                       write(13,'(2i4,2x,(2g14.6))') ipall1, ipall2, atwfc_grad_atwfc( 3, ipall1, ipall2 ) - pswfc_grad_pswfc( 3, ipall1, ipall2 )

                    enddo
                 enddo
              enddo
           enddo


        enddo
        close(11)
        close(12)
        close(13)


        open(21,file="I-x.dat",action='write')
        write(21,*) "#  I_r I_theta I_phi (x components)"
        open(22,file="I-y.dat",action='write')
        write(22,*) "# I_r I_theta I_phi (y components)"
        open(23,file="I-z.dat",action='write')
        write(23,*) "# I_r I_theta I_phi (z components)"

        ipall1=0 ! dummy for ilm collective index
        do il1=0, 3
           do im1=-il1, il1
              ipall1=ipall1+1
              ipall2=0           ! dummy for ilm collective index
              do il2=0, 3
                 do im2=-il2, il2
                    ipall2=ipall2+1

                       write(21,'(6i3,2x,(3(2g13.6)))') ipall1, ipall2, il1, im1, il2, im2, I_r(il1,im1,il2,im2,1), I_theta(il1,im1,il2,im2,1), I_phi(il1,im1,il2,im2,1)
                       write(22,'(6i3,2x,(3(2g13.6)))') ipall1, ipall2, il1, im1, il2, im2, I_r(il1,im1,il2,im2,2), I_theta(il1,im1,il2,im2,2), I_phi(il1,im1,il2,im2,2)
                       write(23,'(6i3,2x,(3(2g13.6)))') ipall1, ipall2, il1, im1, il2, im2, I_r(il1,im1,il2,im2,3), I_theta(il1,im1,il2,im2,3), I_phi(il1,im1,il2,im2,3)

                 enddo
              enddo
           enddo
        enddo

        close(21)
        close(22)
        close(23)

#endif

    end subroutine awfc_grad_awfc


    subroutine diff_awfc_grad_awfc( )
    !
    ! Difference between gradient matrix elements over atomic orbitals
    !  DG = awfc_grad_awfc - pswfc_grad_pswfc
    !
    implicit none

        integer :: it, ip1, ip2
        integer :: il1, il2, im1, im2, ipall1, ipall2


        if ( use_real_spherical_harm ) then 
           call Imatrices_rsh
        else
           call Imatrices_csh
        endif

        call Rmatrices

        call set_indexes


       ! Matrix  of the elements of the gradient operator over the atomic orbitals
       ! atwfc_grad_atwfc - pswfc_grad_pswfc,
       ! stored on collective counters on projectors (beta or kb in QE) ordered by type of atoms as
       ! in becp (=<beta|\psi>), which inherites that from vkb (see init_us_2.f90)

        allocate( DG(1:3,n_pro_type_tot, n_pro_type_tot) )
        DG(1:3,n_pro_type_tot, n_pro_type_tot) = cmplx( 0.0_DP, 0.0_DP )

        ipall1 = 0
        ipall2 = 0

        do it = 1, ntyp

            do ip1 = 1, upf(it)%nbeta
               il1 = upf(it)%lll(ip1)

               do im1    = -il1, il1
                  ipall1 = plm_index(it,ip1,im1)

                  do ip2 = 1, upf(it)%nbeta
                     il2 = upf(it)%lll(ip2)

                     do im2    = -il2, il2
                        ipall2 = plm_index(it,ip2,im2)

                        DG( 1:3, ipall2, ipall1 ) = &
                               ( Rd(it,ip2,ip1) - pRd(it,ip2,ip1) ) * I_r(il2,im2,il1,im1,1:3) &
                             + ( R(it,ip2,ip1) - pR(it,ip2,ip1) ) &
                               * ( I_theta(il2,im2,il1,im1,1:3) &
                                    + I_phi(il2,im2,il1,im1,1:3) )

                     enddo ! im2
                  enddo ! im1

               enddo ! ip2
            enddo ! ip1

        enddo ! it


#ifdef __KGDEBUG

        open(21,file="I-x.dat",action='write')
        write(21,*) "#  I_r I_theta I_phi (x components)"
        open(22,file="I-y.dat",action='write')
        write(22,*) "# I_r I_theta I_phi (y components)"
        open(23,file="I-z.dat",action='write')
        write(23,*) "# I_r I_theta I_phi (z components)"

        ipall1=0 ! dummy for ilm collective index
        do il1=0, 3
           do im1=-il1, il1
              ipall1=ipall1+1
              ipall2=0           ! dummy for ilm collective index
              do il2=0, 3
                 do im2=-il2, il2
                    ipall2=ipall2+1

                       write(21,'(6i3,2x,(3(2g12.6)))') ipall1, ipall2, il1, im1, il2, im2, I_r(il1,im1,il2,im2,1), I_theta(il1,im1,il2,im2,1), I_phi(il1,im1,il2,im2,1)
                       write(22,'(6i3,2x,(3(2g12.6)))') ipall1, ipall2, il1, im1, il2, im2, I_r(il1,im1,il2,im2,2), I_theta(il1,im1,il2,im2,2), I_phi(il1,im1,il2,im2,2)
                       write(23,'(6i3,2x,(3(2g12.6)))') ipall1, ipall2, il1, im1, il2, im2, I_r(il1,im1,il2,im2,3), I_theta(il1,im1,il2,im2,3), I_phi(il1,im1,il2,im2,3)

                 enddo
              enddo
           enddo
        enddo

        close(21)
        close(22)
        close(23)

        open(11,file="Dx.dat",action='write')
        write(11,*) "#  <\phi|\nabla_x|\phi> - <\~\phi|nabla_x|\~\phi> "
        open(12,file="Dy.dat",action='write')
        write(12,*) " # <\phi|\nabla_y|\phi> - <\~\phi|nabla_y|\~\phi> "
        open(13,file="Dz.dat",action='write')
        write(13,*) " # <\phi|\nabla_z|\phi> - <\~\phi|nabla_z|\~\phi> "


        do it = 1, ntyp

           do ip2 = 1, upf(it)%nbeta
              il2 = upf(it)%lll(ip2)

              do im2 = -il2, il2
                 ipall2 = plm_index( it, ip2, im2 )

                 do ip1 = 1, upf(it)%nbeta
                    il1 = upf(it)%lll(ip1)

                    do im1 = -il1, il1
                       ipall1 = plm_index( it, ip1, im1 )

                       write(11,'(2i4,2x,(2g14.6))') ipall1, ipall2, DG( 1, ipall1, ipall2 )
                       write(12,'(2i4,2x,(2g14.6))') ipall1, ipall2, DG( 2, ipall1, ipall2 )
                       write(13,'(2i4,2x,(2g14.6))') ipall1, ipall2, DG( 3, ipall1, ipall2 )

                    enddo
                 enddo
              enddo
           enddo


        enddo
        close(11)
        close(12)
        close(13)

#endif

    end subroutine diff_awfc_grad_awfc

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine psi_norm_correction_paw_at( )
   !
   ! ( < Raplm| Rap'l'm'> - <pseudo Raplm| pseudo Rap'l'm'> ) <Ylm|Yl'm'>
   !

!use uspp, ONLY : qq  or qq_nt from (6.2 on)

   implicit none

      integer :: it, il1, il2, im1, im2, iaplm1, iaplm2, ip1, ip2
      real(DP) :: integral
      real(DP), allocatable :: integrand(:)
      !real(DP) :: RR, pRpR

!integer :: ih, jh

      call set_indexes

      allocate( psi_norm_correction_at(1:n_pro_type_tot,1:n_pro_type_tot), STAT=ierr )
      if (ierr/=0) call errore('kgec:awfc_grad_awfc_2','allocating psi_norm',ABS(ierr))

      psi_norm_correction_at = 0.0_dp

      do it = 1, ntyp

!jh=0

         allocate( integrand(1:rgrid(it)%mesh), STAT=ierr )
         if (ierr/=0) call errore('kgec:psi_norm_correction_paw_at','allocating integrand',ABS(ierr))


         do ip1 = 1, upf(it)%nbeta
            il1 = upf(it)%lll(ip1)
            do im1 = -il1, il1
               iaplm1 = plm_index( it, ip1, im1 )

!jh=jh+1
!ih=0

               do ip2 = 1, upf(it)%nbeta
                  il2 = upf(it)%lll(ip2)
                  do im2 = -il2, il2
                     iaplm2 = plm_index( it, ip2, im2 )

!ih=ih+1

                     ! < Rapl| Rap'l' >
                     !integrand( 1:rgrid(it)%mesh ) = upf(it)%aewfc(1:rgrid(it)%mesh,ip1) &
                     !                                * upf(it)%aewfc(1:rgrid(it)%mesh,ip2)
                     !call simpson( rgrid(it)%mesh, integrand, rgrid(it)%rab, integral )
                     !RR = integral



                     ! < pseudo Rapl| pseudo Rap'l' >
                     !integrand( 1:rgrid(it)%mesh ) = upf(it)%pswfc(1:rgrid(it)%mesh,ip1) &
                     !                                * upf(it)%pswfc(1:rgrid(it)%mesh,ip2)
                     !call simpson( rgrid(it)%mesh, integrand, rgrid(it)%rab, integral )
                     !pRpR = integral

                     !if ( il1==il2 .and. im1==im2 ) &
                     !psi_norm_correction_at( iaplm1, iaplm2 ) = RR - pRpR

                     integrand =     upf(it)%aewfc(1:rgrid(it)%mesh,ip1) &
                                   * upf(it)%aewfc(1:rgrid(it)%mesh,ip2) &
                                 -   upf(it)%pswfc(1:rgrid(it)%mesh,ip1) &
                                   * upf(it)%pswfc(1:rgrid(it)%mesh,ip2)

                     call simpson( rgrid(it)%mesh, integrand, rgrid(it)%rab, integral )

                     if ( il1==il2 .and. im1==im2 ) then
                       psi_norm_correction_at( iaplm2, iaplm1 ) = integral !qq(ih,jh,it) !integral
                     endif

                  enddo ! im2
               enddo ! ip2

            enddo ! im1
         enddo ! ip1

         deallocate( integrand )

      enddo ! it

#ifdef __KGDEBUG
      open(555,file='psi_norm_correction_at.dat',action='write')
      do ip2 = 1, n_pro_type_tot
      do ip1 = ip2, n_pro_type_tot
         write(555,*) ip1, ip2, real(psi_norm_correction_at(ip1,ip2)), aimag(psi_norm_correction_at(ip1,ip2))
      enddo
      enddo
      close(555)
#endif

   end subroutine psi_norm_correction_paw_at

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     subroutine set_indexes
     implicit none
        integer :: ia, it, ip, il, im, nblock 

        ! Get size of the gradient operator matrices over the collective index
        ! and allocate them. Map all the projector to the collective index

        if ( indexes_set ) return

        ! Mapping of ( it, il, im ) to a collective index: plm_index
        ! Colective index of type of atoms and projectors (type, projector, l, m): p_index_type(it)
        allocate( p_index_type_all( 0:ntyp ) )
        allocate( p_index_type(0:ntyp) )
        allocate( plm_index( 1:ntyp, 1:nbetam, -3:3 ) )
        p_index_type     = 0
        n_pro_type_tot   = 0
        p_index_type_all = 0
        p_index_type_all(0) = 1
        plm_index           = 0

        do it = 1, ntyp
           p_index_type(it) = 0
           do ip = 1, upf(it)%nbeta
              il = upf(it)%lll(ip)
              do im = -il, il
                 p_index_type(it) = p_index_type(it) + 1 
                 n_pro_type_tot   = n_pro_type_tot + 1
                 plm_index(it,ip,im) = n_pro_type_tot
              enddo
              p_index_type_all(it) = n_pro_type_tot
           enddo
        enddo


        ! Collective index (p_index) of atoms and projectors ( atoms, projectors, l, m)
        ! First determine the size of p_index
        n_pro_tot     = 0 ! Total number of projecctors for all atoms (not all types)

        do it = 1, ntyp
           do ia = 1, nat
              if ( ityp(ia) == it ) then
                 do ip = p_index_type_all(it-1), p_index_type_all(it)
                    n_pro_tot = n_pro_tot + 1
                 enddo
              endif
            enddo
        enddo

       allocate( p_index( n_pro_tot) )
       allocate( p_index_row_start( n_pro_tot) )
       allocate( p_index_row_end  ( n_pro_tot) )
       ! Fill up p_index
       n_pro_tot     = 0
       nblock        = 0
       do it = 1, ntyp
       do ia = 1, nat
          if ( ityp(ia) == it ) then
            nblock = n_pro_tot
            do ip = p_index_type_all(it-1), p_index_type_all(it)
               n_pro_tot = n_pro_tot + 1
               p_index( n_pro_tot ) = ip
               p_index_row_start( n_pro_tot ) = nblock + &
               merge(1, p_index_type_all(it-1)+1, it==1 )
               p_index_row_end  ( n_pro_tot ) = nblock + &
               ( p_index_type_all(it) - merge(0,p_index_type_all(it-1), it==1) )
            enddo
          endif
        enddo
        enddo

        indexes_set=.true.

     end subroutine set_indexes

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

     subroutine agm_free_memory
        if ( allocated(Rd) )                   deallocate( Rd )
        if ( allocated(DG) )                   deallocate( DG )
        if (allocated(psi_norm_correction_at)) deallocate( psi_norm_correction_at )
        if (allocated(p_index_type))           deallocate( p_index_type )
        if (allocated(plm_index))              deallocate( plm_index    )
        if (allocated(p_index))                deallocate( p_index      )
     end subroutine agm_free_memory


end module apawgm

! Added for the calculation of epsilon_1
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net.
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgsigma2_w
! \sigma_2(w) / w 

use kinds, ONLY    : DP
use qevars
use kgecvars, ONLY : deltarep, deltawidth, nw, wmin, wmax, wgrid, dw, sa, sg, &
                     psi_grad_psi, de,                                        &
                     nbnds_local, nbnds_per_process, nbnds_per_group,         &
                     my_rank, my_rank_old, my_group, sigma2_notintra

implicit none
 
   private

   ! Internal units : atomic Ha
   ! Note on multipliying by the prefactor 2 / omega for sigma2 in a.u.
   ! - The 2 went into the wg ( the combined fermi-dirac and k-weighting factor)
   
   ! Gradient matrix elements needed as input
   ! complex(DP), allocatable    :: psi_grad_psi(:,:,:,:)

   ! \sigma_2 and its decomposition in degenerate (degeneracies) and 
   ! non-degenerate interband (interband) contributions

   real(DP), allocatable, public :: sigma2_w(:,:,:)        
   real(DP), allocatable, public :: sigma2_w_intra(:,:,:)  
   real(DP), allocatable, public :: sigma2_W_degen(:,:,:)  
   real(DP), allocatable, public :: sigma2_w_inter(:,:,:)  

   ! Average traces
   real(DP), allocatable, public :: sigma2_w_atrace(:)     
   real(DP), allocatable, public :: sigma2_w_atrace_intra(:)     
   real(DP), allocatable, public :: sigma2_w_atrace_degen(:)     
   real(DP), allocatable, public :: sigma2_w_atrace_inter(:)     

   ! DC tensors
   real(DP), allocatable, public :: sigma2_w_dc(:,:)        
   real(DP), allocatable, public :: sigma2_w_dc_intra(:,:)  
   real(DP), allocatable, public :: sigma2_W_dc_degen(:,:)  
   real(DP), allocatable, public :: sigma2_w_dc_inter(:,:)  

   ! DC traces
   real(DP), public :: sigma2_w_dc_atrace        
   real(DP), public :: sigma2_w_dc_atrace_intra  
   real(DP), public :: sigma2_W_dc_atrace_degen  
   real(DP), public :: sigma2_w_dc_atrace_inter  


   public :: sigma2_w_sub, sigma2_w_decomp, sigma2_w_atrace_sub, &
             sigma2_w_atrace_decomp, sigma2_w_dc_sub, sigma2_w_dc_decomp, &
             sigma2_w_dc_atrace_sub, sigma2_w_dc_atrace_decomp


   ! Private variables

   real(DP) :: aux, aux2, ee, eem, eep, maux(3,3), wg2

   integer :: ios , ierr ! Input and memory allocation error status variables

   integer :: iw                          ! Frequency index
   integer :: ik, ib1, ib2, ibb1          ! counters on k-points and bands
   integer :: ig                          ! counter on plane waves
   integer :: ix1, ix2                    ! labels x, y an z

   real(DP) :: focc, dfde


   contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine frequency_grid()
   !
   ! Frequency grid
   !

      dw   = ( wmax - wmin ) / dble(nw)  ! Frecuency step

      allocate( wgrid(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma2','allocating wgrid', abs(ierr))
      
      ! Frequency grid in eV
      do iw = 0, nw
         wgrid(iw) = wmin + iw * dw
      enddo


      write(stdout,*) '    Frequency grid:'
      write(stdout,*) "       Frequency step (eV)    :", dw
      write(stdout,*) "       Frequency steps        :", nw
      write(stdout,'(a, f10.4,a,f10.4 )') &
                 "        Frequency range (eV)   :", wgrid(0),  ' to ',wgrid(nw)

     ! Change units to Ha
     wgrid = wgrid / AUTOEV
     dw    = dw    / AUTOEV

   end subroutine frequency_grid


   !===========================================================================
   !                 Full conductivity tensor \sigma_2
   !===========================================================================
   !

   subroutine sigma2_w_sub

      allocate( sigma2_w(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2:sigma2_w_sub',&
                               'allocating sigma2_w', ABS(ierr) )
 
      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = 2 * aux                      ! factor of 2 from the reduction of this
                                          ! expression
      do iw = 0, nw

         wg2 = wgrid(iw) * wgrid(iw)

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                   if ( sigma2_notintra .and. ib2 == ib1 ) cycle   

                   ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                   eem = ee - wgrid(iw)                       ! in Ha
                   eep = ee + wgrid(iw)                       ! in Ha

                   if( ib1 == ib2 .or.  abs(ee) <=  de ) then
                      focc = 1.0_DP/(dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP )
                      dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss*2.0_DP
                   endif

                   if( abs(ee) > de ) &
                      dfde = ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                      maux(ix2,ix1) = maux(ix2,ix1)                            &
                                + dfde                                         &
                                 *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))   &
                                         *    psi_grad_psi(ix2,ib2,ibb1,ik)  ) &
                                       * ( (ee*ee - wg2 -sa*sa) &
                                              /( ( eem*eem + sa*sa )           &
                                                *( eep*eep + sa*sa ) ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1
      enddo ! ix2

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

      sigma2_w(1:3,1:3,iw) = - maux(1:3,1:3) / omega

      enddo ! iw

   end subroutine sigma2_w_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_w_decomp

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          ! (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = 2 * aux                      ! factor of 2 from the reduction of this
                                          ! expression

      ! Intra-band contribution
      allocate( sigma2_w_intra(1:3,1:3,0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                              'allocating sigma2_w_intra',ABS(ierr))

      do iw = 0, nw

         eem = wgrid(iw)                       ! in Ha

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP/( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP )
                  dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))&
                                            *   psi_grad_psi(ix2,ib1,ibb1,ik) )&
                                       * ( -1.0_dp / ( eem*eem + sa*sa )  )

               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_intra(1:3,1:3,iw) = - maux(1:3,1:3) / omega

      enddo ! iw
      ! End intraband contribution

      ! Degeneracies contribution
      allocate( sigma2_w_degen(1:3,1:3,0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                              'allocating sigma2_w_degen',ABS(ierr))

      do iw = 0, nw

         wg2 = wgrid(iw) * wgrid(iw)

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     focc =  1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                     dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     maux(ix2,ix1) = maux(ix2,ix1)                             &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                            *   psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                       * ( (ee*ee - wg2 -sa*sa) &
                                              /( ( eem*eem + sa*sa )           &
                                                *( eep*eep + sa*sa ) ) )
                   endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_degen(1:3,1:3,iw) = - maux(1:3,1:3) / omega

      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma2_w_inter(1:3,1:3,0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                               'allocating sigma2_w_inter',ABS(ierr))

      do iw = 0, nw

         wg2 = wgrid(iw) * wgrid(iw)

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if( ib1 == ib2 ) cycle 

                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     if ( abs(ee) <= de ) cycle

                     eem = ee - wgrid(iw)                       ! in Ha
                     eep = ee + wgrid(iw)                       ! in Ha

                     dfde = ( wg(ib2,ik) - wg(ib1,ik) )/ee

                     maux(ix2,ix1) = maux(ix2,ix1)                             &
                                    + dfde                                     &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                           *     psi_grad_psi(ix2,ib2,ibb1,ik))&
                                       * ( (ee*ee - wg2 -sa*sa) &
                                              /( ( eem*eem + sa*sa )           &
                                                *( eep*eep + sa*sa ) ) )

               enddo ! ib2
               enddo    ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_inter(1:3,1:3,iw) = - maux(1:3,1:3) / omega

      enddo ! iw


      allocate( sigma2_w(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                               'allocating sigma2_w', ABS(ierr) )

      sigma2_w = sigma2_w_intra + sigma2_w_degen + sigma2_w_inter

      allocate( sigma2_w_atrace_intra(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                              'allocating sigma2_w_atrace_intra', ABS(ierr))

      allocate( sigma2_w_atrace_degen(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                               'allocating sigma2_w_atrace_degen', ABS(ierr))
     
      allocate( sigma2_w_atrace_inter(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                              'allocating sigma2_w_atrace_inter', ABS(ierr))

      sigma2_w_atrace_intra(0:nw) = ( sigma2_w_intra(1,1,0:nw) + &
                    sigma2_w_intra(2,2,0:nw) + sigma2_w_intra(3,3,0:nw) )/3.0_DP


      sigma2_w_atrace_degen(0:nw) = ( sigma2_w_degen(1,1,0:nw) + &
                    sigma2_w_degen(2,2,0:nw) + sigma2_w_degen(3,3,0:nw) )/3.0_DP

      sigma2_w_atrace_inter(0:nw) = ( sigma2_w_inter(1,1,0:nw) + &
                    sigma2_w_inter(2,2,0:nw) + sigma2_w_inter(3,3,0:nw) )/3.0_DP

      allocate( sigma2_w_atrace(0:nw), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_decomp',&
                              'allocating sigma2_w_atrace', ABS(ierr))

      sigma2_w_atrace = sigma2_w_atrace_intra + sigma2_w_atrace_degen &
                                              + sigma2_w_atrace_inter


   end subroutine sigma2_w_decomp


   !============================================================================
   !             Average trace of \sigma_2 = tr(sigma2)/3
   !============================================================================


   subroutine sigma2_w_atrace_sub

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2
      !aux = aux * 2                      ! 2 factor coming from the reduction of this
                                          ! expresion 

      allocate( sigma2_w_atrace(0:nw), STAT=ierr )
      if(ierr/=0) &
        call errore('kgcond:sigma2_w_atrace_sub',&
                    'allocating sigma2_w_atrace', abs(ierr))

      do iw = 0, nw
  
         wg2 = wgrid(iw) * wgrid(iw)

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd
              
                  if ( sigma2_notintra .and. ib2 == ib1 ) cycle  

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( ib1 == ib2 .or.  abs(ee) <=  de ) then
                     focc = 1.0_DP / (dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP)
                     dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif

                  if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                     aux2 = aux2                                               &
                            + dfde                                             &
                                * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )     &
                                 *        psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                  * (   (ee*ee- wg2 -sa*sa)      &
                                       /(  ( eem*eem + sa*sa )                 &
                                          *( eep*eep + sa*sa ) ) )

              enddo ! ib2
              enddo ! ib1

           enddo ! ik

        enddo    ! ix1

        call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
        call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

        sigma2_w_atrace(iw) = - aux2 / (3.0_DP * omega)

      enddo ! iw

   end subroutine sigma2_w_atrace_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_w_atrace_decomp

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = aux * 2                      ! 2 factor coming from the reduction of this
                                          ! expresion 

      ! intra-band contribution
      allocate( sigma2_w_atrace_intra(0:nw), STAT=ierr )
      if(ierr/=0) &
        call errore('kgsigma2:sigma2_w_atrace_decomp',&
                    'allocating sigma2_w_atrace_intra', abs(ierr))

      do iw = 0, nw
         aux2 = 0.0_DP

         eep = wgrid(iw)                       ! in Ha

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group


                 focc =1.0_DP / ( dexp(( et(ib1,ik) - e_f )/degauss)+1.0_DP)
                 dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                 aux2 = aux2                                                   &
                            +   dfde                                           &
                                * conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )     &
                                  *       psi_grad_psi( ix1,ib1,ibb1,ik )      &
                                  * (  - 1.0_dp / ( eep*eep + sa*sa ) )

               enddo ! ib1
            enddo ! ik
         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_atrace_intra(iw) = - aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End intra-band contribution

      ! Degeneracies contribution
      allocate( sigma2_w_atrace_degen(0:nw), STAT=ierr )
      if(ierr/=0) &
        call errore('kgsigma2:sigma2_w_atrace_decomp',&
                    'allocating sigma2_w_atrace_degen', abs(ierr))

      do iw = 0, nw

         wg2 = wgrid(iw) * wgrid(iw)
         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <= de ) then
                     focc =1.0_DP / ( dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP)
                     dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     aux2 = aux2                                               &
                            +   dfde                                           &
                                * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )     &
                                  *       psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                  * (   (ee*ee- wg2 -sa*sa)      &
                                       /(  ( eem*eem + sa*sa )                 &
                                          *( eep*eep + sa*sa ) ) )

                 endif

               enddo ! ib2
               enddo ! ib1
            enddo ! ik
         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_atrace_degen(iw) = - aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma2_w_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) &
         call errore('kgsigma2:sigma2_w_atrace_decomp',&
                     'allocating sigma2_atrace_inter', abs(ierr))

      do iw = 0, nw

         wg2 = wgrid(iw) * wgrid(iw)
         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <=  de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  aux2 = aux2                                                  &
                         + dfde                                                &
                             * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )        &
                                *      psi_grad_psi( ix1,ib2,ibb1,ik )         &
                                  * (   (ee*ee- wg2 -sa*sa)      &
                                       /(  ( eem*eem + sa*sa )                 &
                                          *( eep*eep + sa*sa ) ) )

               enddo ! ib2
               enddo ! ib1
            enddo ! ik
         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_atrace_inter(iw) = - aux2 / (3.0_DP * omega)

      enddo ! iw


      allocate( sigma2_w_atrace(0:nw), STAT=ierr )
      if (ierr/=0) &
         CALL errore('kgsigma2:sigma2_w_atrace_decomp',&
                     'allocating sigma2_w_atrace', ABS(ierr) )

      sigma2_w_atrace = sigma2_w_atrace_intra + sigma2_w_atrace_degen &
                                              + sigma2_w_atrace_inter

   end subroutine sigma2_w_atrace_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
!                                  DC
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_w_dc_sub

      allocate( sigma2_w_dc(1:3,1:3), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2:sigma2_w_dc_sub',&
                               'allocating sigma2_w_dc', ABS(ierr) )
 
      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                 ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                    !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = aux * 2                      ! 2 factor coming from the reduction of this
                                          ! expresion 

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                   if ( sigma2_notintra .and. ib2 == ib1 ) cycle   

                   ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                   if( ib1 == ib2 .or.  abs(ee) <=  de ) then
                      focc = 1.0_DP/(dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP )
                      dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss*2.0_DP
                   endif

                   if( abs(ee) > de ) &
                      dfde = ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                      maux(ix2,ix1) = maux(ix2,ix1)                            &
                                + dfde                                         &
                                 *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))   &
                                         *    psi_grad_psi(ix2,ib2,ibb1,ik)  ) &
                                       * ( (ee*ee-sa*sa) &
                                              /( ( ee*ee + sa*sa )           &
                                                *( ee*ee + sa*sa ) ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1
      enddo ! ix2

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

      sigma2_w_dc(1:3,1:3) = - maux(1:3,1:3) / omega

      sigma2_w_dc_atrace = ( sigma2_w_dc(1,1) + &
                             sigma2_w_dc(2,2) + &
                             sigma2_w_dc(3,3) ) / 3.0_DP

   end subroutine sigma2_w_dc_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_w_dc_atrace_sub

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = aux * 2                      ! 2 factor coming from the reduction of this
                                          ! expresion 

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd
              
                  if ( sigma2_notintra .and. ib2 == ib1 ) cycle  

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if( ib1 == ib2 .or. abs(ee) <=  de ) then
                     focc = 1.0_DP / (dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP)
                     dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif

                  if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                     aux2 = aux2                                               &
                            + dfde                                             &
                                * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )     &
                                 *        psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                  * (   (ee*ee - sa*sa)                        &
                                       /(  ( ee*ee + sa*sa )                   &
                                          *( ee*ee + sa*sa ) ) )

              enddo ! ib2
              enddo ! ib1

           enddo ! ik

        enddo    ! ix1

        call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
        call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

        sigma2_w_dc_atrace = - aux2 / (3.0_DP * omega)

   end subroutine sigma2_w_dc_atrace_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_w_dc_decomp

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = aux * 2                      ! 2 factor coming from the reduction of this
                                          ! expresion 


      ! Intra-band contribution
      allocate( sigma2_w_dc_intra(1:3,1:3), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_dc_decomp',&
                              'allocating sigma2_w_dc_intra',ABS(ierr))

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP/( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP )
                  dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))&
                                            *   psi_grad_psi(ix2,ib1,ibb1,ik) )&
                                       * ( -1.0_dp / ( sa*sa )  )

               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_dc_intra(1:3,1:3) = - maux(1:3,1:3) / omega

      ! End intraband contribution


      ! Degeneracies contribution
      allocate( sigma2_w_dc_degen(1:3,1:3), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_dc_decomp',&
                              'allocating sigma2_w_dc_degen',ABS(ierr))

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if( abs(ee) <=  de ) then
                     focc =  1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                     dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     maux(ix2,ix1) = maux(ix2,ix1)                             &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                            *   psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                       * ( (ee*ee-sa*sa) &
                                              /( ( ee*ee + sa*sa )           &
                                                *( ee*ee + sa*sa ) ) )
                   endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_dc_degen(1:3,1:3) = - maux(1:3,1:3) / omega

      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma2_w_dc_inter(1:3,1:3), STAT=ierr )
      if(ierr/=0) CALL errore('kgsigma2:sigma2_w_dc_decomp',&
                               'allocating sigma2_w_dc_inter',ABS(ierr))

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if( ib1 == ib2 ) cycle 

                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     if ( abs(ee) <= de ) cycle

                     dfde = ( wg(ib2,ik) - wg(ib1,ik) )/ee

                     maux(ix2,ix1) = maux(ix2,ix1)                             &
                                    + dfde                                     &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                           *     psi_grad_psi(ix2,ib2,ibb1,ik))&
                                       * ( (ee*ee - sa*sa) &
                                              /( ( ee*ee + sa*sa )           &
                                                *( ee*ee + sa*sa ) ) )

               enddo ! ib2
               enddo    ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_dc_inter(1:3,1:3) = - maux(1:3,1:3) / omega

      allocate( sigma2_w_dc(1:3,1:3), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma2:sigma2_w_dc_decomp',&
                               'allocating sigma2_w_dc', ABS(ierr) )

      sigma2_w_dc = sigma2_w_dc_intra + sigma2_w_dc_degen + sigma2_w_dc_inter


      sigma2_w_dc_atrace_intra = ( sigma2_w_dc_intra(1,1) + &
                    sigma2_w_dc_intra(2,2) + sigma2_w_dc_intra(3,3) )/3.0_DP


      sigma2_w_dc_atrace_degen = ( sigma2_w_dc_degen(1,1) + &
                    sigma2_w_dc_degen(2,2) + sigma2_w_dc_degen(3,3) )/3.0_DP

      sigma2_w_dc_atrace_inter = ( sigma2_w_dc_inter(1,1) + &
                    sigma2_w_dc_inter(2,2) + sigma2_w_dc_inter(3,3) )/3.0_DP


      sigma2_w_dc_atrace = sigma2_w_dc_atrace_intra + sigma2_w_dc_atrace_degen &
                                              + sigma2_w_dc_atrace_inter


   end subroutine sigma2_w_dc_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma2_w_dc_atrace_decomp

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      !aux  = 0.5_dp                      ! 1/2 from ( (e-w)/( (e-w)^2 + sa^2/4 ) - 
                                          !            (e+w)/( (e+w)^2 + sa^2/4 ) ) /2

      !aux = aux * 2                      ! 2 factor coming from the reduction of this
                                          ! expresion 

      ! intra-band contribution

         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group


                 focc =1.0_DP / ( dexp(( et(ib1,ik) - e_f )/degauss)+1.0_DP)
                 dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                 aux2 = aux2                                                   &
                            +   dfde                                           &
                                * conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )     &
                                  *       psi_grad_psi( ix1,ib1,ibb1,ik )      &
                                  * (  - 1.0_dp / ( sa*sa ) )

               enddo ! ib1
            enddo ! ik
         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_dc_atrace_intra = - aux2 / (3.0_DP * omega)

      ! End intra-band contribution

      ! Degeneracies contribution

         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP  ! in Ha

                  if( abs(ee) <= de ) then
                     focc =1.0_DP / ( dexp(( et(ib2,ik) - e_f )/degauss)+1.0_DP)
                     dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     aux2 = aux2                                               &
                            +   dfde                                           &
                                * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )     &
                                  *       psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                  * (   (ee*ee-sa*sa)      &
                                       /(  ( ee*ee + sa*sa )                 &
                                          *( ee*ee + sa*sa ) ) )

                 endif

               enddo ! ib2
               enddo ! ib1
            enddo ! ik
         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_dc_atrace_degen = - aux2 / (3.0_DP * omega)

      ! End degeneracies contribution

      ! Inter bands contribution

         aux2 = 0.0_DP

         do ix1 = 1, 3
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib1 == ib2 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <=  de ) cycle

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  aux2 = aux2                                                  &
                         + dfde                                                &
                             * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )        &
                                *      psi_grad_psi( ix1,ib2,ibb1,ik )         &
                                  * (   (ee*ee-sa*sa)      &
                                       /(  ( ee*ee + sa*sa )                 &
                                          *( ee*ee + sa*sa ) ) )

               enddo ! ib2
               enddo ! ib1
            enddo ! ik
         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma2_w_dc_atrace_inter = - aux2 / (3.0_DP * omega)


      sigma2_w_dc_atrace = sigma2_w_dc_atrace_intra + sigma2_w_dc_atrace_degen &
                                              + sigma2_w_dc_atrace_inter

   end subroutine sigma2_w_dc_atrace_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


end module kgsigma2_w

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgecout
use qevars
use kgecvars
use kgsigma1
use kgsigma2
use kgepsilon1
use kgepsilon2
use kgrrae

implicit none


private

   integer :: iw                          ! Frequency index

   integer :: ik                          ! counter on k-points
                                          ! always local (parallelization is hidden) 
                                         

   integer :: ib1,  ib2                    ! global counters on bands
   integer :: ibb1                         ! local counter on bands


   integer :: ix1, ix2                     ! labels x, y an z

   character(256) :: filename

public :: kgec_output_sigma, kgec_output_epsilon, kgec_output_rrae

contains

   subroutine kgec_output_sigma

   real(DP) :: sigma_aux(3,3,0:nw),       sigma_aux_atrace(0:nw)
   real(DP) :: sigma_aux_intra(3,3,0:nw), sigma_aux_atrace_intra(0:nw)
   real(DP) :: sigma_aux_degen(3,3,0:nw), sigma_aux_atrace_degen(0:nw)
   real(DP) :: sigma_aux_inter(3,3,0:nw), sigma_aux_atrace_inter(0:nw)

   real(DP) :: sigma_dc_aux(3,3),       sigma_dc_aux_atrace
   real(DP) :: sigma_dc_aux_intra(3,3), sigma_dc_aux_atrace_intra
   real(DP) :: sigma_dc_aux_degen(3,3), sigma_dc_aux_atrace_degen
   real(DP) :: sigma_dc_aux_inter(3,3), sigma_dc_aux_atrace_inter

   ! Frequency grid in eV
   wgrid = wgrid * AUTOEV
   
   ! SIGMA1 OUTPUT

   write(stdout,*) ' '
   write(stdout,*)           '    ----------------------------------------------------------------'
   write(stdout,*)           "                 SIGMA1 RELATED OUTPUT (ohm meter)^-1"
   write(stdout,*)           '    ----------------------------------------------------------------'


   WRITESIGMA1: select case ( calculation )
   case( 'tensor' )

      ! Sigma1

      select case( ac )
      case(.true.)

         sigma_aux          = AU_TO_OHMM_INV * sigma1        ! sigma1 in 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace   = AU_TO_OHMM_INV * sigma1_atrace ! sigma1 in 1/a.u. to 1/(ohm meter)

         if ( sigma1_notintra ) then
            write(filename,"('kgec-sigma1-tensor-', A2 ,'inter-only.dat')" ) deltarep
         else
            write(filename,"('kgec-sigma1-tensor-', A2 ,'.dat')" ) deltarep
         endif

         open( 11,file=filename, action='write')
         write(11,'(A)')    '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A,L4,2x,A,2x,A2)') '#   sigma1_exact=', sigma1_exact, 'deltarep=', deltarep      
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
         write(11,'(A)'             ) '#      hbar*w (eV)                           sigma1(w) ( 1/(ohm-meter) )'
         write(11,'(A)',advance='no') '#                               11                  12                  13'
         write(11,'(A)',advance='no') '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'

         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), (((sigma_aux(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                   sigma_aux_atrace(iw)
         enddo
         close(11)

      end select ! ac

      select case(dc)
      case(.true.)

         sigma_dc_aux        = AU_TO_OHMM_INV * sigma1_dc
         sigma_dc_aux_atrace = AU_TO_OHMM_INV * sigma1_dc_atrace

         if ( sigma1_notintra ) then
            write(stdout,*) "    sigma1 DC tensor: inter-band only contributions"
         else    
            write(stdout,*) "    sigma1 DC tensor: all contributions"
         endif 

         do ix1=1,3
            write(stdout,'(1p,3es20.7e3)')  ( sigma_dc_aux(ix1,ix2), ix2=1,3 )
         enddo
         
         if (sigma1_notintra ) then
            write(stdout,*) "      DC ave. trace (inter-band only)          :", sigma_dc_aux_atrace
         else
            write(stdout,*) "      DC ave. trace (all contributions)        :", sigma_dc_aux_atrace
         endif

      end select
         

      select case ( decomposition ) ! sigma1 tensor decomp
      case(.true.)

         ! Sigma1

         select case( ac )
         case(.true.)
         
         sigma_aux_intra   = AU_TO_OHMM_INV * sigma1_intra     ! sigma1 in 1/a.u. to 1/(ohm meter)
         sigma_aux_degen   = AU_TO_OHMM_INV * sigma1_degen     ! sigma1 in 1/a.u. to 1/(ohm meter)
         sigma_aux_inter   = AU_TO_OHMM_INV * sigma1_inter     ! sigma1 in 1/a.u. to 1/(ohm meter)

         sigma_aux_atrace_intra   = AU_TO_OHMM_INV * sigma1_atrace_intra     ! sigma1 in 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace_degen   = AU_TO_OHMM_INV * sigma1_atrace_degen     ! sigma1 in 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace_inter   = AU_TO_OHMM_INV * sigma1_atrace_inter     ! sigma1 in 1/a.u. to 1/(ohm meter)

         
         write(filename,"('kgec-sigma1-tensor-degen-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
         write(11,'(A)'             ) '#      hbar*w (eV)                           sigma1(w) ( 1/(ohm-meter) )'
         write(11,'(A)',advance='no') '#                               11                  12                  13'
         write(11,'(A)',advance='no') '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), (((sigma_aux_degen(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                   sigma_aux_atrace_degen(iw)
         enddo
         close(11)


         write(filename,"('kgec-sigma1-tensor-inter-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
         write(11,'(A)'             ) '#      hbar*w (eV)                           sigma1(w) ( 1/(ohm-meter) )'
         write(11,'(A)',advance='no') '#                               11                  12                  13'
         write(11,'(A)',advance='no') '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), (((sigma_aux_inter(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                   sigma_aux_atrace_inter(iw)
         enddo
         close(11)

         end select ! ac

         select case( dc )
         case(.true.)

            sigma_dc_aux_intra        = AU_TO_OHMM_INV * sigma1_dc_intra
            sigma_dc_aux_atrace_intra = AU_TO_OHMM_INV * sigma1_dc_atrace_intra
            sigma_dc_aux_degen        = AU_TO_OHMM_INV * sigma1_dc_degen
            sigma_dc_aux_inter        = AU_TO_OHMM_INV * sigma1_dc_inter
            sigma_dc_aux_atrace_degen = AU_TO_OHMM_INV * sigma1_dc_atrace_degen
            sigma_dc_aux_atrace_inter = AU_TO_OHMM_INV * sigma1_dc_atrace_inter


            write(stdout,*) "    sigma1 DC tensor: intra-bands contribution"
            do ix1=1,3
               write(stdout,'(1p,3es20.7e3)')  ( sigma_dc_aux_intra(ix1,ix2), ix2=1,3 )
            enddo
            write(stdout,*) "      DC ave. trace (intraband contribution)   :", sigma_dc_aux_atrace_intra

            write(stdout,*) "    sigma1 DC tensor: degeneracies contribution"
            do ix1=1,3
               write(stdout,'(1p,3es20.7e3)')  ( sigma_dc_aux_degen(ix1,ix2), ix2=1,3 )
            enddo
            write(stdout,*) "      DC ave. trace (degeneracies contribution):", sigma_dc_aux_atrace_degen
 
            write(stdout,*) "    sigma1 DC tensor: inter-bands contribution"
            do ix1=1,3
               write(stdout,'(1p,3es20.7e3)')  ( sigma_dc_aux_inter(ix1,ix2), ix2=1,3 )
            enddo
            write(stdout,*) "      DC ave. trace (inter-bands contribution) :", sigma_dc_aux_atrace_inter

         end select
         
      end select ! sigma1 tensor decomp

   
   case( 'atrace' ) ! sigma1


      select case( ac )
      case(.true.)

         sigma_aux_atrace   = AU_TO_OHMM_INV * sigma1_atrace   ! sigma1 in 1/a.u. to 1/(ohm meter)

         if ( sigma1_notintra ) then
            write(filename,"('kgec-sigma1-atrace-', A2 ,'inter-only.dat')" ) deltarep
         else
            write(filename,"('kgec-sigma1-atrace-', A2 ,'.dat')" ) deltarep
         endif

         open(11,file=filename, action='write')
         write(11,'(A)') '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A,L4,2x,A,2x,A2)') '#   sigma1_exact=', sigma1_exact, 'deltarep=', deltarep      
         write(11,'(A)'              ) '#      hbar*w (eV)                           tr(sigma1(w))/3 ( 1/(ohm-meter) )'
         write(11,'(A)'              ) '#'

         do iw = iaux, nw
            write(11,'(1p,2es20.7e3)') wgrid(iw), sigma_aux_atrace(iw)
         enddo
         close(11)

      end select

      select case(dc)
      case(.true.)

         sigma_dc_aux_atrace = AU_TO_OHMM_INV * sigma1_dc_atrace
         
         if (sigma1_notintra ) then
            write(stdout,*) "      DC ave. trace (inter-band only)          :", sigma_dc_aux_atrace
         else
            write(stdout,*) "      DC ave. trace (all contributions)        :", sigma_dc_aux_atrace
         endif

      end select

      select case ( decomposition ) ! sigma1 decomp
      case( .true. )

         select case( ac )
         case(.true.)
         
         sigma_aux_atrace_intra = AU_TO_OHMM_INV &
                               * sigma1_atrace_intra ! 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace_degen = AU_TO_OHMM_INV &
                               * sigma1_atrace_degen ! 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace_inter = AU_TO_OHMM_INV &
                               * sigma1_atrace_inter ! 1/a.u. to 1/(ohm meter)

         write(filename,"('kgec-sigma1-atrace-decomp-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'

         if ( .not. sigma1_notintra ) then
         
         write(11,'(A)'             ) &
         '#      hbar*w (eV)     tr(sigma1_intra)/3    tr(sigma1_degen)/3    &
                                &tr(sigma1_inter)/3    tr(sigma1)/3 ( 1/(ohm-meter) )'
         write(11,'(A)'             ) '#'
 
         do iw = iaux, nw
            write(11,'(1p,6es20.7e3)') wgrid(iw), sigma_aux_atrace_intra(iw),   &
                  sigma_aux_atrace_degen(iw), sigma_aux_atrace_inter(iw), sigma_aux_atrace(iw)
         enddo
         close(11)

         else
         
         write(11,'(A)'             ) &
         '#      hbar*w (eV)     tr(sigma1_degen)/3    tr(sigma1_inter)/3    &
                                               &tr(sigma1)/3 ( 1/(ohm-meter) )'
         write(11,'(A)'             ) '#'
 
         do iw = iaux, nw
            write(11,'(1p,5es20.7e3)') wgrid(iw), sigma_aux_atrace_degen(iw), sigma_aux_atrace_inter(iw), sigma_aux_atrace(iw)
         enddo
         close(11)
         
         endif

         end select ! ac

         select case( dc )
         case(.true.)

         sigma_dc_aux_atrace_intra = AU_TO_OHMM_INV * sigma1_dc_atrace_intra
         sigma_dc_aux_atrace_degen = AU_TO_OHMM_INV * sigma1_dc_atrace_degen
         sigma_dc_aux_atrace_inter = AU_TO_OHMM_INV * sigma1_dc_atrace_inter

         write(stdout,*) "      DC ave. trace (intra-bands contribution) :", sigma_dc_aux_atrace_intra
         write(stdout,*) "      DC ave. trace (degeneracies contribution):", sigma_dc_aux_atrace_degen
         write(stdout,*) "      DC ave. trace (inter-bands contribution) :", sigma_dc_aux_atrace_inter

         end select ! sigma1 decomp

      end select

      select case(ac)
      case(.true.)
         write(stdout,*) ""
         write(stdout,*) "    Real part of the conductivity tensor and/or average trace (in"
         write(stdout,*) "    1/(ohm-meter)) vs frequencies (in eV) saved to kgec-sigma1*.dat file(s)."
      end select

   end select WRITESIGMA1

   !  END OF SIGMA1 OUTPUT 

   !
   ! SIGMA2 OUTPUT
   !

   if (sigma2_via_eps1mod ) calculate_sigma2=.true. ! Output is independent of how sigma2 was calculated

   WRITESIGMA2: select case ( calculate_sigma2 )
   case( .true. )

   write(stdout,*) ' '
   write(stdout,*)           '    ----------------------------------------------------------------'
   write(stdout,*)           "                 SIGMA2 RELATED OUTPUT (ohm meter)^-1"
   write(stdout,*)           '    ----------------------------------------------------------------'

   select case ( dc )
   case( .true. )
        write(stdout,*) '    All sigma2 DC tensor components are zero.'
   end select

   select case ( calculation )
   case( 'tensor' )

      ! Sigma2

      select case( ac )
      case(.true.)

      sigma_aux        = AU_TO_OHMM_INV * sigma2 ! 1/a.u. to 1/(ohm meter)
      sigma_aux_atrace = AU_TO_OHMM_INV * sigma2_atrace

      if ( sigma2_notintra ) then
         write(filename,"('kgec-sigma2-tensor-inter-only.dat')" )
      else
         write(filename,"('kgec-sigma2-tensor.dat')" )
      endif

      open(11,file=filename, action='write')
      write(11,'(A)') '# Imaginary part of the electric conductivity tensor in the xyz system of reference'
      write(11,'(A)'             ) '#      hbar*w (eV)                           sigma2(w) ( 1/(ohm-meter) )'
      write(11,'(A)',advance='no') '#                               11                  12                  13'
      write(11,'(A)',advance='no') '                  21                  22                  23                  31'
      write(11,'(A)') '                  32                  33               trace/3'

      do iw = iaux, nw
         write(11,'(1p,11es20.7e3)') wgrid(iw), (((sigma_aux(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                sigma_aux_atrace(iw)
      enddo
      close(11)

         write(stdout,*) ""
         write(stdout,*) "    Real part of the conductivity tensor and/or average trace (in"
         write(stdout,*) "    1/(ohm-meter)) vs frequencies (in eV) saved to kgec-sigma2*.dat file(s)."

      end select ! ac

      select case ( decomposition )
      case(.true.)

         ! sigma2

         select case( ac )
         case(.true.)

         sigma_aux_degen = AU_TO_OHMM_INV * sigma2_degen ! 1/a.u. to 1/(ohm meter)
         sigma_aux_inter = AU_TO_OHMM_INV * sigma2_inter ! 1/a.u. to 1/(ohm meter)

         sigma_aux_atrace_degen = AU_TO_OHMM_INV * sigma2_atrace_degen ! 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace_inter = AU_TO_OHMM_INV * sigma2_atrace_inter ! 1/a.u. to 1/(ohm meter)


         write(filename,"('kgec-sigma2-tensor-degen.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A)'             ) &
         '#      hbar*w (eV)                           sigma2(w) ( 1/(ohm-meter) )'
         write(11,'(A)',advance='no') &
         '#                               11                  12                  13'
         write(11,'(A)',advance='no') &
         '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), &
                                        (((sigma_aux_degen(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                        sigma_aux_atrace_degen(iw)
         enddo
         close(11)

         write(filename,"('kgec-sigma2-tensor-inter.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A)'             ) &
         '#      hbar*w (eV)                           sigma2(w) ( 1/(ohm-meter) )'
         write(11,'(A)',advance='no') &
         '#                               11                  12                  13'
         write(11,'(A)',advance='no') &
         '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), &
                                       (((sigma_aux_inter(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                       sigma_aux_atrace_inter(iw)
         enddo
         close(11)

         end select ! ac

      end select
   
   case( 'atrace' )

      select case( ac )
      case(.true.)

      sigma_aux_atrace    = AU_TO_OHMM_INV &
                           * sigma2_atrace    ! 1/a.u. to 1/(ohm meter)

      if ( sigma2_notintra ) then
         write(filename,"('kgec-sigma2-atrace-inter-only.dat')" )
      else
         write(filename,"('kgec-sigma2-atrace.dat')" )
      endif

      open(11,file=filename, action='write')
      write(11,'(A)') &
      '# Imaginary part of the average trace of the electric &
      &conductivity tensor in the xyz system of reference'
      write(11,'(A)'             ) &
      '#      hbar*w (eV)                           tr(sigma2(w))/3 ( 1/(ohm-meter) )'
      write(11,* ) '#'

      do iw = iaux, nw
         write(11,'(1p,2es20.7e3)') wgrid(iw), sigma_aux_atrace(iw)
      enddo
      close(11)

      end select ! ac

      select case ( decomposition )
      case( .true. )

         ! sigma2
         select case( ac )
         case(.true.)
         
         sigma_aux_atrace_degen = AU_TO_OHMM_INV &
                               * sigma2_atrace_degen ! 1/a.u. to 1/(ohm meter)
         sigma_aux_atrace_inter = AU_TO_OHMM_INV &
                               * sigma2_atrace_inter ! 1/a.u. to 1/(ohm meter)

         write(filename,"('kgec-sigma2-atrace-decomp.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Imaginary part of the average of the trace of the electric &
         &conductivity tensor in the xyz system of reference'
         write(11,'(A)'             ) &
         '#      hbar*w (eV)     tr(sigma2_degen)/3    tr(sigma2_inter)/3    &
         &tr(sigma2)/3 ( 1/(ohm-meter) )'
         write(11,* ) '#'
         do iw = iaux, nw
            write(11,'(1p,5es20.7e3)') wgrid(iw), sigma_aux_atrace_degen(iw), &
                                       sigma_aux_atrace_inter(iw), sigma_aux_atrace(iw)
         enddo
         close(11)

         end select ! ac

      end select

   end select

   select case(ac)
   case(.true.)
      write(stdout,*) ""
      write(stdout,*) "    Real part of the conductivity tensor and/or average trace (in"
      write(stdout,*) "    1/(ohm-meter)) vs frequencies (in eV) saved to kgec-sigma2*.dat file(s)."
   end select

   end select WRITESIGMA2

   ! END OF SIGMA2 related output


    ! Restore Frequency grid to  Ha
    wgrid = wgrid / AUTOEV

   
   end subroutine kgec_output_sigma

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_output_epsilon

   ! Frequency grid in eV
   wgrid = wgrid * AUTOEV
   
   !
   ! EPSILON1 OUTPUT
   !

   WRITEEPSILON1: select case ( calculate_epsilon1 )
   case( .true. )

   write(stdout,*) ' '
   write(stdout,*)           '    ----------------------------------------------------------------'
   write(stdout,*)           "                      EPSILON1 RELATED OUTPUT "
   write(stdout,*)           '    ----------------------------------------------------------------'

   select case ( calculation )
   case( 'tensor' )

      select case( ac )
      case(.true.)

      if ( sigma2_notintra ) then
         write(filename,"('kegc-epsilon1-tensor-inter-only.dat')" )
      else
         write(filename,"('kegc-epsilon1-tensor.dat')" )
      endif

      open(11,file=filename, action='write')
      write(11,'(A)') '# Real part of the dielectric conductivity tensor in the xyz system of reference'
      write(11,'(A)'             ) '#      hbar*w (eV)                           epsilon1(w) (dimensionless)'
      write(11,'(A)',advance='no') '#                               11                  12                  13'
      write(11,'(A)',advance='no') '                  21                  22                  23                  31'
      write(11,'(A)') '                  32                  33               trace/3'

      do iw = iaux, nw
         write(11,'(1p,11es20.7e3)') wgrid(iw), (((epsilon1(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                epsilon1_atrace(iw)
      enddo
      close(11)

      end select ! ac

      select case(dc)
      case(.true.)

         if ( sigma2_notintra ) then
            write(stdout,*) "    epsilon1 DC tensor: inter-band only contributions"
         else    
            write(stdout,*) "    epsilon1 DC tensor: all contributions"
         endif 

         do ix1=1,3
            write(stdout,'(1p,3es20.7e3)')  ( epsilon1_dc, ix2=1,3 )
         enddo
         
         if (sigma2_notintra ) then
            write(stdout,*) "      DC ave. trace (inter-band only)          :", epsilon1_dc_atrace
         else
            write(stdout,*) "      DC ave. trace (all contributions)        :", epsilon1_dc_atrace
         endif

      end select

      select case ( decomposition )
      case(.true.)

         select case( ac )
         case( .true. )

         write(filename,"('kgec-epsilon1-tensor-intra.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Dielectric conductivity tensor in the xyz system of reference'
         write(11,'(A)'             ) &
         '#      hbar*w (eV)                           epsilon1(w) (dimensionless)'
         write(11,'(A)',advance='no') &
         '#                               11                  12                  13'
         write(11,'(A)',advance='no') &
         '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), &
                                       (((epsilon1_intra(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                       epsilon1_atrace_intra(iw)
         enddo
         close(11)


         write(filename,"('kegec-epsilon1-tensor-degen.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Dielectric tensor in the xyz system of reference'
         write(11,'(A)'             ) &
         '#      hbar*w (eV)                           epsilon1(w) (dimensionless)'
         write(11,'(A)',advance='no') &
         '#                               11                  12                  13'
         write(11,'(A)',advance='no') &
         '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), &
                                        (((epsilon1_degen(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                        epsilon1_atrace_degen(iw)
         enddo
         close(11)

         write(filename,"('kgec-epsilon1-tensor-inter.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Dielectric conductivity tensor in the xyz system of reference'
         write(11,'(A)'             ) &
         '#      hbar*w (eV)                           epsilon1(w) (dimensionless)'
         write(11,'(A)',advance='no') &
         '#                               11                  12                  13'
         write(11,'(A)',advance='no') &
         '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), &
                                       (((epsilon1_inter(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                       epsilon1_atrace_inter(iw)
         enddo
         close(11)

         end select ! ac
         
      end select ! decomposition

   
   case( 'atrace' )


      select case( ac )
      case(.true.)

      if ( sigma2_notintra ) then
         write(filename,"('kgec-epsilon1-atrace-inter-only.dat')" )
      else
         write(filename,"('kgec-epsilon1-atrace.dat')" )
      endif

      open(11,file=filename, action='write')
      write(11,'(A)') &
      '# Imaginary part of the average trace of the dielectric &
      &tensor in the xyz system of reference'
      write(11,'(A)'             ) &
      '#      hbar*w (eV)                           tr(epsilon1(w))/3 (dimensionless)'
      write(11,* ) '#'

      do iw = iaux, nw
         write(11,'(1p,2es20.7e3)') wgrid(iw), epsilon1_atrace(iw)
      enddo
      close(11)

      end select ! ac

      select case(dc)
      case(.true.)

         
         if (sigma2_notintra ) then
            write(stdout,*) "      DC ave. trace (inter-band only)          :", epsilon1_dc_atrace
         else
            write(stdout,*) "      DC ave. trace (all contributions)        :", epsilon1_dc_atrace
         endif

      end select

      select case ( decomposition )
      case( .true. )

         ! sigma2
         select case( ac )
         case(.true.)
         
         write(filename,"('kgec-epsilon1-atrace-decomp.dat')" )
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Imaginary part of the average of the trace of the dielectric &
         &tensor in the xyz system of reference'

         write(11,'(A)'             ) &
         '#      hbar*w (eV)     tr(epsilon1_intra)/3    tr(epsilon1_degen)/3    &
                                &tr(epsilon1_inter)/3    tr(epsilon1)/3 (dimensionless)'
         write(11,'(A)'             ) '#'
 
         do iw = 0, nw
            write(11,'(1p,6es20.7e3)') wgrid(iw), epsilon1_atrace_intra(iw),   &
                  epsilon1_atrace_degen(iw), epsilon1_atrace_inter(iw), epsilon1_atrace(iw)
         enddo
 
         close(11)


         end select ! ac

         select case( dc )
         case(.true.)

            write(stdout,*) "      DC ave. trace (intra-bands contribution) :", epsilon1_dc_atrace_intra
            write(stdout,*) "      DC ave. trace (degeneracies contribution):", epsilon1_dc_atrace_degen
            write(stdout,*) "      DC ave. trace (inter-bands contribution) :", epsilon1_dc_atrace_inter

         end select

      end select

   end select ! Calculation

   select case( ac )
   case(.true.)

      write(stdout,*) ""
      Write(stdout,*) "    Real part of the dielectric tensor and/or average trace "
      Write(stdout,*) "    vs frequency (in eV) saved to kgec-epsilon1-*.dat file(s)."

   end select ! ac

   end select WRITEEPSILON1

   ! END OF EPSILON1 related output

   !
   ! EPSILON2 OUTPUT
   !

   WRITEEPSILON2: select case( calculate_epsilon2 )
   case( .true. )

   write(stdout,*) ' '
   write(stdout,*)           '    ----------------------------------------------------------------'
   write(stdout,*)           "                      EPSILON2 RELATED OUTPUT "
   write(stdout,*)           '    ----------------------------------------------------------------'

   select case ( dc )
   case( .true. )
        write(stdout,*) '    All epsilon2 DC tensor components are infinity.'
   end select

   select case ( calculation )
   case( 'tensor' )

      ! epsilon2

      select case( ac )
      case(.true.)

      write(filename,"('kgec-epsilon2-tensor-', A2 ,'.dat')" ) deltarep
      open( 11,file=filename, action='write')
      write(11,'(A)')    '# Dielectric conductivity tensor in the xyz system of reference'
      write(11,'(A,L4,2x,A,2x,A2)') '#   sigma1_exact=', sigma1_exact, 'deltarep=', deltarep      
      write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
      write(11,'(A)'             ) '#      hbar*w (eV)                           epsilon2(w) ( dimensionless) )'
      write(11,'(A)',advance='no') '#                               11                  12                  13'
      write(11,'(A)',advance='no') '                  21                  22                  23                  31'
      write(11,'(A)') '                  32                  33               trace/3'

      do iw = iaux, nw
         write(11,'(1p,11es20.7e3)') wgrid(iw), (((epsilon2(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                        epsilon2_atrace(iw)
      enddo
      close(11)

      end select ! ac

      select case ( dc )
      case( .true. )

            write(stdout,*) "    epsilon2 DC tensor is infinity for all components."

      end select

         
      select case ( decomposition )
      case(.true.)

         select case( ac )
         case(.true.)
         
         if( .not. sigma1_notintra ) then 

         write(filename,"('kgec-epsilon2-tensor-intra-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') '# Dielectric tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
         write(11,'(A)'             ) '#      hbar*w (eV)                           epsilon2(w) (dimensionless)'
         write(11,'(A)',advance='no') '#                               11                  12                  13'
         write(11,'(A)',advance='no') '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), (((epsilon2_intra(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                        epsilon2_atrace_intra(iw)
         enddo
         close(11)
         
         endif
         
         write(filename,"('kgec-epsilon2-tensor-degen-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') '# Dielectric tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
         write(11,'(A)'             ) '#      hbar*w (eV)                           epsilon2(w) ( dielectric )'
         write(11,'(A)',advance='no') '#                               11                  12                  13'
         write(11,'(A)',advance='no') '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), (((epsilon2_degen(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                    epsilon2_atrace_degen(iw)
         enddo
         close(11)


         write(filename,"('kgec-epsilon2-tensor-inter-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') '# Electric conductivity tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'
         write(11,'(A)'             ) '#      hbar*w (eV)                           epsilon2(w) ( dimensionless )'
         write(11,'(A)',advance='no') '#                               11                  12                  13'
         write(11,'(A)',advance='no') '                  21                  22                  23                  31'
         write(11,'(A)') '                  32                  33               trace/3'
         do iw = iaux, nw
            write(11,'(1p,11es20.7e3)') wgrid(iw), (((epsilon2_inter(ix1,ix2,iw)), ix2=1,3),ix1=1,3), &
                                                   epsilon2_atrace_inter(iw)
         enddo
         close(11)

         end select ! ac

        if ( dc ) write(stdout,*) "       trace of epsilon2 DC tensor is infinity"

         
      end select ! Decomposition

   
   case( 'atrace' )

!      write(stdout,*) "      DDC ave. trace (all contributions)        :", epsilon2_dc_atrace

      select case( ac )
      case(.true.)

      write(filename,"('kgec-epsilon2-atrace-', A2 ,'.dat')" ) deltarep
      open(11,file=filename, action='write')
      write(11,'(A)') '# Dielectric tensor in the xyz system of reference'
      write(11,'(A,L4,2x,A,2x,A2)') '#   sigma1_exact=', sigma1_exact, 'deltarep=', deltarep      
      write(11,'(A)'              ) '#      hbar*w (eV)                           tr(epsilon2(w))/3 ( dimensionless)'
      write(11,'(A)'              ) '#'

      do iw = iaux, nw
         write(11,'(1p,2es20.7e3)') wgrid(iw), epsilon2_atrace(iw)
      enddo
      close(11)

      end select

      select case ( decomposition )
      case( .true. )

         select case( ac )
         case(.true.)
         
         write(filename,"('kgec-epsilon2-atrace-decomp-', A2 ,'.dat')" ) deltarep
         open(11,file=filename, action='write')
         write(11,'(A)') &
         '# Dielectric tensor in the xyz system of reference'
         write(11,'(A,f10.6,A)'     ) '#      deltawidth=', deltawidth, 'eV'

         if ( .not.  sigma1_notintra ) then
         
         write(11,'(A)'             ) &
         '#      hbar*w (eV)     tr(epsilon2_intra)/3    tr(epsilon2_degen)/3    &
                                &tr(epsilon2_inter)/3    tr(epsilon2)/3 (dimensionless)'
         write(11,'(A)'             ) '#'
 
         do iw = iaux, nw
            write(11,'(1p,6es20.7e3)') wgrid(iw), epsilon2_atrace_intra(iw),   &
                  epsilon2_atrace_degen(iw), epsilon2_atrace_inter(iw), epsilon2_atrace(iw)
         enddo
         close(11)

         else
         
         write(11,'(A)'             ) &
         '#      hbar*w (eV)     tr(epsilon2_degen)/3    tr(epsilon2_inter)/3    &
                                               &tr(epsilon2)/3 (dimensionless)'
         write(11,'(A)'             ) '#'
 
         do iw = iaux, nw
            write(11,'(1p,5es20.7e3)') wgrid(iw), epsilon2_atrace_degen(iw), &
                                  epsilon2_atrace_inter(iw), epsilon2_atrace(iw)
         enddo
         close(11)
         
         endif

         end select ! ac

!         select case( dc )
!         case(.true.)

!         if ( .not. notintra ) &         
!         write(*,*) "      DDC ave. trace (intra-bands contribution) :", epsilon2_dc_atrace_intra

!         write(*,*) "      DDC ave. trace (degeneracies contribution):", epsilon2_dc_atrace_degen
!         write(*,*) "      DDC ave. trace (inter-bands contribution) :", epsilon2_dc_atrace_inter

!         end select

      end select

   select case( ac )
   case(.true.)

   write(stdout,*) ""
   Write(stdout,*) "    Imaginary part of the dielectric tensor and/or average trace "
   Write(stdout,*) "    vs frequencies (in eV) saved to kgec-epsilon2-*.dat file(s)."

   end select ! ac

   end select ! ccalculate_epsilon2

   end select WRITEEPSILON2
   !  END OF EPSILON2 OUTPUT 

   ! Restore Frequency grid to Ha
   wgrid = wgrid / AUTOEV

   
   end subroutine kgec_output_epsilon

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_output_rrae

   ! Frequency grid in eV
   wgrid = wgrid * AUTOEV


   write(stdout,*) ' '
   write(stdout,*) '    ----------------------------------------------------------------'
   write(stdout,*) '       REFRACTION, REFLECTION, ABSORPTION AND EELS RELATED OUTPUT   '
   write(stdout,*) '    ----------------------------------------------------------------'


      select case ( dc )
      case( .true. )
       
         write(stdout,*) "    DC n_real is infinity."
         write(stdout,*) "    DC n_imag is infinity."
         write(stdout,*) "    DC reflection is one."
         write(stdout,*) "    DC absorption is zero."
         write(stdout,*) "    DC eels is zero."

      end select

      select case ( ac )
      case ( .true. )
      write(filename,"('kgec-rrae-', A2 ,'.dat')" ) deltarep
      open(11,file=filename, action='write')
      write(11,'(A)') &
      '# Refraction, Reflection, Absorption coefficients'
      write(11,'(A)'             ) &
      '#      hbar*w (eV)     n_real    n_imag    reflection    absorption (1/m)    eels'
         write(11,'(A)'             ) '#'
 
         do iw = iaux, nw
            write(11,'(1p,6es20.7e3)') wgrid(iw), n_real(iw), n_imag(iw),   &
                                       reflection(iw), &
                                       absorption(iw)*HARTREE_SI/(H_PLANCK_SI/TPI)*C_AU/C_SI, &
                                       eels(iw) 
         enddo
         close(11)

      end select

   write(stdout,*) ""
   Write(stdout,*) "    Refracction index ( real and imaginary parts), reflection coef.   "
   Write(stdout,*) "    absorption coef. and eels vs frequencies (in eV) saved to kgec-rrae.dat."


   ! Restore Frequency grid to Ha
   wgrid = wgrid / AUTOEV

   end subroutine kgec_output_rrae
  

end module kgecout

!
! Copyright (C) 2001-2012 Quantum ESPRESSO group
! This file is distributed under the terms of the
! GNU General Public License. See the file `License'
! in the root directory of the present distribution,
! or http://www.gnu.org/copyleft/gpl.txt .
!
! LC: qe read_file sub modified not to read the wavefunctions

SUBROUTINE read_file_nowfc
  !----------------------------------------------------------------------------
  !
  ! Wrapper routine, for compatibility
  !
  USE io_files,             ONLY : nwordwfc, iunwfc, prefix, tmp_dir, wfc_dir
  USE io_global,            ONLY : stdout, ionode
!  USE buffers,              ONLY : open_buffer, close_buffer
  USE wvfct,                ONLY : nbnd, npwx
  USE noncollin_module,     ONLY : npol

#if defined(__QE512) || defined(__QE54)
  USE klist,                ONLY : nks
#endif

  USE paw_variables,        ONLY : okpaw, ddd_PAW
  USE paw_onecenter,        ONLY : paw_potential
  USE uspp,                 ONLY : becsum
  USE scf,                  ONLY : rho
  USE realus,               ONLY : betapointlist, &
                                   init_realspace_vars,real_space
  USE dfunct,               ONLY : newd
  USE ldaU,                 ONLY : lda_plus_u, U_projection

#if defined(__QE6) || defined(__QE54) || defined(__QE512)
  USE pw_restart,           ONLY : pw_readfile
#endif

#if defined(__QE62) || defined(__QE64)
  USE pw_restart_new,       ONLY : read_collected_to_evc
#endif
  USE control_flags,        ONLY : io_level

#if defined(__QE6) || defined(__QE62) || defined(__QE64)
  USE klist,                ONLY : init_igk
  USE gvect,                ONLY : ngm, g
  USE gvecw,                ONLY : gcutw
#endif
 
 !
  IMPLICIT NONE 
  INTEGER :: ierr
  LOGICAL :: exst

#if defined(__QE6) || defined(__QE62) || defined(__QE64)
  CHARACTER( 256 )  :: dirname
  !
  !
  ierr = 0 
#endif

  !
  ! ... Read the contents of the xml data file
  !
#if defined(__QE62) || defined(__QE64)
  dirname = TRIM( tmp_dir ) // TRIM( prefix ) // '.save/'
#endif
  IF ( ionode ) WRITE( stdout, '(/,5x,A,/,5x,A)') &
     'Reading data from directory:', TRIM( tmp_dir ) // TRIM( prefix ) // '.save'
  !
  CALL read_xml_file ( )
  !
  ! ... Open unit iunwfc, for Kohn-Sham orbitals - we assume that wfcs
  ! ... have been written to tmp_dir, not to a different directory!
  ! ... io_level = 1 so that a real file is opened
  !
!  wfc_dir = tmp_dir
!  nwordwfc = nbnd*npwx*npol
!  io_level = 1
!  CALL open_buffer ( iunwfc, 'wfc', nwordwfc, io_level, exst )
  !
  ! ... Allocate and compute k+G indices and number of plane waves
  ! ... FIXME: should be read from file, not re-computed

#if defined(__QE6) || defined(__QE62) || defined(__QE64)
  !
  CALL init_igk ( npwx, ngm, g, gcutw ) 
  !
#endif

#if defined(__QE6) || defined(__QE54) || defined(__512)
  CALL pw_readfile( 'nowave', ierr )
#endif

  !
  ! ... Assorted initialization: pseudopotentials, PAW
  ! ... Not sure which ones (if any) should be done here
  !
  CALL init_us_1()
  !
  IF (lda_plus_u .AND. (U_projection == 'pseudo')) CALL init_q_aeps()
  !
  IF (okpaw) THEN
     becsum = rho%bec
     CALL PAW_potential(rho%bec, ddd_PAW)
  ENDIF 
  !
  IF ( real_space ) THEN
    CALL betapointlist()
    CALL init_realspace_vars()
    IF( ionode ) WRITE(stdout,'(5x,"Real space initialisation completed")')
  ENDIF
!  CALL newd()
  !
!  CALL close_buffer  ( iunwfc, 'KEEP' )
  !
END SUBROUTINE read_file_nowfc

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgecvars
! kgec input and common variables

use kinds, ONLY : DP

!#if defined(__QE512) || defined(__QE52) || defined( __QE54 )
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
use qevars, ONLY : prefix, stdout, ELECTRON_SI, H_PLANCK_SI, tpi,           &
                   ELECTRONMASS_SI, BOHR_RADIUS_SI, HARTREE_SI, pi, &
                   AUTOEV, conv_thr
#endif

!#if defined(__QE6) || defined(__QE62)
#if defined(__QE512) || defined(__QE52) || defined( __QE54 )
use qevars, ONLY : prefix, outdir, stdout, ELECTRON_SI, H_PLANCK_SI, tpi,   &
                   ELECTRONMASS_SI, BOHR_RADIUS_SI, HARTREE_SI, pi, &
                   AUTOEV, conv_thr 
#endif

implicit none

   ! ================ Input variables

   character(len=6) :: calculation = 'atrace' ! Cal. tensor or average trace
   
   logical :: ac = .true.                ! Frequency dependent sigma1
                                         ! (Alternating current) 
   logical :: dc = .true.                ! Direct current conductivity            

   logical :: &
   sigma1_exact   = .true.   ! Use approximated or exact formula
   logical :: &
   decomposition  = .true.   ! Separate contributions into 
                                                 ! intra-bands, degeneracies and 
                                                 ! inter-bands for sigma1

   logical :: calculate_sigma2   = .false. ! Cal. imaginary part of the conduct.
   logical :: calculate_epsilon1 = .false. ! Cal. real part of the dielectric
   logical :: calculate_epsilon2 = .false. ! Cal. imaginary part of the dielec.
   logical :: calculate_rrae     = .false. ! Cal. refraction,reflection,absorp.

   !  character(len=1) :: dc_all = 'n'      ! n=do not do dc calculations using
                                         ! all formulas for both Lorentzian
                                         ! and Gaussian delta representations.
                                         ! w=do it using same deltawidth for 
                                         ! both a Lorentzian and a Gaussian.
                                         ! h=do it matching Gaussian heigth  
                                         ! to the Lorentzian's.
                                         ! f=do it matching the Gaussian FWHM 
                                         ! to the Lorentzian's.
                                         ! a=do the three cases

   logical :: sigma1_notintra = .false.  ! Do not include intrabands
                                         ! contributions in the
                                         ! sigma1 with exact formula.

   logical :: sigma2_notintra = .false.  ! Do not include intrabands 
                                         ! contributions in sigma2.
                                         
   ! Checking options
   logical :: check_wfc   = .false. ! Check the orthogonality of wavefunctions
   logical :: check_delta = .false. ! Compare the effect of Lorentzians and 
                                   ! Gaussians as delta functions

   ! Overriding options
   logical :: non_local   = .false. ! Use a norm-conserving pseudo even when 
                                    ! the non-local corrections 
                                    ! are not implemented

   logical :: yessym      = .false. ! Over ride the no use of symmetry
   logical :: yesinv      = .false. ! Over ride the no use of inversion symm.

   logical :: writegm     = .false.  ! Read gradient matrix elements if true, else
                                    ! calculate them
   logical :: readgm      = .false. ! Read gradient matrix elements if true, else
                                    ! calculate them

   logical :: npwrecover  = .false. ! If .true., recover cores used in pw 
                                    ! parallelization to use them in the bands
                                    ! parallelization.

   ! delta function and frequency grid variables
   character(len=4) :: deltarep    = '2l' ! Representation for the delta function
                                          ! and use of ( s(w) + s(-w) )/2: 
                                          ! '1l' one for a Lorentzian, 
                                          ! '2l' one for Lorentzians, 
                                          ! '1g' for a Gaussian,
                                          ! '2g' for two Gaussians.
   real(DP) :: deltawidth  = 0.01_DP      ! Width of the representation of the 
                                          ! Dirac delta function in eV
   integer  :: nw   = 1000                ! Number of frequency points
   real(DP) :: wmin = 0.01_DP              ! Minimum frequency in eV (fixed)
   real(DP) :: wmax = 5.0_DP              ! Maximum frequency in eV
   real(DP), allocatable :: wgrid(:)      ! Frequency grid
   real(DP) :: de = 0.0_DP                ! Two energies are equal if the absolute 
                                          ! difference is
                                          ! less than this number (in eV)

   ! Also from QE: outdir (QE<6) or tmp_dir (QE>=6), prefix

   ! ================ End of input variables

   ! Other common variables
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
   character(256) :: outdir ! outdir not defined in QE 6.0
#endif

   ! Gradient matrix elements ( defined and calculated in the main program )
   complex(DP), allocatable    :: psi_grad_psi(:,:,:,:)

   real(DP) :: dw                         ! Frequency step
   real(DP) :: sa                         ! Lorentzian width (delta function)
   real(DP) :: sg                         ! Gaussian width (delta function)

   integer  :: iaux=0 ! To remove the zero frequency in the approx gaussian case 
                      ! (iaux=first argument of frequency higher than 10^-12 ev)

   character(256) :: fname  ! for file names

   integer :: ios, ierr     ! Input and memory allocation error status variables

   ! Variables to recover the plane waves cores and use them in the bands
   ! parallelization
   integer                  :: nproc_kp, nproc_bands, nproc_pw,                &
                               nbnds_local, nbnds_per_process, nbnds_per_group,&
                               my_rank, my_rank_old, my_group
   

   ! \sigma in S.I. : (ohm*meter)^-1
   ! The prefactor for \sigma is
   !    2 \pi e^2 \hbar^3 / (m_e^2 \omega)
   ! That is 2 Pi electron_charge^2 hbar^3/ electron_mass^2 /volume_unit_cell
   ! Ha atomic units are used until here (see kgsigma1 and kgsigma2 modules),
   ! in those units the prefactor is
   ! 2 / \omega
   ! so we have to multiply by
   ! e^2 \hbar^3 / m_e^2 in SI units
   ! and convert the Ha atomic units to SI

   real(DP), parameter :: AU_TO_OHMM_INV = &    ! Conductivity AU to 1/(ohm m)
    ELECTRON_SI**2 * (H_PLANCK_SI/tpi)**3 / ELECTRONMASS_SI**2 &
    / BOHR_RADIUS_SI**3  &                  ! \Omega from bohr^3 to meter^3
    / HARTREE_SI         &                  ! \hbar w in Ha to J
    / BOHR_RADIUS_SI**2  &                  ! \nabla^2 in 1/Bohr^2 to 1/meter^2
    / HARTREE_SI                            ! terms of the form a/(x^2+b^2)
                                            ! in 1/Ha to 1/J

   logical :: sigma2_via_eps1mod   ! calculate sigma2 from sigma2/w through
                                   ! kgepsilon1 module. (Avoid duplicated calc.)
   
                               
contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine kgecvars_check
use qevars, ONLY : mp_bcast, ionode_id, world_comm, tmp_dir
use apawgm, ONLY : use_real_spherical_harm

   call mp_bcast( tmp_dir, ionode_id, world_comm )        
   call mp_bcast( outdir,  ionode_id, world_comm )        
   call mp_bcast( prefix,  ionode_id, world_comm )
   call mp_bcast( calculation, ionode_id, world_comm )        
   call mp_bcast( dc, ionode_id, world_comm )
   call mp_bcast( ac, ionode_id, world_comm )
   call mp_bcast( sigma1_exact, ionode_id, world_comm )
   call mp_bcast( decomposition, ionode_id, world_comm )
   call mp_bcast( calculate_sigma2, ionode_id, world_comm )
   call mp_bcast( calculate_epsilon1, ionode_id, world_comm )
   call mp_bcast( calculate_epsilon2, ionode_id, world_comm )
   call mp_bcast( calculate_rrae, ionode_id, world_comm )
   call mp_bcast( sigma1_notintra, ionode_id, world_comm )
   call mp_bcast( sigma2_notintra, ionode_id, world_comm )
   call mp_bcast( check_wfc, ionode_id, world_comm ) 
   call mp_bcast( check_delta, ionode_id, world_comm )
   call mp_bcast( non_local, ionode_id, world_comm ) 
   call mp_bcast( yessym, ionode_id, world_comm ) 
   call mp_bcast( yesinv, ionode_id, world_comm ) 
   call mp_bcast( writegm, ionode_id, world_comm )
   call mp_bcast( readgm, ionode_id, world_comm )
   call mp_bcast( npwrecover, ionode_id, world_comm )
   call mp_bcast( deltarep, ionode_id, world_comm ) 
   call mp_bcast( deltawidth, ionode_id, world_comm )
   call mp_bcast( nw, ionode_id, world_comm )
   call mp_bcast( wmin, ionode_id, world_comm )
   call mp_bcast( wmax, ionode_id, world_comm )
   call mp_bcast( de, ionode_id, world_comm )
   call mp_bcast( use_real_spherical_harm, ionode_id, world_comm )
   call mp_bcast( sigma2_via_eps1mod, ionode_id, world_comm )
!   call mp_bcast( dc_all, ionode_id, world_comm )

   select case ( calculation )
    case('TENSOR','tensor')
      calculation = 'tensor'
    case('atrace', 'ATRACE')
      calculation = 'atrace'
    case default
      call errore( 'kgecvars','set calculation to either tensor or atrace', 7 )
   end select

   select case ( deltarep )
    case( 'l', 'L', '1l', '1L' )
      deltarep = '1l'
    case('2l', '2L' )
      deltarep = '2l'
    case( 'g', 'G', '1g', '1G' )
      deltarep = '1g'
    case( '2g', '2G' )
      deltarep = '2g'
    case default
      call errore( 'kgecvars','set deltarep to either l or g, 2l or 2g', 8 )
   end select

   select case ( ac )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set ac to either .true. or .false.', 8 )
   endselect 

   select case ( dc )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set dc to either .true. or .false.', 8 )
   endselect 

   if( (ac .eqv. .false.) .and. (dc .eqv. .false.) ) then
      call errore( 'kgecvars','ac and dc can not be both .false.', 8 )
   endif

   select case ( calculate_sigma2 )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set calculate_sigma2 to either .true. or .false.', 8 )
   endselect 

   select case ( calculate_epsilon1 )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set calculate_epsilon1 to either .true. or .false.', 8 )
   endselect 

   select case ( calculate_epsilon1 )
   case( .true. )  
      if( .not. calculate_sigma2 ) calculate_sigma2=.true.
   endselect 

   select case ( calculate_epsilon2 )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set calculate_epsilon2 to either .true. or .false.', 8 )
   endselect 

   select case ( calculate_rrae )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set calculate_rrae to either .true. or .false.', 8 )
   endselect 

   select case ( calculate_rrae )
   case( .true. )

      if ( .not. calculate_epsilon1   ) then
         write(stdout, '(A)') &
         ' Warning: calculate_rrae=.true. so changing calculate_epsilon1  to .true.'
        calculate_epsilon1 = .true.

        if ( .not. calculate_sigma2 ) then 
           write(stdout, '(A)') &
           ' Warning: calculate_rrae=.true. so changing calculate_sigma2  to .true.'
           calculate_sigma2 = .true.
        endif

      endif

      if ( .not. calculate_epsilon2   ) then
         write(stdout, '(A)') &
         ' Warning: calculate_rrae=.true. so changing calculate_epsilon2  to .true.'
        calculate_epsilon2 = .true.
      endif

   endselect 
        
   select case ( sigma1_notintra )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set sigma1_notintra to either .true. or .false.', 8 )
   endselect         

   select case ( sigma2_notintra )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set sigma2_notintra to either .true. or .false.', 8 )
   endselect         

   select case ( check_wfc )
   case( .true., .false.)
   case default
      call errore( 'kgecvars','set check_wfc to either .true. or .false.', 8 )
   endselect 

   select case ( check_delta )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set check_delta to either .true. or .false.', 8 )
   endselect 

   select case ( non_local )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set non_local to either .true. or .false.', 8 )
   endselect 

   select case ( yessym )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set yessym to either .true. or .false.', 8 )
   endselect 

   select case ( yesinv )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set yesinv to either .true. or .false.', 8 )
   endselect 

   if ( writegm .and. readgm ) then
      call errore( 'kgecvars','set writegm and readgm can not be both to .true.', 11 )
   endif

   select case ( writegm )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set writegm to either .true. or .false.', 8 )
   endselect 

   select case ( readgm )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set readgm to either .true. or .false.', 8 )
   endselect 

   select case ( npwrecover )
   case( .true.,  .false.)
   case default
      call errore( 'kgecvars','set npwrecover to either .true. or .false.', 8 )
   endselect 

   if ( .not. sigma1_exact ) then

      if ( decomposition ) then
         call errore( &
         'kgecvars','Decomposition not possible for the approximated formula. ', 9)
      endif

      if ( sigma1_notintra ) then
         call errore(&
  'kgecvars','sigma1_notintra=.true. only for the exact formula (sigma1_exact=.true.) ', 10)
      endif      
   
   endif  

   if( mod(nw,2) /= 0 ) then
      call errore( 'kgecvars','nw must be even', 11 )
   endif

   if ( calculate_sigma2 .and. calculate_epsilon1 ) then
      sigma2_via_eps1mod = .true.
      calculate_sigma2   = .false.
   endif

   if ( (sigma1_notintra .or. sigma2_notintra) .and. decomposition ) then
      call errore(& 
      'kgecvars','sigma1_notintra=.true. or sigma2_notintra=.true. &
       and decomposition=.true. not possible', 11 )
   endif 

!   select case( dc_all )
!   case( 'n','N','No','no' )
!      dc_all='n'
!   case( 'w', 'W' ) ! same widths means the deltawidths given is used directly as
!      dc_all='w'    ! 1/deltawidth for the gaussian exponent
!   case( 'h', 'H' )
!      dc_all='h'  
!   case( 'f', 'F' )
!      dc_all='f'
!   case( 'all', 'a', 'A', 'ALL' )
!      dc_all='a'
 !  end select   

   if ( de == 0.0_DP ) then
      de = conv_thr * 0.5_DP ! Change from Ry to Ha
   else
      de = de / AUTOEV       ! Change from eV to Ha
   endif
   
   if ( readgm ) then
      check_wfc = .false.
   endif 
 
end subroutine kgecvars_check


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine kgecvars_print
use apawgm, ONLY : use_real_spherical_harm

   write(stdout,*) ''
   write(stdout,*)           '    --------------------------------------------------------------'
   write(stdout,*)           "                Parameters for the KG conductivity"
   write(stdout,*)           '    --------------------------------------------------------------'
   write(stdout,'(A,A)')     '     Type of calculation          : ', calculation

   if( calculate_sigma2 .or. sigma2_via_eps1mod ) then
     write(stdout,*)         '    Calculate                    : Sigma1 and Sigma2'
   else
     write(stdout,*)         '    Calculate                    : Sigma1 only'
   endif
   if( calculate_epsilon1 ) then
     write(stdout,*)         '    Calculate                    : epsilon1'
   endif
   if( calculate_epsilon2 ) then
     write(stdout,*)         '    Calculate                    : epsilon2'
   endif
   if( calculate_rrae ) then
     write(stdout,*)         '    Calculate                    : spectral properties'
   endif
   if( use_real_spherical_harm ) then
     write(stdout,*)         '    Spherical Harmonics          : Real'
   else
     write(stdout,*)         '    Spherical Harmonics          : Complex'
   endif
   if (sigma1_exact ) then
    write(stdout,'(A)')      '     Formulas                     : exact'
    
   if ( sigma1_notintra ) then
       write(stdout,'(A)')    '        sigma1_notintra           : yes'
   else
       write(stdout,'(A)')    '        sigma1_notintra           : no'
   endif

   if ( sigma2_notintra ) then
       write(stdout,'(A)')    '        sigma2_notintra           : yes'
   else
       write(stdout,'(A)')    '        sigma2_notintra           : no'
   endif
   
    if ( decomposition ) then 
       write(stdout,'(A)')    '        Decomposition             : yes'
    else
       write(stdout,'(A)')    '        Decomposition             : no'
    endif
   else
    write(stdout,'(A)')      '     Formulas                     : approximated (decomposition not possible)'
   endif

   if ( deltarep == '1l' .or. deltarep == '2l' ) then
     write(stdout,'(a,f10.6,a,1a,a)') '     Delta function width (eV)    :', deltawidth,'  (', deltarep(1:1),' Lorentzian(s))'
     write(stdout,'(a,f10.6,a)') '      Gaussian width (same height):', &
                                    0.5_dp*deltawidth/sqrt(pi)   ! Same height as Lorentzian
     write(stdout,'(a,f10.6,a)') '      Gaussian width (same FWHM)  :', &
                                    deltawidth * 0.5_dp / sqrt( log(2.0_dp) ) ! Same FWHM
   endif
   if ( deltarep == '1g' .or. deltarep=='2g' ) then
     write(stdout,'(a,f10.6,a,1a,a)') '     Delta function width (eV)    :', deltawidth,'  (', deltarep(1:1),' Gaussian(s))'
   endif
   if ( check_wfc ) then
     write(stdout,'(A)') '     Check the wave functions     : yes'
   else
     write(stdout,'(A)') '     Check the wave functions     : no'
   endif
   if ( check_delta ) then
     write(stdout,'(A)') '     Check delta function rep.    : yes'
   else
     write(stdout,'(A)') '     Check delta function rep.    : no'
   endif
   if ( dc ) then
     write(stdout,'(A)') '     DC component                 : yes'
   else
     write(stdout,'(A)') '     DC component                 : no'
   endif
   if ( ac ) then
     write(stdout,'(A)') '     AC component                 : yes'
   else
     write(stdout,'(A)') '     AC component                 : no'
   endif
   if ( readgm ) then
     write(stdout,'(A)') '     Gradient matrix elements     : read'
   else
     write(stdout,'(A)') '     Gradient matrix elements     : calculate'
   endif

   write(stdout,*)       '     Energies equal. tol. (eV)   :', de * AUTOEV

   if ( npwrecover ) then
     write(stdout,'(A)') '     Recover plane waves procs.   : yes'
   else
     write(stdout,'(A)') '     Recover plane waves procs.   : no'
   endif

end subroutine kgecvars_print

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_writegm
      ! Save final gradient matrix elements
      use mp_pools,  ONLY : inter_pool_comm, intra_pool_comm, my_pool_id, me_pool
      use mp,        ONLY : mp_rank, mp_size
      use qevars,    ONLY : nbnd, nks, tmp_dir, IONODE
       
      integer :: ik, ibb1, ib2, nk, nb

      my_pool_id = mp_rank( inter_pool_comm )
      me_pool    = mp_rank( intra_pool_comm )         
      

      if (IONODE) then
        nk = mp_size( inter_pool_comm )
        nb = mp_size( intra_pool_comm )
        open(121, file='nodes-and-tasks-in-use.dat', action='write')
        write(121,*) nk, nb
        close(121)
      endif

      write(stdout,*) ''
      write(stdout,'(A)',advance='no') '     Writing the gradient matrix elements ...'

      write (fname, "('psi_grad_psi-k', i0,'_b', i0, '.dat')") my_pool_id, me_pool 
      fname=trim(tmp_dir)//fname

      open(121, file=fname,action='write')
      do ik=1, nks

      do ibb1=1, nbnds_local
      do ib2=1, nbnd
         write(121,*) psi_grad_psi(1,ib2,ibb1,ik), &
                      psi_grad_psi(2,ib2,ibb1,ik), &
                      psi_grad_psi(3,ib2,ibb1,ik)
      enddo  
      enddo
      enddo
      close(121)

      write(stdout,'(A)') ' done.'  
      
   end subroutine kgec_writegm

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_readgm

      ! Read gradient matrix elements

      use mp_pools,  ONLY : inter_pool_comm, intra_pool_comm, my_pool_id, &
                            me_pool
      use mp,        ONLY : mp_rank, mp_size, mp_bcast
      use io_global, ONLY : stdout
      use qevars,    ONLY : nbnd, nks, tmp_dir, IONODE, ionode_id, world_comm
       
      integer :: ik, ibb1, ib2, ierr, nk, nb, nk1, nb1
      logical :: file_exist
      

      my_pool_id = mp_rank( inter_pool_comm )
      me_pool    = mp_rank( intra_pool_comm )         

      if (IONODE) then

        inquire(file="./nodes-and-tasks-in-use.dat", exist=file_exist)

        if ( file_exist ) then
          open(121, file='nodes-and-tasks-in-use.dat', action='read')
          read(121,*) nk1, nb1
          close(121)
        endif

        nk = mp_size( inter_pool_comm )
        nb = mp_size( intra_pool_comm )

      endif

      call mp_bcast( file_exist, ionode_id, world_comm )
      
      if ( .not. file_exist ) then
         call errore( 'kgecvars','File nodes-and-tasks-in-use.dat does not exist (see writegm).', 10)
      endif
                   
      call mp_bcast( nk1, ionode_id, world_comm )        
      call mp_bcast( nb1, ionode_id, world_comm )        
      call mp_bcast(  nk, ionode_id, world_comm )        
      call mp_bcast(  nb, ionode_id, world_comm )        

      if ( nk1 /= nk .or. nb1 /= nb ) then
         call errore( 'kgecvars','Current nk and nb values are not the same as those used to write the grad. matrix. ', 10)
      endif


      write(stdout,*) ''
      write(stdout,'(A)',advance='no') '     Reading the gradient matrix elements ...'

      write (fname, "('psi_grad_psi-k', i0,'_b', i0, '.dat')") my_pool_id, me_pool 
      fname=trim(tmp_dir)//fname

      allocate( psi_grad_psi(1:3, 1:nbnd, 1:nbnds_local, 1:nks), STAT=ierr )
      if (ierr/=0) call errore('kgecvars','allocating psi_grad_psi', abs(ierr) )

      open(121, file=fname,action='read')
      do ik=1, nks
         do ibb1=1, nbnds_local
         do ib2=1, nbnd
            read(121,*) psi_grad_psi(1,ib2,ibb1,ik), &
                        psi_grad_psi(2,ib2,ibb1,ik), &
                        psi_grad_psi(3,ib2,ibb1,ik)
         enddo
         enddo
      enddo
      close(121)

      write(stdout,'(A)') ' done.'  
      
   end subroutine kgec_readgm


end module kgecvars

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module qevars
! Quantum Espresso variables

    use kinds,      ONLY : DP
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
    use io_files,   ONLY : nd_nmbr, prefix, tmp_dir, nwordwfc, iunwfc
#elif defined(__QE54) || defined(__QE512)
    use io_files,   ONLY : nd_nmbr, prefix, outdir, tmp_dir, nwordwfc, iunwfc
#endif
    use io_global,  ONLY : ionode, ionode_id, stdout
#if defined(__QE64)
    use mp_global, ONLY: mp_startup, mp_global_end
    use mp_world,  ONLY: world_comm !, nproc
#else
    use mp_global,  ONLY : mp_startup, mp_global_end, world_comm
#endif
    ! for parallelization over k-points, bands and PW 
    use mp_pools,   ONLY : inter_pool_comm, intra_pool_comm, my_pool_id, me_pool
    use mp_bands,   ONLY : inter_bgrp_comm, intra_bgrp_comm, nproc_bgrp
    use mp,         ONLY : mp_sum, mp_bcast, mp_size, mp_barrier, mp_rank,     &
                           mp_comm_split, mp_comm_group, mp_comm_free,         &
                           mp_group_free
    use constants,  ONLY : PI, TPI, RYTOEV, tpi, ELECTRON_SI, H_PLANCK_SI,     &
                           AUTOEV, HARTREE_SI, BOHR_RADIUS_SI, ELECTRONMASS_SI,&
                           ELECTRONVOLT_SI, SQRTPI, eps6, eV_to_kelvin,        &
                           C_SI, C_AU

#if defined(__QE64)
    use control_flags, ONLY: gamma_only
    use input_parameters, ONLY: conv_thr, wf_collect
#else
    use control_flags, ONLY : twfcollect, gamma_only
    !use input_parameters, ONLY : pseudo_dir, wfcdir, wf_collect
    use input_parameters, ONLY : conv_thr
#endif

    use noncollin_module, ONLY : noncolin, npol
    use environment, ONLY : environment_start, environment_end

    ! Real space unit cell
    use cell_base,  ONLY : tpiba, tpiba2, omega

    ! Reciprocal Space
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
    use klist,      ONLY : nks, xk, wk, ngk, igk_k, nelec, ngauss, degauss, nkstot
#elif defined (__QE54) || defined(__QE512)
    use klist,      ONLY : nks, xk, wk, nelec, ngauss, degauss, nkstot
#endif
    use gvect,      ONLY : ngm, g

    ! Point group symmetry and inversion control variables
    use symm_base,     ONLY : nsym
#if defined(__QE62)
    use input_parameters, ONLY : noinv
#else
    use control_flags, ONLY : noinv
#endif

    ! System Wave Functions
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
    use wvfct,      ONLY : npw, npwx, nbnd, g2kin, wg, et
#elif defined(__QE54)
    use wvfct,      ONLY : npw, npwx, nbnd, igk, g2kin, wg, et
#elif defined(__QE512)
    use wvfct,      ONLY : npw, npwx, nbnd, igk, g2kin, wg, et, ecutwfc
#endif
#if defined(__QE6) || defined(__QE62) || defined(__QE54) || defined(__QE64)
    use gvecw,      ONLY : ecutwfc
#endif
    use lsda_mod,   ONLY : lsda, nspin
#if defined(__QE64)
    use wavefunctions,        ONLY : evc
#else
    use wavefunctions_module, ONLY : evc
#endif

    ! Atoms and pseudo data
    !USE ions_base,      ONLY : nat, ityp, tau
    use uspp,           ONLY : okvan
    use paw_variables,  ONLY : okpaw, only_paw
    !USE atom,           ONLY : msh, rgrid
    !USE paw_onecenter,  ONLY : PAW_potential
    !USE paw_symmetry,   ONLY : PAW_symmetrize_ddd
    !USE uspp_param,     ONLY : upf, nh, nhm, nbetam

    use ener, ONLY : e_f => ef
    implicit none
end module qevars

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgecpaw
use kinds, ONLY : DP
implicit none

      real(DP),    allocatable :: psi_norm_factor(:,:)

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_paw_renorm
   use qevars
   use qe_p_psi, ONLY: p_psi, becp
   use kgecvars
   use apawgm, ONLY : awfc_grad_awfc,         &
                      n_pro_tot, check_p_pswfc, diff_awfc_grad_awfc,   &
                      psi_norm_correction_paw_at, psi_norm_correction_at,  &
                      p_index, p_index_row_start, p_index_row_end, agm_free_memory

   implicit none


      integer :: ip1, ip2              ! Consecutive counters for the projectors

      integer :: ik, ig                ! counter on k-points and plane waves
                                       ! always local (parallelization is hidden) 
                                         

      integer :: ib1                    ! global counters on bands

      complex(DP) :: caux

      my_rank = mp_rank( inter_bgrp_comm )

      write(stdout,*) " "
      write(stdout,'(A)',advance='no')  &
         "     Calculating the re-normalization factors of | \Psi_{nk} > ..."

      ! If PAW, renormalize the wave function psi
      ! The norm of |psi> is given by
      ! <psi|psi> =  <pssi|pspsi> 
      ! + sum_anlm sum_an'lm <pspsi|p_anlm> 
      ! ( <Ranl|Ran'l> - <pseudo R_anl| pseudo R_an'l> ) <p_an'lm|pspsi>

      ! Calculating the 
      ! ( < R_anl | R_an'l >  - < pseudo R_anl | pseudo R_an'l > ) term
       call psi_norm_correction_paw_at()

       ! Get <p|\Psi> ( becp%k )
       call p_psi

       ! Calculating the renormalization factors 1/<psi|psi>^(1/2)
       allocate( psi_norm_factor( 1:nbnd, 1:nks ) )

       do ik=1, nks
          ! Get npw for the current k-vector
#if defined(__QE512) || defined(__QE54)
          call gk_sort (xk (1, ik), ngm, g, ecutwfc / tpiba2, npw, igk, g2kin)
#elif defined(__QE6) || defined(__QE62) || defined(__QE64)
          npw = ngk(ik)
#endif
          ! Read the wave function for the current k-vector
          call davcio ( evc , 2*nwordwfc, iunwfc, ik, - 1 )

          do ib1=1, nbnd

             caux = cmplx( 0.0_dp, 0.0_dp )

             do ig=1, npw
                caux = caux + conjg( evc(ig,ib1) ) * evc(ig,ib1)
             enddo

             call mp_sum( caux, intra_bgrp_comm ) ! reduce on G (npw)

             do ip1=1, n_pro_tot
!             do ip2=1, n_pro_tot
             do ip2=p_index_row_start(ip1), p_index_row_end(ip1)
                caux = caux + conjg( becp(ik)%k(ip1,ib1) ) &
                              * psi_norm_correction_at( p_index(ip1), p_index(ip2) ) &
                                * becp(ik)%k(ip2,ib1)
             enddo
             enddo

             psi_norm_factor( ib1, ik) = 1.0_dp / dsqrt(abs(caux))
!             psi_norm_factor( ib1, ik ) = 1.0_dp


          enddo
       enddo

       write(stdout,*) ' done.'

   end subroutine kgec_paw_renorm


end module kgecpaw

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 

module kgecchecks
use qevars
use qe_p_psi, ONLY: becp
use kgecvars
implicit none


private

   integer :: ip1, ip2 ! Consecutive counters for the projectors

   integer :: ik                      ! counter on k-points and plane waves
                                      ! always local (parallelization is hidden) 
   integer :: ib1,  ib2               ! global counters on bands
   integer :: ibb1                     ! local counters on bands

   real(DP)    :: aux, ee
   complex(DP) :: caux, psi_grad_psi_aux(3), cvaux(1:3)

public :: kgec_check_requirements, kgec_check_orthonormalization_nc, &
          kgec_check_orthonormalization_paw

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


subroutine kgec_check_requirements
use qevars
use kgecvars, ONLY : non_local, yessym, yesinv, outdir

   !
   ! Check if the conditions for the utilization of the code are met
   !

   if( okvan .and. (.not. okpaw)     ) &
      call errore( 'kgec','Ultrasoft not implemented',              1 )
   if( okpaw .and. (.not. only_paw ) ) &
      call errore( 'kgec','Mixed norm conserving pps and PAW sets', 2 )
   if( gamma_only )                     &
      call errore( 'kgec','Gamma only code used',                   4 )
   if( noncolin )                       &
      call errore( 'kgec','Non-collinear not implemented',          5 )
   if( lsda )                           &
      call errore( 'kgec','Spin not implemented',                   6 )
   if( .not. okpaw .and. ( .not. non_local ) ) then
        write(stdout,*) 'kgec','Non-local correction not implemented'
        call errore( 'kgec','Please use non_local=.true. in KGEC if you would &
                                                         like to proceed',   7 )
   endif

   ! track both nosym and noinv by the value of nsym 
   ! (nsym=1 => identity )
   ! (nsym=2 => identity and inversion)
   ! (nsym>2 => symmetries beyond identity plus inversion)  
   if ( (nsym > 1) .and. (.not. yessym) ) then
       call errore( 'kgec','Symmetry used? (set nosym=.true. in QE or &
                                                    yessym=.true. in KGEC)', 8 )
   !endif
   !if( ( .not. noinv ) .and. ( .not. yesinv ) ) then
      call errore( 'kgec','Inversion symmetry used? (set noinv=.true. &
                                            in QE or yesinv=.true. in KGEC', 9 )
   endif

   ! 
   ! Check the kind of smearing used by pw.x
   ! 

   select case (ngauss)
   case ( -99 )
   case default
     write(stdout,*) "  WARNING: not Fermi-Dirac smearing, ngauss=", ngauss
     write(stdout,*)
   end select


   write(stdout,*) ''
   write(stdout,*) &
          '    --------------------------------------------------------------'
   write(stdout,*) &
          "               Parameters from the QE calculation "
   write(stdout,*) &
          '    --------------------------------------------------------------'
   write(stdout,'(A,2x,A20)') &
          '     System                    :', prefix
   write(stdout,'(A,2x,A20)') &
          '     Directory                 :', outdir
   write(stdout,'(A,f20.6)')  &
          '     Number of electrons       :', nelec
   write(stdout,'(A,f20.6)')  &
          '     Temperature (Ry)(degauss) :', degauss ! Ry units in QE
   write(stdout,'(A,f20.6)')  &
          '     Temperature (K) (degauss) :', degauss * RYTOEV * eV_to_kelvin
   write(stdout,'(A,f20.6)') &
          '     Temperature (eV)(degauss) :', degauss * RYTOEV
   write(stdout,'(A,i20)'  ) &
          '     Number of bands           :', nbnd
   write(stdout,'(A,i20)'  ) &
          '     Number of k-points        :', nkstot
   write(stdout,'(A,f20.6)') &
          '     Sum of k-weights          :', sum(wk) ! Should be equal to 2
   write(stdout,'(A,f20.6)') &
          '     Sum of band weights       :', sum(wg)  ! Should be equal to nelec
   write(stdout,'(A,f20.6)') &
          '     Fermi energy (eV)         :', e_f*RYTOEV
   write(stdout,'(A,f20.6)') &
          '     Volume (bohr^3)           :', omega
   write(stdout,'(A,f20.6)') &
          '     Wave function cutoff (ry) :', ecutwfc 
   if( okpaw ) then
     write(stdout,*) &
          '    Pseudo type               :                PAWs'
   else
     write(stdout,*) &
          '    Pseudo type               :     Norm-Conserving'
   endif

end subroutine kgec_check_requirements

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_check_orthonormalization_nc

      complex(DP), allocatable :: psi_psi(:,:)

      integer :: ik                  ! counter on k-points
                                     ! always local (parallelization is hidden) 
                                         

      integer :: ib1,  ib2           ! global counters on bands
      integer :: ibb1, ibb2          ! local counters on bands
       
      complex(DP) :: caux
   
         my_rank = mp_rank( inter_bgrp_comm )

         write(stdout,*)  " "
         write(stdout,'(A)',advance='no') &
                 "     Checking ortho-normality of the Wave Functions .."

         allocate( psi_psi(1:nbnds_local, 1:nbnds_local) )

         do ik = 1, nks

#if defined (__QE512) || defined(__QE54)
          call gk_sort (xk (1, ik), ngm, g, ecutwfc / tpiba2, npw, igk, g2kin)
#elif defined(__QE6) || defined (__QE62) || defined(__QE64)
          npw = ngk(ik)
#endif

            ! Read the wave function for the current k-vector
            call davcio ( evc , 2*nwordwfc, iunwfc, ik, -1 )

            CALL zgemm( 'C', 'N', nbnd, nbnds_local, npw, &
                        1.0_dp, evc, npwx, evc, npwx, (0.0_dp,0.0_dp), &
                        psi_psi, nbnds_local )

            call mp_sum( psi_psi, intra_bgrp_comm ) ! reduce on G (npw)    

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank
                           
               do ibb2 = 1, nbnds_local
                  ib2  = ibb2 + nbnds_per_process * my_rank
                  
                  caux = psi_psi( ibb2, ibb1 )

!! XXX ik is local, change it to global 

                  if ( (ib1/=ib2) .and. abs(caux)> 1.d-6 ) then
                     write(stdout,*) '     Non orthogonal:', ik, ib1, ib2, caux
                  endif

                  if ( (ib1==ib2) .and. abs(caux-1.0_dp)>1.0d-5 ) then
                     write(stdout,*) '     Not normalized:', ik, ib1, ib2, caux
                  endif

               enddo
            enddo

         enddo
         deallocate(psi_psi)

         write(stdout,'(A)') ' done. '

   
   end subroutine kgec_check_orthonormalization_nc
   

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


   subroutine kgec_check_orthonormalization_paw
   use kgecpaw, ONLY : psi_norm_factor
   use apawgm,  ONLY : awfc_grad_awfc,                                      &
                       n_pro_tot, check_p_pswfc, diff_awfc_grad_awfc,       &
                       psi_norm_correction_paw_at, psi_norm_correction_at,  &
                       p_index, p_index_row_start, p_index_row_end,         &
                       agm_free_memory

      integer :: ik, ig                  ! counter on k-points and plane waves
                                         ! always local (parallelization is hidden) 
                                         

      integer :: ib1,  ib2                    ! global counters on bands
      integer :: ibb1                         ! local counters on bands
       

IF(IONODE) THEN
         ! Check duality of PAW projectors and pseudo atomic wavefunctions
         call check_p_pswfc
ENDIF ! ionode

         my_rank = mp_rank( inter_bgrp_comm )

         write(stdout,*)  " "
         write(stdout,'(A)',advance='no') &
            "     Checking orthogonality of the Wave Functions"

         write (fname, "('non-orthogonal-wfc-k', i0,'_b', i0, '.dat')") &
                                                             my_pool_id, me_pool 

         fname=trim(tmp_dir)//fname
         open(121,file=fname, action='write' )
         write(121,'(A)') "# Non-orthogonal wavefunctions"
         write(121,'(A)') &
            "# k-point, band index, band -index, Re(<ib1|ib2>), Im(<ib1|ib2>)"
 
         ierr = 0
         do ik=1, nks
            ! Get npw for the current k-vector
#if defined (__QE512) || defined(__QE54)
          call gk_sort (xk (1, ik), ngm, g, ecutwfc / tpiba2, npw, igk, g2kin)
#elif defined(__QE6) || defined(__QE62) || defined(__QE64)
          npw = ngk(ik)
#endif

            ! Read the wave function for the current k-vector
            call davcio( evc , 2*nwordwfc, iunwfc, ik, -1 )

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank

            do ib2 = ib1, nbnd

               caux = cmplx( 0.0_dp, 0.0_dp )

               do ig = 1, npw
                  caux = caux + conjg( evc( ig,ib1 ) ) * evc( ig,ib2 )
               enddo

               call mp_sum( caux, intra_bgrp_comm ) ! reduce on G (npw)

               do ip1 = 1, n_pro_tot
!               do ip2 = 1, n_pro_tot
               do ip2 = p_index_row_start(ip1), p_index_row_end(ip1)
                  caux = caux + conjg( becp(ik)%k(ip1,ib1) ) &
                        * psi_norm_correction_at( p_index(ip1), p_index(ip2) ) &
                                  * becp(ik)%k(ip2,ib2)
               enddo
               enddo

               caux = caux * psi_norm_factor(ib1,ik) * psi_norm_factor(ib2,ik)

! XXX ik is local, change to global

               if ( ib1/=ib2 .and. abs(caux)>1.e-9 ) then
                  ierr = ierr + 1
                  write(121,'(2x,3i8,2x,1g20.7)') ik, ib2, ib1, abs(caux)
               endif

            enddo
            enddo

         enddo

         call mp_sum( ierr, inter_pool_comm )
          
         if ( ierr>0 ) then
            close(121)
            write(stdout,*) " "
            write(stdout,*) &
              "     WARNING: wave functions non orthogonal (pairs):", ierr
            write(stdout,*) "     See file non-orthogonal-wfc*.dat"
         else
            close(121,status='delete') 
            write(stdout,*) "... done"
         endif
          
         ierr=0

   end subroutine kgec_check_orthonormalization_paw
   
   

end module kgecchecks

!  Added module to KGEC for the calculation of other properties based on KG
! 
! Copyright (C) 2017- Lazaro Calderin and Valentin Karasiev
! 
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net
! 
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 

module kgepsilon1

use kinds, ONLY      : DP
use qevars, ONLY     : pi
use kgecvars, ONLY   : nw, wgrid
use kgsigma2_w
use kgsigma2

implicit none

   private

   ! \epsilon_2 and its decomposition in intra-bands, degeneracies and 
   ! inter-bands contributions
   real(DP), allocatable, public :: epsilon1(:,:,:)       
   real(DP), allocatable, public :: epsilon1_intra(:,:,:)  
   real(DP), allocatable, public :: epsilon1_degen(:,:,:)  
   real(DP), allocatable, public :: epsilon1_inter(:,:,:) 

   ! Average traces
   real(DP), allocatable, public :: epsilon1_atrace(:)    
   real(DP), allocatable, public :: epsilon1_atrace_intra(:)     
   real(DP), allocatable, public :: epsilon1_atrace_degen(:)     
   real(DP), allocatable, public :: epsilon1_atrace_inter(:)     

   ! DC tensors
   real(DP), allocatable, public :: epsilon1_dc(:,:)       
   real(DP), allocatable, public :: epsilon1_dc_intra(:,:)  
   real(DP), allocatable, public :: epsilon1_dc_degen(:,:)  
   real(DP), allocatable, public :: epsilon1_dc_inter(:,:) 

   ! DC traces
   real(DP), public :: epsilon1_dc_atrace    
   real(DP), public :: epsilon1_dc_atrace_intra   
   real(DP), public :: epsilon1_dc_atrace_degen    
   real(DP), public :: epsilon1_dc_atrace_inter    


   public :: epsilon1_tensor,                         &   
             epsilon1_atrace_sub,                     &
             epsilon1_tensor_decomp,                  &
             epsilon1_atrace_decomp,                  &
             epsilon1_dc_tensor,                      &
             epsilon1_dc_atrace_sub,                  &
             epsilon1_dc_atrace_decomp,               &
             epsilon1_dc_tensor_decomp,               &
             epsilon1_tensor_sub_sigma2,              &
             epsilon1_atrace_sub_sigma2,              &
             epsilon1_tensor_decomp_sigma2,           &
             epsilon1_atrace_decomp_sigma2           
             

  integer :: iw, ix, ierr

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_tensor

   call sigma2_w_sub

   ! dielectric tensor ( real part )
   allocate( epsilon1(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor','allocating epsilon1', ABS(ierr) )

   do iw = 0, nw
         epsilon1(1:3,1:3, iw) = -4.0d0 * pi * sigma2_w( 1:3, 1:3, iw) 
   enddo

   do ix = 1, 3
      epsilon1(ix,ix,0:nw) = 1.0_dp + epsilon1(ix,ix,0:nw)
   enddo

   ! traces
   
   allocate( epsilon1_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor',&
                  'allocating epsilon1_atrace', ABS(ierr) )

   epsilon1_atrace(0:nw) = & 
       ( epsilon1(1,1,0:nw) + epsilon1(2,2,0:nw) + epsilon1(3,3,0:nw) ) / 3.0_dp

end subroutine epsilon1_tensor

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_tensor_decomp

   call sigma2_w_decomp

   ! dielectric tensor ( real part ) intra-band contribution
   allocate( epsilon1_intra(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_intra', ABS(ierr) )
   do iw = 0, nw
         epsilon1_intra(1:3,1:3, iw) = &
              -4.0d0 * pi * sigma2_w_intra( 1:3, 1:3, iw)
   enddo

   do ix = 1, 3
      epsilon1_intra(ix,ix,0:nw) = 1.0_dp + epsilon1_intra(ix,ix,0:nw) 
   enddo

   ! dielectric tensor ( real part ) degeneracies contribution

   allocate( epsilon1_degen(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_degen', ABS(ierr) )
   do iw = 0, nw

         epsilon1_degen(1:3,1:3, iw) = &
              -4.0d0 * pi * sigma2_w_degen( 1:3, 1:3, iw)
   enddo

   do ix = 1, 3
      epsilon1_degen(ix,ix,0:nw) = 1.0_dp + epsilon1_degen(ix,ix,0:nw) 
   enddo

   ! dielectric tensor ( real part ) inter-band contribution

   allocate( epsilon1_inter(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_inter', ABS(ierr) )

   do iw = 0, nw
         epsilon1_inter(1:3,1:3, iw) = &
              -4.0d0 * pi * sigma2_w_inter( 1:3, 1:3, iw)
   enddo

   do ix = 1, 3
      epsilon1_inter(ix,ix,0:nw) = 1.0_dp + epsilon1_inter(ix,ix,0:nw) 
   enddo


   allocate( epsilon1(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1', ABS(ierr) )

   epsilon1 = epsilon1_intra + epsilon1_degen + epsilon1_inter


   ! Traces

   allocate( epsilon1_atrace_intra(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_atrace_intra', ABS(ierr) )

   epsilon1_atrace_intra(0:nw) = & 
       ( epsilon1_intra(1,1,0:nw) + epsilon1_intra(2,2,0:nw) &
                               + epsilon1_intra(3,3,0:nw) ) / 3.0_dp


   allocate( epsilon1_atrace_degen(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_atrace_degen', ABS(ierr) )

   epsilon1_atrace_degen(0:nw) = & 
       ( epsilon1_degen(1,1,0:nw) + epsilon1_degen(2,2,0:nw) &
                              + epsilon1_degen(3,3,0:nw) ) / 3.0_dp

   allocate( epsilon1_atrace_inter(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_atrace_inter', ABS(ierr) )

   epsilon1_atrace_inter(0:nw) = & 
       ( epsilon1_inter(1,1,0:nw) + epsilon1_inter(2,2,0:nw) &
                               + epsilon1_inter(3,3,0:nw) ) / 3.0_dp


   allocate( epsilon1_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_tensor_decomp',&
                  'allocating epsilon1_atrace', ABS(ierr) )

   epsilon1_atrace = epsilon1_atrace_intra + epsilon1_atrace_degen & 
                                           + epsilon1_atrace_inter

end subroutine epsilon1_tensor_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_atrace_sub

   call sigma2_w_atrace_sub
 
   ! dielectric tensor ( real part )
   allocate( epsilon1_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace',&
                  'allocating epsilon1_atrace', ABS(ierr) )

   do iw = 0, nw
      epsilon1_atrace(iw) = 1.0_dp - 4.0_dp * pi * sigma2_w_atrace( iw )
   enddo

end subroutine epsilon1_atrace_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_atrace_decomp()

  call sigma2_w_atrace_decomp

  ! dielectric tensor ( real part ) intra-band contribution

   allocate( epsilon1_atrace_intra(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon1_atrace_intra', ABS(ierr) )

   do iw = 0, nw
      epsilon1_atrace_intra(iw) = - 4.0d0*pi*sigma2_w_atrace_intra(iw)   
   enddo

   ! dielectric tensor ( real part ) degeneracies contribution

   allocate( epsilon1_atrace_degen(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon1_atrace_degen', ABS(ierr) )

   do iw = 0, nw
         epsilon1_atrace_degen(iw) = - 4.0d0*pi*sigma2_w_atrace_degen(iw)
   enddo

   ! dielectric tensor ( real part ) inter-band contribution

   allocate( epsilon1_atrace_inter(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon1_atrace_inter', ABS(ierr) )

   do iw = 0, nw
         epsilon1_atrace_inter(iw) = &
                           - 4.0d0 * pi * sigma2_w_atrace_inter( iw )
   enddo

   allocate( epsilon1_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_atrace_decomp',&
                  'allocating epsilon1_atrace', ABS(ierr) )

   epsilon1_atrace = epsilon1_atrace_intra + epsilon1_atrace_degen &
                                           + epsilon1_atrace_inter &
                                           + 1.0_dp

end subroutine epsilon1_atrace_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_dc_tensor

   call sigma2_w_dc_sub

   ! dielectric tensor ( real part )
   allocate( epsilon1_dc(1:3,1:3), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_dc_tensor',&
                   'allocating epsilon1_dc', ABS(ierr) )

   epsilon1_dc(1:3,1:3) = -4.0_dp * pi * sigma2_w_dc( 1:3, 1:3) 

   do ix = 1, 3
      epsilon1_dc(ix,ix) = 1.0_dp + epsilon1_dc(ix,ix)
   enddo

   ! trace
   
   epsilon1_dc_atrace = & 
                1.0_dp - 4.0_dp * pi * sigma2_w_dc_atrace
 
end subroutine epsilon1_dc_tensor

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_dc_atrace_sub

   call sigma2_w_dc_atrace_sub
 
   epsilon1_dc_atrace = 1.0_dp - 4.0_dp * pi * sigma2_w_dc_atrace

end subroutine epsilon1_dc_atrace_sub

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_dc_atrace_decomp()

   call sigma2_w_dc_atrace_decomp

  ! dielectric tensor ( real part ) intra-band contribution

   epsilon1_dc_atrace_intra = - 4.0d0*pi*sigma2_w_dc_atrace_intra   

   ! dielectric tensor ( real part ) degeneracies contribution

   epsilon1_dc_atrace_degen = - 4.0d0*pi*sigma2_w_dc_atrace_degen

   ! dielectric tensor ( real part ) inter-band contribution

   epsilon1_dc_atrace_inter = &
                            - 4.0d0 * pi * sigma2_w_dc_atrace_inter

   ! Total traces

   epsilon1_dc_atrace = epsilon1_dc_atrace_intra + epsilon1_dc_atrace_degen &
                                           + epsilon1_dc_atrace_inter &
                                           + 1.0_dp


end subroutine epsilon1_dc_atrace_decomp

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine epsilon1_dc_tensor_decomp

   call sigma2_w_dc_decomp

   ! dielectric tensor ( real part ) intra-band contribution
   allocate( epsilon1_dc_intra(1:3,1:3), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_dc_tensor_decomp',&
                  'allocating epsilon1_dc_intra', ABS(ierr) )

   epsilon1_dc_intra(1:3,1:3) = &
              -4.0d0 * pi * sigma2_w_dc_intra( 1:3, 1:3)


   do ix = 1, 3
      epsilon1_dc_intra(ix,ix) = 1.0_dp + epsilon1_dc_intra(ix,ix)
   enddo

   ! Trace

   epsilon1_dc_atrace_intra = 1.0_dp - 4.0_dp * pi * sigma2_w_dc_atrace_intra  

   ! dielectric tensor ( real part ) degeneracies contribution

   allocate( epsilon1_dc_degen(1:3,1:3), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_dc_tensor_decomp',&
                  'allocating epsilon1_dc_degen', ABS(ierr) )

   epsilon1_dc_degen(1:3,1:3) = &
              -4.0d0 * pi * sigma2_w_dc_degen( 1:3, 1:3)

   do ix = 1, 3
      epsilon1_dc_degen(ix,ix) = 1.0_dp + epsilon1_dc_degen(ix,ix)
   enddo

   ! Trace

   epsilon1_dc_atrace_degen = & 
          1.0_dp - 4.0_dp * pi * sigma2_w_dc_atrace_degen


   ! dielectric tensor ( real part ) inter-band contribution

   allocate( epsilon1_dc_inter(1:3,1:3), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_dc_tensor_decomp',&
                  'allocating epsilon1_dc_inter', ABS(ierr) )

   epsilon1_dc_inter(1:3,1:3) = &
              -4.0d0 * pi * sigma2_w_dc_inter( 1:3, 1:3 )

   do ix = 1, 3
      epsilon1_dc_inter(ix,ix) = 1.0_dp + epsilon1_dc_inter(ix,ix)
   enddo

   ! Trace

   epsilon1_dc_atrace_inter = & 
         1.0_dp - 4.0_dp * pi * sigma2_w_dc_atrace_inter  


   allocate( epsilon1_dc(1:3,1:3), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon:epsilon_dc_tensor_decomp',&
                  'allocating epsilon1_dc', ABS(ierr) )

   epsilon1_dc = epsilon1_dc_intra + epsilon1_dc_degen + epsilon1_dc_inter

   epsilon1_dc_atrace = epsilon1_dc_atrace_intra + epsilon1_dc_atrace_degen & 
                                           + epsilon1_dc_atrace_inter

 end subroutine epsilon1_dc_tensor_decomp
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
! Calculating sigma2 from sigma2/w
!

subroutine epsilon1_tensor_sub_sigma2

   allocate( sigma2(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_sub_sigma2',&
                  'allocating sigma2', ABS(ierr) )



   allocate( sigma2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_sub_sigma2',&
                  'allocating sigma2_atrace', ABS(ierr) )

   do iw=1,nw
      sigma2(:,:,iw)    = wgrid(iw) * sigma2_w(:,:,iw)
      sigma2_atrace(iw) = wgrid(iw) * sigma2_w_atrace(iw)
   enddo

end subroutine epsilon1_tensor_sub_sigma2

subroutine epsilon1_tensor_decomp_sigma2

   allocate( sigma2_intra(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_intra', ABS(ierr) )

   allocate( sigma2_degen(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_degen', ABS(ierr) )

   allocate( sigma2_inter(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_inter', ABS(ierr) )

   allocate( sigma2(1:3,1:3,0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2', ABS(ierr) )

   allocate( sigma2_atrace_intra(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_atrace_intra', ABS(ierr) )

   allocate( sigma2_atrace_degen(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_atrace_degen', ABS(ierr) )

   allocate( sigma2_atrace_inter(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_atrace_inter', ABS(ierr) )

   allocate( sigma2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_tensor_decomp_sigma2',&
                  'allocating sigma2_atrace', ABS(ierr) )


   do iw=1,nw
      sigma2_intra(:,:,iw)        = wgrid(iw) * sigma2_w_intra(:,:,iw)
      sigma2_degen(:,:,iw)        = wgrid(iw) * sigma2_w_degen(:,:,iw)
      sigma2_inter(:,:,iw)        = wgrid(iw) * sigma2_w_inter(:,:,iw)
      sigma2(:,:,iw)              = wgrid(iw) * sigma2_w(:,:,iw)
      sigma2_atrace_intra(iw) = wgrid(iw) * sigma2_w_atrace_intra(iw)
      sigma2_atrace_degen(iw) = wgrid(iw) * sigma2_w_atrace_degen(iw)
      sigma2_atrace_inter(iw) = wgrid(iw) * sigma2_w_atrace_inter(iw)
      sigma2_atrace(iw)       = wgrid(iw) * sigma2_w_atrace(iw)
   enddo

end subroutine epsilon1_tensor_decomp_sigma2

subroutine epsilon1_atrace_sub_sigma2

   allocate( sigma2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_atrace_sub_sigma2',&
                  'allocating sigma2_atrace', ABS(ierr) )

   do iw=1,nw
      sigma2_atrace(iw)       = wgrid(iw) * sigma2_w_atrace(iw)
   enddo

end subroutine epsilon1_atrace_sub_sigma2

subroutine epsilon1_atrace_decomp_sigma2

   allocate( sigma2_atrace_intra(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_atrace_decomp_sigma2',&
                  'allocating sigma2_atrace_intra', ABS(ierr) )

   allocate( sigma2_atrace_degen(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_atrace_decomp_sigma2',&
                  'allocating sigma2_atrace_degen', ABS(ierr) )

   allocate( sigma2_atrace_inter(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_atrace_decomp_sigma2',&
                  'allocating sigma2_atrace_inter', ABS(ierr) )

   allocate( sigma2_atrace(0:nw), STAT=ierr )
   if (ierr/=0) &
      CALL errore('kgepsilon1:epsilon1_atrace_decomp_sigma2',&
                  'allocating sigma2_atrace', ABS(ierr) )


   do iw=1,nw
      sigma2_atrace_intra(iw) = wgrid(iw) * sigma2_w_atrace_intra(iw)
      sigma2_atrace_degen(iw) = wgrid(iw) * sigma2_w_atrace_degen(iw)
      sigma2_atrace_inter(iw) = wgrid(iw) * sigma2_w_atrace_inter(iw)
      sigma2_atrace(iw)       = wgrid(iw) * sigma2_w_atrace(iw)
   enddo

end subroutine epsilon1_atrace_decomp_sigma2

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

end module kgepsilon1

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgsigma1
! Kubo-Greenwood conductivity \sigma_1

use kinds, ONLY    : DP
use qevars
use kgecvars, ONLY : deltarep, deltawidth, nw, wmin, wmax, wgrid, dw, sa, sg, &
                     psi_grad_psi, iaux, de, sigma1_notintra, AU_TO_OHMM_INV, &
                     nbnds_local, nbnds_per_process, nbnds_per_group,         &
                     my_rank, my_rank_old, my_group, dc

implicit none

   ! Internal units : atomic Ha
   ! Note on multipliying by the prefactor 2 Pi/ omega for sigma1 in a.u.
   ! - The 2 went into the wg (the combined fermi-dirac and k-weighting factor)
   ! The Pi cancels the Pi in the normalization of the Lorentzian, and its taken
   ! care of also for the Gaussian
   
   ! Gradient matrix elements must be supplied as input
   ! real(DP), allocatable    :: psi_grad_psi(:,:,:,:)

   private

   ! \sigma_1 and its decomposition in intra-bands, degeneracies and 
   ! inter-bands contributions
   real(DP), allocatable, public :: sigma1(:,:,:)       
   real(DP), allocatable, public :: sigma1_intra(:,:,:)  
   real(DP), allocatable, public :: sigma1_degen(:,:,:)  
   real(DP), allocatable, public :: sigma1_inter(:,:,:) 

   ! Average traces
   real(DP), allocatable, public :: sigma1_atrace(:)    
   real(DP), allocatable, public :: sigma1_atrace_intra(:)     
   real(DP), allocatable, public :: sigma1_atrace_degen(:)     
   real(DP), allocatable, public :: sigma1_atrace_inter(:)     

   ! DC components
   real(DP), public :: sigma1_dc(1:3,1:3)
   real(DP), public :: sigma1_dc_intra(1:3,1:3)    
   real(DP), public :: sigma1_dc_degen(1:3,1:3)    
   real(DP), public :: sigma1_dc_inter(1:3,1:3)    

   real(DP), public :: sigma1_dc_atrace            ! - DC average trace  
   real(DP), public :: sigma1_dc_atrace_intra      
   real(DP), public :: sigma1_dc_atrace_degen
   real(DP), public :: sigma1_dc_atrace_inter


   public :: frequency_grid,                          &   
             check_delta_sub,                         &
             !  
             ! TENSORS
             ! 
             sigma1_approx_1lorentzian,               &
             sigma1_approx_2lorentzian,               &
             sigma1_approx_2lorentzian_DC,            &
             ! 
             sigma1_approx_1gaussian,                 &
             sigma1_approx_2gaussian,                 &
             sigma1_approx_2gaussian_DC,              &
             !
             sigma1_exact_1lorentzian,                &
             sigma1_exact_2lorentzian,                & 
             sigma1_exact_lorentzian_DC,              &
             !
             sigma1_exact_1gaussian,                  &
             sigma1_exact_2gaussian,                  &
             sigma1_exact_gaussian_DC,                &
             !
             sigma1_exact_decomp_1lorentzian,         &
             sigma1_exact_decomp_2lorentzian,         &
             sigma1_exact_decomp_lorentzian_DC,       &
             !
             sigma1_exact_decomp_1gaussian,           &
             sigma1_exact_decomp_2gaussian,           &
             sigma1_exact_decomp_gaussian_DC,         &
             ! 
             ! TRACES
             ! 
             sigma1_atrace_exact_1lorentzian,         &
             sigma1_atrace_exact_2lorentzian,         &
             sigma1_atrace_exact_lorentzian_DC,       &
             !
             sigma1_atrace_exact_1gaussian,           &
             sigma1_atrace_exact_2gaussian,           &
             sigma1_atrace_exact_gaussian_DC,         &
             !
             sigma1_atrace_exact_decomp_1lorentzian,  &
             sigma1_atrace_exact_decomp_2lorentzian,  &
             sigma1_atrace_exact_decomp_lorentzian_DC, &
             !
             sigma1_atrace_exact_decomp_1gaussian,    &
             sigma1_atrace_exact_decomp_2gaussian,    &
             sigma1_atrace_exact_decomp_gaussian_DC,  &
             !
             sigma1_atrace_approx_1lorentzian,        &
             sigma1_atrace_approx_2lorentzian,        &
             sigma1_atrace_approx_2lorentzian_DC,     &
             !
             sigma1_atrace_approx_1gaussian,          &
             sigma1_atrace_approx_2gaussian,          &
             sigma1_atrace_approx_2gaussian_DC !,       &
             !  
!             sigma1_dc_all_deltarep


   ! private variables
   integer :: iw                          ! Frequency index
   integer :: ik, ib1, ib2, ibb1          ! counters on k-points and bands
   integer :: ig                          ! counter on plane waves
   integer :: ix1, ix2                    ! labels x, y an z

   real(DP) :: focc, dfde

   real(DP) :: aux, aux2, ee, eem, eep
   real(DP) :: psi_grad_psi_aux(3), maux(3,3)

   integer  :: ios , ierr ! Input and memory allocation error status variables


   contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine frequency_grid()
   !
   ! Frequency grid
   ! Input units: eV    Output Units: Ha

      if ( nw == 0 ) then
         dw = 0.0_DP
      else
         dw   = ( wmax - wmin ) / dble(nw)  ! Frecuency step
      endif

      allocate( wgrid(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating wgrid', abs(ierr))
      
      ! Frequency grid in eV
      do iw = 0, nw
         wgrid(iw) = wmin + iw * dw
      enddo


      write(stdout,*) '    Frequency grid:'
      write(stdout,*) "       Frequency step (eV)       :", dw
      write(stdout,*) "       Frequency steps           :", nw
      write(stdout,'(a, f10.4,a,f10.4 )') &
                 "        Frequency range (eV)      :", wgrid(0),  ' to ',wgrid(nw)

     ! Change units from eV to Ha
     wgrid = wgrid / AUTOEV
     dw    = dw    / AUTOEV

   end subroutine frequency_grid

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine check_delta_sub()
   ! 
   ! Calculations to compare lorentzians and gaussians as delta-function repr.
   ! 
   
   real(DP) :: lp, gp, gae
   real(DP) :: loren1, loren1a, loren2, loren3, gauss1a, gauss1, gauss2, gauss3



      ! 
      ! Calculations to compare lorentzians and gaussians as delta-function repr.
      ! 
      ! (using Lorentzian and Gaussians with the same width )

      sa  = 0.5_dp * deltawidth / AUTOEV       ! Lorentzian half-width in Ha :
                                               !  sa/2 / ( x^2 + sa^2/4 ) / pi

      lp  = sa / pi                            ! Lorentzian prefactor  
      

      gae =  deltawidth / AUTOEV               ! Gaussian exponent (inverse)
                                               ! exp(- x^2/gae^2 ) / gae sqrt(pi)  

      gp  = 1.0_dp / ( gae * sqrt(pi) )        ! Gaussian prefactor 

      gae = 1.0_dp / ( gae * gae )             ! Inverse of the exponent squared             


      IF(IONODE) THEN
      open(121,file='delta-lor-vs-gau-same-width.dat', action='write')

      do iw = 1, nw
         ee = wgrid(iw)
         write(121,*) wgrid(iw)*AUTOEV, &
              lp / (ee*ee + sa*sa) * AU_TO_OHMM_INV, &
              dexp(-gae*ee*ee)*gp  * AU_TO_OHMM_INV 
         enddo
         close(121)

         open(121,file='sigma1-atrace-lor-vs-gau-same-width.dat', action='write')
         write(121,'(A,f10.6,A)'     ) &
         '#      lorentzian deltawidth=', deltawidth, 'eV'
         write(121,'(A,f10.6,A)'     ) &
         '#      gaussian   deltawidth=', deltawidth, 'eV'
         write(121,'(A)'             ) &
         '#      hbar omega in eV, conductivities in 1/(ohm m)'
         write(121,'(A)'             ) &
         '#      hbar omega           Exact 1 Lor &
         &       Exact 2 Lor          Appr 1 Lor          Appr 2 Lor &
         Exact 1 Gau          Exact 2 Gau         Appr 1 Gau          Exact 2 Gau'
  

      ENDIF ! inode

      do iw = 1, nw

         loren1 = 0.0_DP
         loren1a = 0.0_DP
         loren2 = 0.0_DP
         loren3 = 0.0_DP
         gauss1 = 0.0_DP
         gauss1a = 0.0_DP
         gauss2 = 0.0_DP
         gauss3 = 0.0_DP

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if( sigma1_notintra .and. ib2 == ib1 ) cycle

                  aux = 0.0_DP
                  do ix1 = 1, 3
                     aux = aux + real( conjg( psi_grad_psi(ix1,ib2,ibb1,ik) ) &
                                 * psi_grad_psi(ix1,ib2,ibb1,ik) )
                  enddo

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     if ( sigma1_notintra ) cycle
                     focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
                  else
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee
                  endif

                  ! Conductivity, exact formula with a Lorentzian
                  loren1  = loren1 + aux * dfde /( eem*eem + sa*sa )
                  
                  ! Conductivity, exact formula with two Lorentzian
                  loren1a = loren1a &
                           + aux * dfde  &
                              * (   1.0_dp / (eem*eem + sa*sa)       &
                                  + 1.0_dp / (eep*eep + sa*sa) )

                  ! Conductivity, approx formula with a Lorentzian
                  loren2 = loren2 + aux*( wg(ib2,ik) - wg(ib1,ik) ) &
                                                /( eem*eem + sa*sa )/(wgrid(iw))

                  ! Conductivity, approx formula with sum of two Lorentzian
                  loren3 = loren3 &
                           + aux*( wg(ib2,ik) - wg(ib1,ik) ) * 4.0_DP &
                            * ee / ( ( eem*eem + sa*sa ) * ( eep*eep + sa*sa ) )


                  ! Conductivity, exact formula with a Gaussian
                  gauss1  = gauss1  + aux * dfde * exp(-eem*eem*gae)

                  ! Conductivity, exact formula with sum of two Gaussians
                  gauss1a = gauss1a + aux * dfde &
                                      * ( exp(-eem*eem*gae) + exp(-eep*eep*gae) )


                  ! Conductivity, approx formula with a Gaussian
                  gauss2 = gauss2 + aux*( wg(ib2,ik) - wg(ib1,ik) ) &
                                        /(wgrid(iw)) * ( exp(-eem*eem*gae) )

                  ! Conductivity, approx formula with sum of two Gaussian
                  gauss3 = gauss3 &
                           + aux*( wg(ib2,ik) - wg(ib1,ik) ) /(wgrid(iw)) &
                              * ( exp(-eem*eem*gae)-exp(-eep*eep*gae) )
  
                 enddo ! ib2
            enddo    ! ib1

         enddo ! ik

         call mp_sum( loren1,  inter_bgrp_comm ) ! reduce over bands (nbnd)
         call mp_sum( loren1a, inter_bgrp_comm )
         call mp_sum( loren2,  inter_bgrp_comm )
         call mp_sum( loren3,  inter_bgrp_comm )
         call mp_sum( gauss1,  inter_bgrp_comm )
         call mp_sum( gauss1a, inter_bgrp_comm )
         call mp_sum( gauss2,  inter_bgrp_comm )
         call mp_sum( gauss3,  inter_bgrp_comm )

         call mp_sum( loren1,  inter_pool_comm ) ! reduce over k (nks)
         call mp_sum( loren1a, inter_pool_comm )
         call mp_sum( loren2,  inter_pool_comm )
         call mp_sum( loren3,  inter_pool_comm )
         call mp_sum( gauss1,  inter_pool_comm )
         call mp_sum( gauss1a, inter_pool_comm )
         call mp_sum( gauss2,  inter_pool_comm )
         call mp_sum( gauss3,  inter_pool_comm )

         loren1  = pi * lp * loren1 /omega/3.0_DP * AU_TO_OHMM_INV
         loren1a = pi * lp * loren1a/omega/6.0_DP * AU_TO_OHMM_INV
         loren2  = pi * lp * loren2 /omega/3.0_DP * AU_TO_OHMM_INV
         loren3  = pi * lp * loren3 /omega/6.0_DP * AU_TO_OHMM_INV

         gauss1  = pi * gp * gauss1 /omega/3.0_DP * AU_TO_OHMM_INV
         gauss1a = pi * gp * gauss1a/omega/6.0_DP * AU_TO_OHMM_INV
         gauss2  = pi * gp * gauss2 /omega/3.0_DP * AU_TO_OHMM_INV
         gauss3  = pi * gp * gauss3 /omega/6.0_DP * AU_TO_OHMM_INV

         IF(IONODE) THEN
            write(121,'(1p,9es20.7e3)') wgrid(iw)*AUTOEV, &
                                        loren1, loren1a, loren2, loren3, &
                                        gauss1, gauss1a, gauss2, gauss3
         ENDIF ! ionode

      enddo ! iw

      IF(IONODE) THEN
        close(121)
      ENDIF ! ionode

      ! 
      ! Calculations to compare lorentzians and gaussians as delta-function repr.
      ! 
      ! (using Lorentzian and Gaussians of the same FWHM )

      sa  = 0.5_dp * deltawidth / AUTOEV       ! Lorentzian half-width in Ha :
                                               !  sa/2 / ( x^2 + sa^2/4 ) / pi

      lp  = sa / pi                            ! Lorentzian prefactor  
      
      gae  = 0.5_dp * deltawidth  &            ! Gaussian exponent to get the same
            /( AUTOEV * sqrt(log(2.0_dp)) )    ! FWHM as the Lorentzian
 
      gp  = 1.0_dp / ( gae * sqrt(pi) )        ! Gaussian prefactor
      
      gae = 1.0_dp / (gae*gae)            


      IF(IONODE) THEN
      open(121,file='delta-lor-vs-gau.dat', action='write')

      do iw = 1, nw
         ee = wgrid(iw)
         write(121,*) wgrid(iw)*AUTOEV, &
              lp / (ee*ee + sa*sa) * AU_TO_OHMM_INV, &
              dexp(-gae*ee*ee)*gp  * AU_TO_OHMM_INV
         enddo
         close(121)

         open(121,file='sigma1-atrace-lor-vs-gau-same-fwhm.dat', action='write')
         write(121,'(A,f10.6,A)'     ) '#      lorentzian deltawidth=', deltawidth, 'eV'
         write(121,'(A,f10.6,A)'     ) '#      gaussian   deltawidth=', sqrt(1.0_dp/gae)*AUTOEV, 'eV'
         write(121,'(A)'             ) '#      hbar omega in eV, conductivities in 1/(ohm m)'
         write(121,'(A)'             ) &
         '#      hbar omega           Exact 1 Lor &
         &       Exact 2 Lor          Appr 1 Lor          Appr 2 Lor&
         Exact 1 Gau          Exact 2 Gau         Appr 1 Gau          Exact 2 Gau'
      ENDIF ! inode

      do iw = 1, nw

         loren1  = 0.0_DP
         loren1a = 0.0_DP
         loren2  = 0.0_DP
         loren3  = 0.0_DP
         gauss1  = 0.0_DP
         gauss1a = 0.0_DP
         gauss2  = 0.0_DP
         gauss3  = 0.0_DP

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if( sigma1_notintra .and. ib2 == ib1 ) cycle

                  aux = 0.0_DP
                  do ix1 = 1, 3
                     aux = aux + real( conjg( psi_grad_psi(ix1,ib2,ibb1,ik) ) &
                                 * psi_grad_psi(ix1,ib2,ibb1,ik) )
                  enddo

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     if ( sigma1_notintra ) cycle
                     focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
                  else
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee
                  endif

                  ! Conductivity, exact formula with a Lorentzian
                  loren1  = loren1 + aux * dfde /( eem*eem + sa*sa )
                  
                  ! Conductivity, exact formula with two Lorentzian
                  loren1a = loren1a &
                           + aux * dfde  &
                              * (   1.0_dp / (eem*eem + sa*sa)       &
                                  + 1.0_dp / (eep*eep + sa*sa) )

                  ! Conductivity, approx formula with a Lorentzian
                  loren2 = loren2 + aux*( wg(ib2,ik) - wg(ib1,ik) ) &
                                                /( eem*eem + sa*sa )/(wgrid(iw))

                  ! Conductivity, approx formula with sum of two Lorentzian
                  loren3 = loren3 &
                           + aux*( wg(ib2,ik) - wg(ib1,ik) ) * 4.0_DP &
                            * ee / ( ( eem*eem + sa*sa ) * ( eep*eep + sa*sa ) )


                  ! Conductivity, exact formula with a Gaussian
                  gauss1  = gauss1  + aux * dfde * exp(-eem*eem*gae)

                  ! Conductivity, exact formula with sum of two Gaussians
                  gauss1a = gauss1a + aux * dfde &
                                      * ( exp(-eem*eem*gae) + exp(-eep*eep*gae) )


                  ! Conductivity, approx formula with a Gaussian
                  gauss2 = gauss2 + aux*( wg(ib2,ik) - wg(ib1,ik) ) &
                                        /(wgrid(iw)) * ( exp(-eem*eem*gae) )

                  ! Conductivity, approx formula with sum of two Gaussian
                  gauss3 = gauss3 &
                           + aux*( wg(ib2,ik) - wg(ib1,ik) ) /(wgrid(iw)) &
                              * ( exp(-eem*eem*gae)-exp(-eep*eep*gae) )
  
                 enddo ! ib2
            enddo    ! ib1

         enddo ! ik

         call mp_sum( loren1,  inter_bgrp_comm ) ! reduce over bands (nbnd)
         call mp_sum( loren1a, inter_bgrp_comm )
         call mp_sum( loren2,  inter_bgrp_comm )
         call mp_sum( loren3,  inter_bgrp_comm )
         call mp_sum( gauss1,  inter_bgrp_comm )
         call mp_sum( gauss1a, inter_bgrp_comm )
         call mp_sum( gauss2,  inter_bgrp_comm )
         call mp_sum( gauss3,  inter_bgrp_comm )

         call mp_sum( loren1,  inter_pool_comm ) ! reduce over k (nks)
         call mp_sum( loren1a, inter_pool_comm )
         call mp_sum( loren2,  inter_pool_comm )
         call mp_sum( loren3,  inter_pool_comm )
         call mp_sum( gauss1,  inter_pool_comm )
         call mp_sum( gauss1a, inter_pool_comm )
         call mp_sum( gauss2,  inter_pool_comm )
         call mp_sum( gauss3,  inter_pool_comm )

         loren1  = pi * lp * loren1 /omega/3.0_DP * AU_TO_OHMM_INV
         loren1a = pi * lp * loren1a/omega/6.0_DP * AU_TO_OHMM_INV
         loren2  = pi * lp * loren2 /omega/3.0_DP * AU_TO_OHMM_INV
         loren3  = pi * lp * loren3 /omega/6.0_DP * AU_TO_OHMM_INV

         gauss1  = pi * gp * gauss1 /omega/3.0_DP * AU_TO_OHMM_INV
         gauss1a = pi * gp * gauss1a/omega/6.0_DP * AU_TO_OHMM_INV
         gauss2  = pi * gp * gauss2 /omega/3.0_DP * AU_TO_OHMM_INV
         gauss3  = pi * gp * gauss3 /omega/6.0_DP * AU_TO_OHMM_INV

         IF(IONODE) THEN
            write(121,'(1p,9es20.7e3)') wgrid(iw)*AUTOEV, &
                                        loren1, loren1a, loren2, loren3, &
                                        gauss1, gauss1a, gauss2, gauss3
         ENDIF ! ionode

      enddo ! iw

      IF(IONODE) THEN
        close(121)
      ENDIF ! ionode

      ! 
      ! Calculations to compare lorentzians and gaussians as delta-function repr.
      ! 
      ! (using Lorentzian and Gaussians of the same heights )
   
      sa  = 0.5_dp * deltawidth / AUTOEV       ! Lorentzian half-width in Ha :
                                               !  sa/2 / ( x^2 + sa^2/4 ) / pi

      lp  = sa / pi                            ! Lorentzian prefactor  
      
      gae  = 0.5_dp * deltawidth &             ! Gaussian exponent to get the same
            / (AUTOEV * sqrt(pi))              ! height as the Lorentzian

      gp  = 1.0_dp / ( gae * sqrt(pi) )        ! Gaussian prefactor

      gae = 1.0_dp / (gae*gae)


      IF(IONODE) THEN
         open(121,file='delta-lor-vs-gau-same-height.dat', action='write')
         do iw = 1, nw
            ee = wgrid(iw)
            write(121,*) wgrid(iw)*AUTOEV, &
              lp / (ee*ee + sa*sa) * AU_TO_OHMM_INV , &
              dexp(-gae*ee*ee)*gp  * AU_TO_OHMM_INV 
         enddo
         close(121)
      ENDIF



      IF(IONODE) THEN
         open(121,file='sigma1-atrace-lor-vs-gau-same-height.dat', action='write')
         write(121,'(A,f10.6,A)'     ) '#      lorentzian deltawidth=', deltawidth, 'eV'
         write(121,'(A,f10.6,A)'     ) '#      gaussian   deltawidth=', sqrt(1.0_dp/gae)*AUTOEV, 'eV'
         write(121,'(A)'             ) '#      hbar omega in eV, conductivities in 1/(ohm m)'
         write(121,'(A)'             ) '#      hbar omega           Exact 1 Lor &
         &       Exact 2 Lor          Appr 1 Lor          Appr 2 Lor&
         &         Exact 1 Gau          Exact 2 Gau         Appr 1 Gau          Exact 2 Gau'
      ENDIF ! inode

      do iw = 1, nw

         loren1     = 0.0_DP
         loren1a   = 0.0_DP
         loren2     = 0.0_DP
         loren3     = 0.0_DP
         gauss1   = 0.0_DP
         gauss1a = 0.0_DP
         gauss2   = 0.0_DP
         gauss3   = 0.0_DP

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if( sigma1_notintra .and. ib2 == ib1 ) cycle

                  aux = 0.0_DP
                  do ix1 = 1, 3
                     aux = aux + real( conjg( psi_grad_psi(ix1,ib2,ibb1,ik) ) &
                                 * psi_grad_psi(ix1,ib2,ibb1,ik) )
                  enddo

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     if ( sigma1_notintra ) cycle
                     focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
                  else
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee
                  endif  

                  ! Conductivity, exact formula with a Lorentzian
                  loren1  = loren1 + aux * dfde /( eem*eem + sa*sa )
                  
                  ! Conductivity, exact formula with two Lorentzian
                  loren1a = loren1a &
                           + aux * dfde  &
                              * (   1.0_dp / (eem*eem + sa*sa)       &
                                  + 1.0_dp / (eep*eep + sa*sa) )

                  ! Conductivity, approx formula with a Lorentzian
                  loren2 = loren2 + aux*( wg(ib2,ik) - wg(ib1,ik) ) &
                                                /( eem*eem + sa*sa )/(wgrid(iw))

                  ! Conductivity, approx formula with sum of two Lorentzian
                  loren3 = loren3 &
                           + aux*( wg(ib2,ik) - wg(ib1,ik) ) * 4.0_DP &
                            * ee / ( ( eem*eem + sa*sa ) * ( eep*eep + sa*sa ) )


                  ! Conductivity, exact formula with a Gaussian
                  gauss1  = gauss1  + aux * dfde * exp(-eem*eem*gae)


                  ! Conductivity, exact formula with sum of twho Gaussians
                  gauss1a = gauss1a + aux * dfde &
                                      * ( exp(-eem*eem*gae) + exp(-eep*eep*gae) )

                  ! Conductivity, approx formula with a Gaussian
                  gauss2 = gauss2 + aux*( wg(ib2,ik) - wg(ib1,ik) ) &
                                        /(wgrid(iw)) * ( exp(-eem*eem*gae) )

                  ! Conductivity, approx formula with sum of two Gaussian
                  gauss3 = gauss3 &
                           + aux*( wg(ib2,ik) - wg(ib1,ik) ) /(wgrid(iw)) &
                              * ( exp(-eem*eem*gae)-exp(-eep*eep*gae) )
  
                 enddo ! ib2
            enddo    ! ib1

         enddo ! ik

         call mp_sum( loren1,  inter_bgrp_comm ) ! reduce over bands (nbnd)
         call mp_sum( loren1a, inter_bgrp_comm )
         call mp_sum( loren2,  inter_bgrp_comm )
         call mp_sum( loren3,  inter_bgrp_comm )
         call mp_sum( gauss1,  inter_bgrp_comm )
         call mp_sum( gauss1a, inter_bgrp_comm )
         call mp_sum( gauss2,  inter_bgrp_comm )
         call mp_sum( gauss3,  inter_bgrp_comm )

         call mp_sum( loren1,  inter_pool_comm ) ! reduce over k (nks)
         call mp_sum( loren1a, inter_pool_comm )
         call mp_sum( loren2,  inter_pool_comm )
         call mp_sum( loren3,  inter_pool_comm )
         call mp_sum( gauss1,  inter_pool_comm )
         call mp_sum( gauss1a, inter_pool_comm )
         call mp_sum( gauss2,  inter_pool_comm )
         call mp_sum( gauss3,  inter_pool_comm )

         loren1  = pi * lp * loren1 /omega/3.0_DP * AU_TO_OHMM_INV
         loren1a = pi * lp * loren1a/omega/6.0_DP * AU_TO_OHMM_INV
         loren2  = pi * lp * loren2 /omega/3.0_DP * AU_TO_OHMM_INV
         loren3  = pi * lp * loren3 /omega/6.0_DP * AU_TO_OHMM_INV

         gauss1  = pi * gp * gauss1 /omega/3.0_DP * AU_TO_OHMM_INV
         gauss1a = pi * gp * gauss1a/omega/6.0_DP * AU_TO_OHMM_INV
         gauss2  = pi * gp * gauss2 /omega/3.0_DP * AU_TO_OHMM_INV
         gauss3  = pi * gp * gauss3 /omega/6.0_DP * AU_TO_OHMM_INV

         IF(IONODE) THEN
            write(121,'(1p,9es20.7e3)') wgrid(iw)*AUTOEV, &
                                        loren1, loren1a, loren2, loren3, &
                                        gauss1, gauss1a, gauss2, gauss3
         ENDIF ! ionode

     enddo ! iw

     IF(IONODE) THEN
        close(121)
     ENDIF ! ionode

   end subroutine check_delta_sub ! check delta function representation

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   !===========================================================================
   !               Full Conductivity tensor (\sigma_1)
   !===========================================================================
   !
   ! Two choices for the \sigma_1 formula: 
   ! 1) With the 1/w factor          (approximated formula)
   ! 2) With the 1/(e_n-e_n') factor (exact formula)
   !


   !----------------------------------------------------------------------------
   subroutine sigma1_approx_1lorentzian

      ! Lorentzian delta function
      ! (sa / Pi) / ( (ei - ej - omega)^2 + sa^2 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      ! So we only have sa as prefactor

      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )


      ! Avoid division by zero
      iw   = 0
      iaux = 0
      do while ( wgrid(iw) < 1.0D-12 )
         iw = iw + 1      
      enddo 
      iaux = iw

      if ( iaux /= 0 ) then
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Conductivity for zero frequency can not" 
         write(stdout,*) "    be calculated using the KG approximated formula"
         write(stdout,*) "    with one Lorentzian representing the Dirac delta"
         write(stdout,*) "    function." 
         write(stdout,*) "      Calculation will start at", wgrid(iaux)," Ha." 
         !write(stdout,*) "    ================================================"

         if ( dc ) then

            write(stdout,*) ""
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    dc is set to TRUE, hence the DC component will be"
            write(stdout,*) "    calculated using the analytical limit for the "
            write(stdout,*) "    approximated formula and two Lorentzians."
            write(stdout,*) "    ================================================"

         else

            write(stdout,*) ""    
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    Set dc=.true. to calculate the DC component with"
            write(stdout,*) "    the analytical limit of the approximated formula"
            write(stdout,*) "    with two Lorenziants."
            write(stdout,*) "    ================================================"

         endif

      endif

      do iw = iaux, nw
         maux(1:3,1:3) = 0.0_DP

         do ix1 = 1, 3
         do ix2 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1  = ibb1 + nbnds_per_process * my_rank_old &
                              + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha

                  maux(ix2,ix1) = maux(ix2,ix1)                                 &
                                  + ( wg(ib2,ik) - wg(ib1,ik) )                 &
                                    * real(conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                           *     psi_grad_psi(ix2,ib2,ibb1,ik)) &   
                                              /   ( eem*eem + sa*sa )         

               enddo ! ib2
               enddo    ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)
         
         sigma1(1:3,1:3,iw) = sa * maux(1:3,1:3) / ( omega * wgrid(iw) )

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_approx_1lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_approx_2lorentzian

      ! Lorentzian delta function
      ! (sa / Pi) / ( (ei - ej - omega)^2 + sa^2 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      ! So up to here we only have sa as prefactor

      ! Use s(w) = ( s(w)+s(-w) ) / 2 to get
      ! ( 1/( (e-w)^2 + sa^2 ) - 1/( (e+w)^2 + sa^2 ) ) / w =
      ! 4 * e / ( ((e-w)^2 + sa^2)* ((e+w)^2 + sa^2 ) ), which changes
      ! the prefactor to 2 sa
      ! but summing over ib1 and ib2=ib1+1 we have 4 sa as the final
      ! prefactor
 
      sa   = 0.5_dp * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux  = 4.0_DP * sa
      
      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )

      do iw = 0, nw
         maux(1:3,1:3) = 0.0_DP

         do ix1 = 1, 3
         do ix2 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1  = ibb1 + nbnds_per_process * my_rank_old &
                              + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + ( wg(ib2,ik) - wg(ib1,ik) )                &
                                    * real(conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                           *     psi_grad_psi(ix2,ib2,ibb1,ik)) &   
                                        * ee / (   ( eem*eem + sa*sa )         &
                                                 * ( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo    ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)
         
         sigma1(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_approx_2lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_approx_2lorentzian_DC

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa  = 0.5_DP * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux = 2.0_DP * sa                  ! Prefactor from lim w->0
   
      aux = 2.0_DP * aux                 ! Twice the sum ib1, ib2=ib1+1  
      
      
      maux(1:3,1:3) = 0.0_DP

      do ix1 = 1, 3
         do ix2 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1  = ibb1 + nbnds_per_process * my_rank_old &
                              + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + ( wg(ib2,ik) - wg(ib1,ik) )                &
                                    * real(conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                           *     psi_grad_psi(ix2,ib2,ibb1,ik)) &   
                                        * ee / (   ( ee*ee + sa*sa )         &
                                                 * ( ee*ee + sa*sa ) )

               enddo ! ib2
               enddo    ! ib1

            enddo ! ik

         enddo ! ix2
      enddo ! ix1

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)
         
      sigma1_dc(1:3,1:3) = aux * maux(1:3,1:3) / omega
      sigma1_dc_atrace   = (   sigma1_dc(1,1) &
                             + sigma1_dc(2,2) &
                             + sigma1_dc(3,3) )/3.0_dp

   end subroutine sigma1_approx_2lorentzian_DC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_approx_1gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg             ! pi * 1/ (sg * sqrt(pi) ) 
                                        ! The pi comes form KG formula
                                        ! The 2 in KG goes into the wg 
                                        ! factors

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )
                                        ! The 1/2 comes from (s(w)+s(-w))/2
      ! Avoid division by zero
      iw   = 0
      iaux = 0
      do while ( wgrid(iw) < 1.0D-12 )
         iw = iw + 1      
      enddo 
      iaux = iw

      if ( iaux /= 0 ) then
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Conductivity for zero frequency can not" 
         write(stdout,*) "    be calculated using the KG approximated formula"
         write(stdout,*) "    with one Gaussian representing the Dirac delta"
         write(stdout,*) "    function." 
         write(stdout,*) "      Calculation will start at", wgrid(iaux)," Ha." 
         !write(stdout,*) "    ================================================"

         if ( dc ) then

            write(stdout,*) ""
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    dc is set to TRUE, hence the DC component will be"
            write(stdout,*) "    calculated using the analytical limit for the "
            write(stdout,*) "    approximated formula and two Gaussians."
            write(stdout,*) "    ================================================"

         else

            write(stdout,*) ""    
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    Set dc=.true. to calculate the DC component with"
            write(stdout,*) "    the analytical limit of the approximated formula"
            write(stdout,*) "    with two Gaussians."
            write(stdout,*) "    ================================================"

         endif

      endif

      do iw = iaux, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd
                   
                  if ( ib2 == ib1 ) cycle
                   
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha

                  maux(ix2, ix1) = maux(ix2,ix1)                               &
                              +  ( wg(ib2,ik) - wg(ib1,ik) )/wgrid(iw)         &
                                * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))   &
                                        * psi_grad_psi(ix2,ib2,ibb1,ik)      ) &
                                          * exp(-eem*eem/(sg*sg))

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_approx_1gaussian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_approx_2gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      !aux  =  0.5_dp * sqrt(pi) / sg   ! pi * 1/2 * 1/ (sg * sqrt(pi) ) 
                                        ! The 1/2 comes from (s(w)+s(-w))/2
                                        ! The pi comes form KG formula
                                        ! The 2 in KG goes into the wg             
                                        ! factors                                        
      aux  =  sqrt(pi) / sg             ! Factor of two to account for 
                                        ! adding ib1, ib2=ib1+1
                                     

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )
                                        ! The 1/2 comes from (s(w)+s(-w))/2
      ! Avoid division by zero
      iw   = 0
      iaux = 0
      do while ( wgrid(iw) < 1.0D-12 )
         iw = iw + 1      
      enddo 
      iaux = iw

      if ( iaux /= 0 ) then
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Conductivity for zero frequency can not" 
         write(stdout,*) "    be calculated using the KG approximated formula"
         write(stdout,*) "    without taking proper analytical limits."
         write(stdout,*) "    Calculation will start at", wgrid(iaux)," Ha." 
         write(stdout,*) "    ================================================"
      endif

      if ( dc ) then

         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    dc is set to TRUE, hence the DC component with"
         write(stdout,*) "    the choosen formula and Dirac delta function"
         write(stdout,*) "    representation will be calculated and reported"
         write(stdout,*) "    in this output." 
         write(stdout,*) "    ================================================"

      else
    
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Set dc=.true. to calculate the DC component with"
         write(stdout,*) "    the choosen formula and Dirac delta function"
         write(stdout,*) "    representation. " 
         write(stdout,*) "    ================================================"

      endif

      do iw = iaux, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd
               
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  maux(ix2, ix1) = maux(ix2,ix1)                                &
                              +  ( wg(ib2,ik) - wg(ib1,ik) )                    &
                                * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))    &
                                        * psi_grad_psi(ix2,ib2,ibb1,ik)       ) &
                            * ( exp(-eem*eem/(sg*sg)) - exp(-eep*eep/(sg*sg)) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1(1:3,1:3,iw) = aux * maux(1:3,1:3) / ( omega * wgrid(iw) )

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_approx_2gaussian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_approx_2gaussian_DC

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV         ! Gaussian width in Ha
      aux  =  2.0_dp * sqrt(pi) &         ! pi * 1/2 *( 1/ (sg * sqrt(pi) ) ) 
              / (sg*sg*sg)                ! 4 / sg^2
                                          ! The 1/2 comes from (s(w)+s(-w))/2
                                          ! The pi comes form KG formula
                                          ! The 2 in KG goes into the wg 
                                          ! factors                                        
                                          ! The 4/sg^2 comes from w->0 limit
      aux = 2.0_DP * aux                  ! Factor of two to account for the
                                          ! sum ib1,ib2=ib1+1
                                          

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd
               
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  maux(ix2, ix1) = maux(ix2,ix1)                                &
                              +  ( wg(ib2,ik) - wg(ib1,ik) )                    &
                                * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))    &
                                        * psi_grad_psi(ix2,ib2,ibb1,ik)       ) &
                                          *  ee * exp(-ee*ee/(sg*sg))


               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_dc(1:3,1:3) = aux * maux(1:3,1:3) / omega
         sigma1_dc_atrace   = (   sigma1_dc(1,1) &
                                + sigma1_dc(2,2) &
                                + sigma1_dc(3,3) )/3.0_DP

   end subroutine sigma1_approx_2gaussian_DC
   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_1lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )

      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha

      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = 1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha

                  if( ib2 == ib1 .or. abs(ee) <=  de ) then
                     focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss * 2.0_DP
                  endif

                  if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  maux(ix2, ix1) = maux(ix2,ix1)                                &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                                 / ( eem*eem + sa*sa )         

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_exact_1lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_2lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )


      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha

      ! aux = 0.5 * sa (from 1/2 ( s(w) + s(-w) )
      ! aux = 2 * aux to sum over ib1, ib2+1 => aux = sa

      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = ib1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( ib2 == ib1 .or. abs(ee) <=  de ) then
                     focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
                  endif

                  if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee


                  maux(ix2, ix1) = maux(ix2,ix1)                               &
                                 + dfde                                        &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                        * ( 1.0_DP/( eem*eem + sa*sa )         &
                                            + 1.0_DP/( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_exact_2lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_lorentzian_DC

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha

      do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = ib1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if( ib2 == ib1 .or. abs(ee) <=  de ) then
                     focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
                  endif

                  if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  ! Factor of two above accounts for the sum ib1, ib2=ib1+1   
                  if ( ib2 /= ib1 ) dfde = 2.0_DP * dfde
                  

                  maux(ix2, ix1) = maux(ix2,ix1)                                &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                        /( ee*ee + sa*sa )
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix2
      enddo ! ix1

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)


      sigma1_dc(1:3,1:3) = sa * maux(1:3,1:3) / omega
      sigma1_dc_atrace   = (    sigma1_dc(1,1) &
                              + sigma1_dc(2,2) &
                              + sigma1_dc(3,3) )/3.0_DP

   end subroutine sigma1_exact_lorentzian_DC



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_1gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg              !  pi * (1 / (sg * sqrt(pi) ) 
                                         ! The pi comes form KG formula
                                         ! The 2 in KG goes into the wg factors                                        

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )

      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

               do ib2 = 1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha

                  if ( ib2 == ib1 .or. abs(ee) <= de ) then
                     focc = 1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP)
                     dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif
                  
                  if( abs(ee) > de ) &
                      dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  maux(ix2,ix1) = maux(ix2,ix1)                                 &
                                + dfde                                          &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                    *           psi_grad_psi( ix2,ib2,ibb1,ik) )&
                                      * exp(-eem*eem/(sg*sg))                   
                                          
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

          enddo ! ix1
          enddo ! ix2

          call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
          call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

          sigma1(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_exact_1gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_2gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  0.5_dp * sqrt(pi) / sg     ! pi * 1/2 * 1/ (sg * sqrt(pi) ) 
                                         ! The 1/2 comes from (s(w)+s(-w))/2
                                         ! The pi comes form KG formula
                                         ! The 2 in KG goes into the wg 
                                         ! factors                                        
      aux = 2.0_DP * aux   ! Factor of two to sum over ib1,ib2=ib1+1


      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )

      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

               do ib2 = ib1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( ib2 == ib1 .or. abs(ee) <= de ) then
                     focc = 1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP)
                     dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif

                  if( abs(ee) > de ) &
                      dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee
 
                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                + dfde                                         &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                    *           psi_grad_psi( ix2,ib2,ibb1,ik) )&
                                      * ( exp(-eem*eem/(sg*sg))                &
                                          + exp(-eep*eep/(sg*sg)) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

          enddo ! ix1
          enddo ! ix2

          call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
          call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

          sigma1(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', ABS(ierr) )

    
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + & 
                              sigma1(2,2,0:nw) + &
                              sigma1(3,3,0:nw) ) / 3.0_DP

   end subroutine sigma1_exact_2gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_gaussian_DC

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg              !  pi * (1 / (sg * sqrt(pi) ) 
                                         ! The pi comes form KG formula
                                         ! The 2 in KG goes into the wg 
                                         ! factors                                        

         do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

               do ib2 = ib1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if ( ib2 == ib1 .or. abs(ee) <= de ) then
                     focc = 1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP)
                     dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif
                  
                  if( abs(ee) > de ) &
                      dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  ! Factor of two to account for the sum ib1, ib2=ib1+1
                  if ( ib1 /=  ib2 ) dfde = 2.0_DP * dfde

                  maux(ix2,ix1) = maux(ix2,ix1)                                 &
                                + dfde                                          &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                    *           psi_grad_psi( ix2,ib2,ibb1,ik) )&
                                      * exp(-ee*ee/(sg*sg))                   
                                          
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

          enddo ! ix1
          enddo ! ix2

          call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
          call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_dc(1:3,1:3) = aux * maux(1:3,1:3) / omega
         sigma1_dc_atrace   = ( sigma1_dc(1,1) + sigma1_dc(2,2) &
                                                      + sigma1_dc(3,3) )/3.0_DP

   end subroutine sigma1_exact_gaussian_DC 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! SUBROUTINES FOR DECOMPOSITION IN INTRA, INTER and DEGENERATE CONTRIBUTIONS
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_decomp_1lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa   = 0.5_dp * deltawidth / AUTOEV     ! Lorentzian half-width in Ha

      ! Intra bands contribution

      allocate( sigma1_intra(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_intra', &
                                                                      ABS(ierr))

      do iw = 0, nw
         eem =   wgrid(iw)                       ! in Ha

         do ix1 = 1, 3
         do ix2 = 1, 3

            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss)+1.0_DP)
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) /degauss * 2.0_DP

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                 + dfde                                        &
                                   *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik)) &
                                     *          psi_grad_psi(ix2,ib1,ibb1,ik) )& 
                                       /( eem*eem + sa*sa )       

               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_intra(1:3,1:3,iw) =  sa * maux(1:3,1:3) / omega

      enddo ! iw
      ! End intra band contributions

      ! Degeneracies contribution
      allocate( sigma1_degen(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_degen', &
                                                                      ABS(ierr))
      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3

            maux(ix2,ix1)=0.0_DP
            
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib2 == ib1 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     focc = 1.0_DP/( dexp( (et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                     dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) /degauss * 2.0_DP

                     maux(ix2,ix1) = maux(ix2,ix1)                              &
                                  + dfde                                        &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                       *         psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                          / ( eem*eem + sa*sa )
                  endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_degen(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega


      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma1_inter(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_inter', &
                                                                      ABS(ierr))
      do iw = 0, nw 

         do ix1 = 1, 3
         do ix2 = 1, 3

            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib2 == ib1 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <= de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                      *       psi_grad_psi( ix2,ib2,ibb1,ik ) )&
                                        / ( eem*eem + sa*sa )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_inter(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega

      enddo ! iw


      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )
      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))
      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))
      allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_inter', &
                                                                      ABS(ierr))
                                                                            
      sigma1(1:3,1:3,0:nw) =   sigma1_intra(1:3,1:3,0:nw) &
                               + sigma1_degen(1:3,1:3,0:nw) &
                               + sigma1_inter(1:3,1:3,0:nw)

      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_intra', &
                                                                      ABS(ierr))
      sigma1_atrace_intra(0:nw) = ( sigma1_intra(1,1,0:nw) + &
                    sigma1_intra(2,2,0:nw) + sigma1_intra(3,3,0:nw) )/3.0_DP

      sigma1(1:3,1:3,0:nw) =   sigma1_degen(1:3,1:3,0:nw) &
                               + sigma1_inter(1:3,1:3,0:nw)
      
      sigma1_atrace(0:nw) = ( sigma1(1,1,0:nw) + sigma1(2,2,0:nw) &
                                                   + sigma1(3,3,0:nw) )/3.0_DP

      sigma1_atrace_degen(0:nw) = ( sigma1_degen(1,1,0:nw) + &
                    sigma1_degen(2,2,0:nw) + sigma1_degen(3,3,0:nw) )/3.0_DP
      sigma1_atrace_inter(0:nw) = ( sigma1_inter(1,1,0:nw) + &
                    sigma1_inter(2,2,0:nw) + sigma1_inter(3,3,0:nw) )/3.0_DP


   end subroutine sigma1_exact_decomp_1lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_decomp_2lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant

      sa   = 0.5_dp * deltawidth / AUTOEV     ! Lorentzian half-width in Ha
      !aux  = 0.5_dp * sa                      ! Prefactor including the 1/2 from
                                              ! ( 1/( (e-w)^2 + sa^2/4 ) 
                                              !   + 1/( (e+w)^2 + sa^2/4 ) )/2

      !aux = 2.0_DP * aux = sa (Factor of two to sum over ib1,ib2=ib1+1) 

      ! Intra bands contribution

      allocate( sigma1_intra(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_intra', &
                                                                      ABS(ierr))

      do iw = 0, nw
         eem = wgrid(iw)                       ! in Ha

         do ix1 = 1, 3
         do ix2 = 1, 3

            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss)+1.0_DP)
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) /degauss * 2.0_DP

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                 + dfde                                        &
                                   *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))  &
                                     *          psi_grad_psi( ix2,ib1,ibb1,ik) )& 
                                       * ( 1.0_DP/( eem*eem + sa*sa ) )       

               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_intra(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega

      enddo ! iw
      ! End intra band contributions


      ! Degeneracies contribution
      allocate( sigma1_degen(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_degen', &
                                                                      ABS(ierr))


      do iw = 0, nw

         do ix1 = 1, 3
         do ix2 = 1, 3

            maux(ix2,ix1)=0.0_DP
            
            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     focc = 1.0_DP/( exp( (et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                     dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) /degauss * 2.0_DP

                     maux(ix2,ix1) = maux(ix2,ix1)                              &
                                  + dfde                                        &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                       *         psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                         * ( 1.0_DP/( eem*eem + sa*sa )+ &
                                             1.0_DP/( eep*eep + sa*sa ) )
                  endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_degen(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega

      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma1_inter(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_inter', &
                                                                      ABS(ierr))
      do iw = 0, nw 

         do ix1 = 1, 3
         do ix2 = 1, 3

            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd

                  if ( ib2 == ib1 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <= de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  maux(ix2,ix1) = maux(ix2,ix1)                                &
                                  + dfde                                       &
                                    *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                      *       psi_grad_psi( ix2,ib2,ibb1,ik ) )&
                                        * ( 1.0_DP/( eem*eem + sa*sa )         &
                                            + 1.0_DP/( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_inter(1:3,1:3,iw) = sa * maux(1:3,1:3) / omega

      enddo ! iw


      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )
      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      sigma1(1:3,1:3,0:nw) =    sigma1_degen(1:3,1:3,0:nw) &
                              + sigma1_inter(1:3,1:3,0:nw)

      sigma1(1:3,1:3,0:nw) =    sigma1(1:3,1:3,0:nw)       &
                                 + sigma1_intra(1:3,1:3,0:nw) 

      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_intra', &
                                                                      ABS(ierr))

      sigma1_atrace_intra(0:nw) = (   sigma1_intra(1,1,0:nw) &
                                       + sigma1_intra(2,2,0:nw) &
                                       + sigma1_intra(3,3,0:nw) )/3.0_DP

      sigma1_atrace(0:nw) = (   sigma1(1,1,0:nw) &
                              + sigma1(2,2,0:nw) &
                              + sigma1(3,3,0:nw) )/3.0_DP

      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))
      allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_inter', &
                                                                      ABS(ierr))

      sigma1_atrace_degen(0:nw) = (   sigma1_degen(1,1,0:nw) &
                                    + sigma1_degen(2,2,0:nw) &
                                    + sigma1_degen(3,3,0:nw) )/3.0_DP
                                    
      sigma1_atrace_inter(0:nw) = (   sigma1_inter(1,1,0:nw) &
                                    + sigma1_inter(2,2,0:nw) &
                                    + sigma1_inter(3,3,0:nw) )/3.0_DP

   end subroutine sigma1_exact_decomp_2lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_decomp_lorentzian_DC

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha

      ! Intra bands contributions

      do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       

                  focc =1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss)+1.0_DP)
                  dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP

                  maux(ix2, ix1) = maux(ix2,ix1)                                &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik)) &
                                      *          psi_grad_psi(ix2,ib1,ibb1,ik) )
                                        
               enddo ! ib1

            enddo ! ik

         enddo ! ix2
      enddo ! ix1

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

      sigma1_dc_intra(1:3,1:3) = maux(1:3,1:3) / omega / sa
      sigma1_dc_atrace_intra   = (    sigma1_dc_intra(1,1) &
                                    + sigma1_dc_intra(2,2) &
                                    + sigma1_dc_intra(3,3) )/3.0_DP

      ! Degeneracies contributions
      aux = 2.0_DP * sa             ! Factor of 2 to sum over ib1, ib2=ib1+1

      do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = ib1+1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if( abs(ee) >  de ) cycle

                  focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                  dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
 
                  maux(ix2, ix1) = maux(ix2,ix1)                               &
                                 + dfde                                        &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                        /( ee*ee + sa*sa )
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix2
      enddo ! ix1

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)


      sigma1_dc_degen(1:3,1:3) = aux * maux(1:3,1:3) / omega
      sigma1_dc_atrace_degen   = (    sigma1_dc_degen(1,1) &
                                    + sigma1_dc_degen(2,2) &
                                    + sigma1_dc_degen(3,3) )/3.0_DP

      ! Inter band contributions

      do ix1 = 1, 3
         do ix2 = 1, 3
            maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = ib1+1, nbnd
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if ( abs(ee) <= de ) cycle

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee    

                  maux(ix2, ix1) = maux(ix2,ix1)                               &
                                 + dfde                                        &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                        /( ee*ee + sa*sa )
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix2
      enddo ! ix1

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)


      sigma1_dc_inter(1:3,1:3) = aux * maux(1:3,1:3) / omega
      sigma1_dc_atrace_inter   = (    sigma1_dc_inter(1,1) &
                                    + sigma1_dc_inter(2,2) &
                                    + sigma1_dc_inter(3,3) )/3.0_DP

      sigma1_dc(1:3,1:3) =   sigma1_dc_intra(1:3,1:3) &
                           + sigma1_dc_degen(1:3,1:3) & 
                           + sigma1_dc_inter(1:3,1:3)

      sigma1_dc_atrace   =   sigma1_dc_atrace_intra   &
                           + sigma1_dc_atrace_degen   & 
                           + sigma1_dc_atrace_inter

   end subroutine sigma1_exact_decomp_lorentzian_DC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_decomp_1gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg             ! pi / ( sg * sqrt(pi) ) 


      ! Intra bands contribution
      
      allocate( sigma1_intra(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_intra', &
                                                                      ABS(ierr))

      do iw = 0, nw

         eem = wgrid(iw)                       ! in Ha

         do ix1 = 1, 3
            do ix2 = 1, 3
               maux(ix2,ix1) = 0.0_DP

               do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                     focc = 1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP )
                     dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     maux(ix2, ix1) = maux(ix2,ix1)                            &
                                 + dfde                                        &
                                   *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))  &
                                          *     psi_grad_psi(ix2,ib1,ibb1,ik) ) &
                                     * ( exp(-eem*eem/(sg*sg)) )

                  enddo    ! ib1

               enddo ! ik

            enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_intra(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw
      ! End intra bands contribution

      ! Degeneracies contribution
      allocate( sigma1_degen(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_degen', &
                                                                      ABS(ierr))

      do iw = 0, nw

         do ix1 = 1, 3
            do ix2 = 1, 3
               maux(ix2,ix1) = 0.0_DP

               do ik = 1, nks
               
               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group 

                  do ib2 = 1, nbnd

                     if ( ib2 == ib1 ) cycle

                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     eem = ee - wgrid(iw)                       ! in Ha
                     eep = ee + wgrid(iw)                       ! in Ha

                     if( abs(ee) <=  de ) then
                        focc =1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                        dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                        maux(ix2,ix1) = maux(ix2,ix1)                          &
                                  + dfde                                       &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                          *     psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                    * ( exp(-eem*eem/(sg*sg))  )
                     endif

                  enddo ! ib2
                  enddo ! ib1

               enddo ! ik

            enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_degen(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw
      ! End degeneracies contribution

      ! Inter band contributions
      allocate( sigma1_inter(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_inter', &
                                                                      ABS(ierr))

      do iw = 0, nw

         do ix1 = 1, 3
            do ix2 = 1, 3
               maux(ix2,ix1) = 0.0_DP

               do ik = 1, nks
  
                   do ibb1 = 1, nbnds_local
                      ib1 = ibb1 + nbnds_per_process * my_rank_old &
                                 + nbnds_per_group   * my_group

                     do ib2 = 1, nbnd

                        if ( ib2 == ib1 ) cycle

                        ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                        if ( abs(ee) <= de ) cycle

                        eem = ee - wgrid(iw)                       ! in Ha
                        eep = ee + wgrid(iw)                       ! in Ha

                        dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                        maux(ix2, ix1) = maux(ix2,ix1)                         &
                                + dfde                                         &
                                  *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                      *        psi_grad_psi( ix2,ib2,ibb1,ik ))&
                                        * (  exp(-eem*eem/(sg*sg))   )          
                     enddo ! ib2
                  enddo    ! ib1

               enddo ! ik

            enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_inter(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw
      ! End inter band contributions

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )
      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      sigma1(1:3,1:3,0:nw) =    sigma1_degen(1:3,1:3,0:nw) &
                              + sigma1_inter(1:3,1:3,0:nw)
      sigma1(1:3,1:3,0:nw) =    sigma1(1:3,1:3,0:nw)       &
                                 + sigma1_intra(1:3,1:3,0:nw) 

      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_intra', &
                                                                      ABS(ierr))

      sigma1_atrace_intra(0:nw) = (   sigma1_intra(1,1,0:nw) &
                                       + sigma1_intra(2,2,0:nw) &
                                       + sigma1_intra(3,3,0:nw) )/3.0_DP

      sigma1_atrace(0:nw) = (   sigma1(1,1,0:nw) &
                              + sigma1(2,2,0:nw) &
                              + sigma1(3,3,0:nw) )/3.0_DP

      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))
      allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_inter', &
                                                                      ABS(ierr))

      sigma1_atrace_degen(0:nw) = (   sigma1_degen(1,1,0:nw) &
                                    + sigma1_degen(2,2,0:nw) &
                                    + sigma1_degen(3,3,0:nw) )/3.0_DP
                                    
      sigma1_atrace_inter(0:nw) = (   sigma1_inter(1,1,0:nw) &
                                    + sigma1_inter(2,2,0:nw) &
                                    + sigma1_inter(3,3,0:nw) )/3.0_DP

   end subroutine sigma1_exact_decomp_1gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_decomp_2gaussian
      
      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      aux =           sqrt(pi) / sg    ! pi / (sg * sqrt(pi) ) 
      !aux  =  0.5_dp * sqrt(pi) / sg    ! pi * 1/2 * 1/ (sg * sqrt(pi) ) 
                                        ! The 1/2 comes from (s(w)+s(-w))/2
      
      ! aux = 2 * aux to sum over ib1,ib2=ib1+1 so we have only sqrt(pi)/sg     


      ! Intra bands contribution
      
      allocate( sigma1_intra(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_intra', &
                                                                      ABS(ierr))

      do iw = 0, nw

         eem = wgrid(iw)                       ! in Ha

         do ix1 = 1, 3
            do ix2 = 1, 3
               maux(ix2,ix1) = 0.0_DP

               do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                     focc = 1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP )
                     dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     maux(ix2, ix1) = maux(ix2,ix1)                             &
                                 + dfde                                         &
                                   *real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))  &
                                          *     psi_grad_psi(ix2,ib1,ibb1,ik) ) &
                                     * ( exp(-eem*eem/(sg*sg)) )

                  enddo    ! ib1

               enddo ! ik

            enddo ! ix1
         enddo ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_intra(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw
      ! End intra bands contribution

      ! Degeneracies contribution
      allocate( sigma1_degen(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_degen', &
                                                                      ABS(ierr))

      ! aux already takes into account twice the sum over ib1, ib2=ib1+1

      do iw = 0, nw

         do ix1 = 1, 3
            do ix2 = 1, 3
               maux(ix2,ix1) = 0.0_DP

               do ik = 1, nks
               
               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group 

                  do ib2 = ib1 + 1, nbnd
                  
                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     eem = ee - wgrid(iw)                       ! in Ha
                     eep = ee + wgrid(iw)                       ! in Ha

                     if( abs(ee) <=  de ) then
                        focc =1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                        dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP

                        maux(ix2,ix1) = maux(ix2,ix1)                          &
                                   + dfde                                      &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))&
                                          *     psi_grad_psi(ix2,ib2,ibb1,ik) )&
                                     * (   exp(-eem*eem/(sg*sg))               &
                                         + exp(-eep*eep/(sg*sg)) )
                     endif

                  enddo ! ib2
                  enddo ! ib1

               enddo ! ik

            enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_degen(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega


      enddo ! iw
      ! End degeneracies contribution

      ! Inter band contributions
      allocate( sigma1_inter(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_inter', &
                                                                      ABS(ierr))

      do iw = 0, nw

         do ix1 = 1, 3
            do ix2 = 1, 3
               maux(ix2,ix1) = 0.0_DP

               do ik = 1, nks
  
                   do ibb1 = 1, nbnds_local
                      ib1 = ibb1 + nbnds_per_process * my_rank_old &
                                 + nbnds_per_group   * my_group

                     do ib2 = ib1 + 1, nbnd

                        ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                        if ( abs(ee) <= de ) cycle

                        eem = ee - wgrid(iw)                       ! in Ha
                        eep = ee + wgrid(iw)                       ! in Ha

                        dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                        maux(ix2, ix1) = maux(ix2,ix1)                         &
                                + dfde                                         &
                                  *real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                      *        psi_grad_psi( ix2,ib2,ibb1,ik ))&
                                        * (  exp(-eem*eem/(sg*sg))             &
                                             + exp(-eep*eep/(sg*sg)) )

                     enddo ! ib2
                  enddo    ! ib1

               enddo ! ik

            enddo ! ix1
         enddo    ! ix2

         call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

         sigma1_inter(1:3,1:3,iw) = aux * maux(1:3,1:3) / omega

      enddo ! iw
      ! End inter band contributions

      allocate( sigma1(1:3,1:3,0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1', ABS(ierr) )

      sigma1(1:3,1:3,0:nw) =    sigma1_intra(1:3,1:3,0:nw) &
                              + sigma1_degen(1:3,1:3,0:nw) &
                              + sigma1_inter(1:3,1:3,0:nw) 

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))
      sigma1_atrace(0:nw) = (   sigma1(1,1,0:nw) &
                              + sigma1(2,2,0:nw) &
                              + sigma1(3,3,0:nw) )/3.0_DP

      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_intra', &
                                                                      ABS(ierr))

      sigma1_atrace_intra(0:nw) = (   sigma1_intra(1,1,0:nw) &
                                    + sigma1_intra(2,2,0:nw) &
                                    + sigma1_intra(3,3,0:nw) )/3.0_DP

      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))
      sigma1_atrace_degen(0:nw) = (   sigma1_degen(1,1,0:nw) &
                                    + sigma1_degen(2,2,0:nw) &
                                    + sigma1_degen(3,3,0:nw) )/3.0_DP
                                    
      allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) CALL errore('kgsigma1','allocating sigma1_atrace_inter', &
                                                                      ABS(ierr))

      sigma1_atrace_inter(0:nw) = (   sigma1_inter(1,1,0:nw) &
                                    + sigma1_inter(2,2,0:nw) &
                                    + sigma1_inter(3,3,0:nw) )/3.0_DP


   end subroutine sigma1_exact_decomp_2gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_exact_decomp_gaussian_DC

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg              !  pi * (1 / (sg * sqrt(pi) ) 
                                         ! The pi comes form KG formula
                                         ! The 2 in KG goes into the wg 
                                         ! factors
      ! Intra bands contributions
       
      do ix1 = 1, 3
      do ix2 = 1, 3
         maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

                  focc = 1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP)
                  dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                  
                  maux(ix2,ix1) = maux(ix2,ix1)                                 &
                                + dfde                                          &
                                  * real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik))  &
                                    *           psi_grad_psi( ix2,ib1,ibb1,ik) )&
                                      * exp(-ee*ee/(sg*sg))                   
                                          
               enddo ! ib1

            enddo ! ik

      enddo ! ix1
      enddo ! ix2

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

      sigma1_dc_intra(1:3,1:3) = aux * maux(1:3,1:3) / omega
      sigma1_dc_atrace_intra   = (   sigma1_dc_intra(1,1) &
                                   + sigma1_dc_intra(2,2) &
                                   + sigma1_dc_intra(3,3) )/3.0_DP

      ! Degeneracies contributions

      aux = 2.0_DP * aux                 ! Factor of 2 to sum over 
                                         ! ib1, ib2=ib1+1                                        
       
      do ix1 = 1, 3
      do ix2 = 1, 3
         maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

               do ib2 = ib1+1, nbnd
                                    
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if ( abs(ee) > de ) cycle

                  focc = 1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP)
                  dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                  
                  maux(ix2,ix1) = maux(ix2,ix1)                                 &
                                + dfde                                          &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                    *           psi_grad_psi( ix2,ib2,ibb1,ik) )&
                                      * exp(-ee*ee/(sg*sg))                   
                                          
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

       enddo ! ix1
       enddo ! ix2

       call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
       call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

       sigma1_dc_degen(1:3,1:3) = aux * maux(1:3,1:3) / omega
       sigma1_dc_atrace_degen   = (   sigma1_dc_degen(1,1) &
                                    + sigma1_dc_degen(2,2) &
                                    + sigma1_dc_degen(3,3) )/3.0_DP


      ! Inter bands contributions
       
      do ix1 = 1, 3
      do ix2 = 1, 3
         maux(ix2,ix1) = 0.0_DP

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

               do ib2 = ib1+1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if ( abs(ee) <= de ) cycle

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  maux(ix2,ix1) = maux(ix2,ix1)                                 &
                                + dfde                                          &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                    *           psi_grad_psi( ix2,ib2,ibb1,ik) )&
                                      * exp(-ee*ee/(sg*sg))                   
                                          
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1
      enddo ! ix2

      call mp_sum( maux, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( maux, inter_pool_comm ) ! reduce on k (nks)

      sigma1_dc_inter(1:3,1:3) = aux * maux(1:3,1:3) / omega
      sigma1_dc_atrace_inter   = (   sigma1_dc_inter(1,1) &
                                   + sigma1_dc_inter(2,2) &
                                   + sigma1_dc_inter(3,3) )/3.0_DP

      sigma1_dc(1:3,1:3) =   sigma1_dc_intra(1:3,1:3)  &
                            + sigma1_dc_degen(1:3,1:3) & 
                            + sigma1_dc_inter(1:3,1:3)

      sigma1_dc_atrace   =   sigma1_dc_atrace_intra    &
                            + sigma1_dc_atrace_degen   & 
                            + sigma1_dc_atrace_inter


   end subroutine sigma1_exact_decomp_gaussian_DC 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


   !===========================================================================
   !                     Average trace of sigma1 = tr(sigma1)/3
   !===========================================================================
   !
   ! Two choices for the sigma1 formula: 
   ! 1) With the 1/w factor (approximated formula)
   ! 2) With the 1/(e_n-e_n') factor (exact formula)
   !
   
   subroutine sigma1_atrace_approx_1lorentzian
      ! Lorentzian delta function
      ! (sa / Pi) / ( (ei - ej - omega)^2 + sa^2 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant

      sa   = 0.5_dp * deltawidth / AUTOEV     ! Lorentzian half-width in Ha


      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      ! Avoid division by zero
      iw   = 0
      do while ( wgrid(iw) < 1.0D-12 )
         iw = iw + 1      
      enddo 
      iaux = iw


      if ( iaux /= 0 ) then
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Conductivity for zero frequency can not" 
         write(stdout,*) "    be calculated using the KG approximated formula"
         write(stdout,*) "    with one Lorentzian representing the Dirac delta"
         write(stdout,*) "    function." 
         write(stdout,*) "      Calculation will start at", wgrid(iaux)," Ha." 
         !write(stdout,*) "    ================================================"

         if ( dc ) then

            write(stdout,*) ""
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    dc is set to TRUE, hence the DC component will be"
            write(stdout,*) "    calculated using the analytical limit for the "
            write(stdout,*) "    approximated formula and two Lorentzians."
            write(stdout,*) "    ================================================"

         else

            write(stdout,*) ""    
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    Set dc=.true. to calculate the DC component with"
            write(stdout,*) "    the analytical limit of the approximated formula"
            write(stdout,*) "    with two Lorenziants."
            write(stdout,*) "    ================================================"

         endif

      endif



      do iw = iaux, nw

      aux2 = 0.0_DP

      do ix1 = 1, 3
  
         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

            do ib2 = 1, nbnd

                if ( ib2 == ib1 ) cycle

                ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                eem = ee - wgrid(iw)                       ! in Ha

                aux2 = aux2                                                  &
                        + ( ( wg(ib2,ik) - wg(ib1,ik) )                      &
                             *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                              *       psi_grad_psi( ix1,ib2,ibb1,ik )  )   ) &
                                       * 1.0_DP / ( eem*eem + sa*sa )
                                                

            enddo ! ib2
            enddo ! ib1

         enddo ! ik

      enddo    ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = sa * aux2 / ( 3.0_DP * omega * wgrid(iw) )

      enddo ! iw

   end subroutine sigma1_atrace_approx_1lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_approx_2lorentzian
      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant

      sa   = 0.5_dp * deltawidth / AUTOEV     ! Lorentzian half-width in Ha

      ! Use ( 1/( (e-w)^2 + sa^2 ) - 1/( (e+w)^2 + sa^2 ) ) / (2 w) =
      ! 2 * e / ( ((e-w)^2 + sa^2)* ((e+w)^2 + sa^2 ) ), for which
      aux  = 2.0_DP * sa

      aux = 2.0_DP * aux                      ! Factor of 2 to sum over
                                              ! ib1, ib2 = ib1+1

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      do iw = 0, nw

      aux2 =  0.0_DP

      do ix1 = 1, 3
  
         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

            do ib2 = ib1 + 1, nbnd

               ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
               eem = ee - wgrid(iw)                       ! in Ha
               eep = ee + wgrid(iw)                       ! in Ha

               aux2 = aux2                                                   &
                        + ( ( wg(ib2,ik) - wg(ib1,ik) )                      &
                             *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                              *       psi_grad_psi( ix1,ib2,ibb1,ik )  )   ) &
                                       * ee / ( ( eem*eem + sa*sa ) *        &
                                                ( eep*eep + sa*sa ) )

            enddo ! ib2
            enddo ! ib1

         enddo ! ik

      enddo    ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = aux * aux2 / ( 3.0_DP * omega )

      enddo ! iw

   end subroutine sigma1_atrace_approx_2lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_approx_2lorentzian_DC

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa   = 0.5_DP * deltawidth / AUTOEV ! Lorentzian half-width in Ha
      aux  = 2.0_DP * sa                  ! Prefactor from lim w->0
      aux  = 2.0_DP * aux                 ! Twice the sum ib1, ib2=ib1+1  
      
      
      aux2 = 0.0_DP

      do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1  = ibb1 + nbnds_per_process * my_rank_old &
                              + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  aux2 = aux2                                                   &
                                  + ( wg(ib2,ik) - wg(ib1,ik) )                 &
                                    * real(conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                           *     psi_grad_psi(ix1,ib2,ibb1,ik)) &   
                                        * ee / (   ( ee*ee + sa*sa )            &
                                                 * ( ee*ee + sa*sa ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)
         
      sigma1_dc_atrace = aux * aux2 / ( 3.0_DP * omega )

   end subroutine sigma1_atrace_approx_2lorentzian_DC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_approx_1gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )


      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg              ! pi / (sg * sqrt(pi) )


      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      ! Avoid division by zero
      iw   = 0
      iaux = 0
      do while ( wgrid(iw) < 1.0D-12 )
         iw = iw + 1
      enddo 
      iaux = iw

      if ( iaux /= 0 ) then
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Conductivity for zero frequency can not" 
         write(stdout,*) "    be calculated using the KG approximated formula"
         write(stdout,*) "    with one Gaussian representing the Dirac delta"
         write(stdout,*) "    function." 
         write(stdout,*) "      Calculation will start at", wgrid(iaux)," Ha." 
         !write(stdout,*) "    ================================================"

         if ( dc ) then

            write(stdout,*) ""
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    dc is set to TRUE, hence the DC component will be"
            write(stdout,*) "    calculated using the analytical limit for the "
            write(stdout,*) "    approximated formula and two Gaussians."
            write(stdout,*) "    ================================================"

         else

            write(stdout,*) ""    
            !write(stdout,*) "    ================================================"
            !write(stdout,*) "    WARNING:" 
            write(stdout,*) "    Set dc=.true. to calculate the DC component with"
            write(stdout,*) "    the analytical limit of the approximated formula"
            write(stdout,*) "    with two Gaussians."
            write(stdout,*) "    ================================================"

         endif

      endif


      do iw = iaux, nw

      aux2 = 0.0_DP
 
      do ix1 = 1, 3

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

            do ib2 = 1, nbnd

                if ( ib2 == ib1 ) cycle

                ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                eem = ee - wgrid(iw)                       ! in Ha
                eep = ee + wgrid(iw)                       ! in Ha

                aux2 = aux2                                           &
                       +  ( wg(ib2,ik) - wg(ib1,ik) )                 &
                          *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )&
                              *       psi_grad_psi( ix1,ib2,ibb1,ik ))&
                            * exp(-eem*eem/(sg*sg))

             enddo ! ib2
             enddo ! ib1

         enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = aux * aux2 / (3.0_DP * omega * wgrid(iw))

      enddo ! iw

   end subroutine sigma1_atrace_approx_1gaussian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_approx_2gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )


      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      !aux  =  0.5_dp * sqrt(pi) / sg     ! pi * 1/2 * 1/ (sg * sqrt(pi) )
                                         ! The 1/2 comes from (s(w)+s(-w))/2
      aux  =  sqrt(pi) / sg              ! Factor of two for the sum
                                         ! ib1, ib2=ib1+1

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      ! Avoid division by zero
      iw   = 0
      iaux = 0
      do while ( wgrid(iw) < 1.0D-12 )
         iw = iw + 1      
      enddo 
      iaux = iw

      if ( iaux /= 0 ) then
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
	 write(stdout,*) "    Conductivity for zero frequency can not" 
         write(stdout,*) "    be calculated using the KG approximated formula"
         write(stdout,*) "    without taking proper analytical limits."
         write(stdout,*) "    Calculation will start at", wgrid(iaux)," Ha." 
         write(stdout,*) "    ================================================"
      endif

      if ( dc ) then

         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    dc is set to TRUE, hence the DC component with"
         write(stdout,*) "    the choosen formula and Dirac delta function"
         write(stdout,*) "    representation will be calculated and reported"
         write(stdout,*) "    in this output." 
         write(stdout,*) "    ================================================"

      else
    
         write(stdout,*) ""
         write(stdout,*) "    ================================================"
         write(stdout,*) "    WARNING:" 
         write(stdout,*) "    Set dc=.true. to calculate the DC component with"
         write(stdout,*) "    the choosen formula and Dirac delta function"
         write(stdout,*) "    representation. " 
         write(stdout,*) "    ================================================"

      endif

      do iw = iaux, nw

      aux2 = 0.0_DP

      do ix1 = 1, 3

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1  = ibb1 + nbnds_per_process * my_rank_old &
                           + nbnds_per_group   * my_group

            do ib2 = ib1 + 1, nbnd

                ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                eem = ee - wgrid(iw)                       ! in Ha
                eep = ee + wgrid(iw)                       ! in Ha

                aux2 = aux2                                                    &
                       +  ( wg(ib2,ik) - wg(ib1,ik) )                          &
                          *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )         &
                             *       psi_grad_psi( ix1,ib2,ibb1,ik )        )  &
                            * ( exp(-eem*eem/(sg*sg)) - exp(-eep*eep/(sg*sg)) )

             enddo ! ib2
             enddo    ! ib1

         enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = aux * aux2 / ( 3.0_DP * omega * wgrid(iw) )

      enddo ! iw

   end subroutine sigma1_atrace_approx_2gaussian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_approx_2gaussian_DC


      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV         ! Gaussian width in Ha
      aux  =  2.0_dp * sqrt(pi) &         ! pi * 1/2 *( 1/ (sg * sqrt(pi) ) ) 
              / (sg*sg*sg)                ! 4 / sg^2
                                          ! The 1/2 comes from (s(w)+s(-w))/2
                                          ! The pi comes form KG formula
                                          ! The 2 in KG goes into the wg 
                                          ! factors                                        
                                          ! The 4/sg^2 comes from w->0 limit
      aux = 2.0_DP * aux                  ! Factor of two to account for the
                                          ! sum ib1,ib2=ib1+1
                                          

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1 + 1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  aux2 = aux2                                                   &
                              +  ( wg(ib2,ik) - wg(ib1,ik) )                    &
                                * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))    &
                                        * psi_grad_psi(ix1,ib2,ibb1,ik)       ) &
                                          *  ee * exp(-ee*ee/(sg*sg))


               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_dc_atrace = aux * aux2 / ( 3.0_DP * omega )


   end subroutine sigma1_atrace_approx_2gaussian_DC
   
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_1lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant


      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha
 
      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgcond:1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      do iw = 0, nw

      aux2 = 0.0_DP

      do ix1 = 1, 3

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1 = ibb1 + nbnds_per_process * my_rank_old &
                          + nbnds_per_group   * my_group

            do ib2 = 1, nbnd

                if ( sigma1_notintra .and. ib2 == ib1 ) cycle

                ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                eem = ee - wgrid(iw)                       ! in Ha
                eep = ee + wgrid(iw)                       ! in Ha

                if( ib2 == ib1 .or. abs(ee) <= de ) then
                   focc = 1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                   dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss *2.0_DP
                endif

                if( abs(ee) >  de ) &
                   dfde =( wg(ib2,ik) - wg(ib1,ik) )/ ee


                aux2 = aux2                                                    &
                          + dfde                                               &
                            * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )         &
                              *       psi_grad_psi( ix1,ib2,ibb1,ik )          &
                                *  1.0_DP/( eem*eem + sa*sa )                 

             enddo ! ib2
             enddo ! ib1

         enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = sa * aux2 / ( 3.0_DP * omega )

      enddo ! iw

      sigma1_dc_atrace = sigma1_atrace(0)

   end subroutine sigma1_atrace_exact_1lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_2lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant


      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha
      !aux  = 0.5_dp * sa                   ! Prefactor including the 1/2 from
                                           ! ( 1/( (e-w)^2 + sa^2/4 ) 
                                           !   + 1/( (e+w)^2 + sa^2/4 ) )/2
      ! aux = 2 * aux to account for sum over ib1, ib2=ib1+1 => aux = sa

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgcond:2','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      do iw = 0, nw

      aux2 = 0.0_DP

      do ix1 = 1, 3

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1 = ibb1 + nbnds_per_process * my_rank_old &
                          + nbnds_per_group   * my_group

            do ib2 = ib1, nbnd

                if ( sigma1_notintra .and. ib2 == ib1 ) cycle

                ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                eem = ee - wgrid(iw)                       ! in Ha
                eep = ee + wgrid(iw)                       ! in Ha

                if( ib2 == ib1 .or. abs(ee) <= de ) then
                   focc = 1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                   dfde =-wk(ik) * focc * ( focc - 1.0_DP ) / degauss *2.0_DP
                endif

                if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee


                aux2 = aux2                                                    &
                          + dfde                                               &
                            * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )         &
                              *       psi_grad_psi( ix1,ib2,ibb1,ik )          &
                                * ( 1.0_DP/( eem*eem + sa*sa )                 &
                                    + 1.0_DP/( eep*eep + sa*sa ) )

             enddo ! ib2
             enddo ! ib1

         enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = sa * aux2 / (3.0_DP * omega)

      enddo ! iw

   end subroutine sigma1_atrace_exact_2lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_lorentzian_DC

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha

      aux2 = 0.0_DP
      do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = 1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if( abs(ee) <=  de ) then
                     focc =1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss)+1.0_DP)
                     dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
                  endif

                  if( abs(ee) > de ) &
                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  aux2 = aux2                                                   &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix1,ib2,ibb1,ik) )&
                                        /( ee*ee + sa*sa )
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)


      sigma1_dc_atrace = sa * aux2 / ( 3.0_DP * omega )

   end subroutine sigma1_atrace_exact_lorentzian_DC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_1gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )


      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg              ! pi / (sg * sqrt(pi) ) 

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      do iw = 0, nw

      aux2 = 0.0_DP

      do ix1 = 1, 3

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1 = ibb1 + nbnds_per_process * my_rank_old &
                          + nbnds_per_group   * my_group

            do ib2 = 1, nbnd

               if ( sigma1_notintra .and. ib2 == ib1 ) cycle

               ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
               eem = ee - wgrid(iw)                       ! in Ha

               if( ib2 == ib1 .or. abs(ee) <= de ) then
                  focc =  1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP
               endif

               if( ib1 /= ib2 .and. abs(ee) > de ) &
                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

               aux2 = aux2                                                     &
                       +   dfde                                                &
                           *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )        &
                               *       psi_grad_psi( ix1,ib2,ibb1,ik )       ) &
                            *  exp(-eem*eem/(sg*sg)) 

            enddo ! ib2
            enddo ! ib1

         enddo ! ik

      enddo    ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = aux * aux2 / (3.0_DP * omega)

      enddo ! iw

   end subroutine sigma1_atrace_exact_1gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_2gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )


      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      !aux  =  sqrt(pi) / sg              ! pi / (sg * sqrt(pi) ) 
      !aux  =  0.5_dp * sqrt(pi) / sg     ! 1/2 from (s(w)+s(-w))/2 
                                         ! Factor of two to sum over
      aux  = sqrt(pi) / sg               ! ib1, ib2=ib1+1


      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      do iw = 0, nw

      aux2 = 0.0_DP

      do ix1 = 1, 3

         do ik = 1, nks

            do ibb1 = 1, nbnds_local
               ib1 = ibb1 + nbnds_per_process * my_rank_old &
                          + nbnds_per_group   * my_group

            do ib2 = ib1, nbnd

               if ( sigma1_notintra .and. ib2 == ib1 ) cycle

               ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
               eem = ee - wgrid(iw)                       ! in Ha
               eep = ee + wgrid(iw)                       ! in Ha

               if( ib2 == ib1 .or. abs(ee) <= de ) then
                  focc =  1.0_DP/( dexp((et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP
               endif


               if( ib1 /= ib2 .and. abs(ee) > de ) &
                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

               aux2 = aux2                                                     &
                       +   dfde                                                &
                           *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )        &
                               *       psi_grad_psi( ix1,ib2,ibb1,ik )       ) &
                            * ( exp(-eem*eem/(sg*sg)) + exp(-eep*eep/(sg*sg)) )

            enddo ! ib2
            enddo ! ib1

         enddo ! ik

      enddo    ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_atrace(iw) = aux * aux2 / ( 3.0_DP * omega )

      enddo ! iw

   end subroutine sigma1_atrace_exact_2gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_gaussian_DC


      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )

      sg   =  deltawidth / AUTOEV        ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg              !  pi * (1 / (sg * sqrt(pi) ) 
                                         ! The pi comes form KG formula
                                         ! The 2 in KG goes into the wg 
                                         ! factors                                        

         aux2 = 0.0_DP
         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group               

               do ib2 = ib1, nbnd

                  if ( sigma1_notintra .and. ib2 == ib1 ) cycle
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if ( ib2 == ib1 .or. abs(ee) <= de ) then
                     focc = 1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP)
                     dfde =-wk(ik)*focc*( focc - 1.0_DP ) / degauss * 2.0_DP
                  endif
                  
                  if( abs(ee) > de ) &
                      dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  ! Factor of two to account for the sum ib1, ib2=ib1+1
                  if ( ib1 /=  ib2 ) dfde = 2.0_DP * dfde


                  aux2 = aux2                                 &
                                + dfde                                          &
                                  * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik))  &
                                    *           psi_grad_psi( ix1,ib2,ibb1,ik) )&
                                      * exp(-ee*ee/(sg*sg))                   
                                          
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

          enddo ! ix2

          call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
          call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_dc_atrace = aux * aux2 / ( 3.0_DP * omega )

   end subroutine sigma1_atrace_exact_gaussian_DC 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_decomp_1lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant

      sa   = 0.5_dp * deltawidth / AUTOEV     ! Lorentzian half-width in Ha

      ! Intra bands contributions
      
      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgcond:3','allocating sigma1_atrace', &
                                                                      ABS(ierr))
      do iw = 0, nw
         eem =   wgrid(iw)                       ! in Ha
         aux2 = 0.0_DP 
 
         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc = 1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP  )
                  dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  aux2 = aux2                                                  &
                         + dfde                                                &
                           *  (conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )        &
                               *       psi_grad_psi( ix1,ib1,ibb1,ik )        ) &
                                 * ( 1.0_DP/( eem*eem + sa*sa ) )

               enddo    ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_intra(iw) = sa * aux2 / (3.0_DP * omega)

      enddo ! iw

      ! End intra band contributions


      ! Degeneracies contribution
      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib2 == ib1 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     focc = 1.0_DP/( dexp( (et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                     dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     aux2 = aux2                                               &
                            + ( dfde                                           &
                              *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )      &
                               *       psi_grad_psi( ix1,ib2,ibb1,ik )  )     ) &
                                * ( 1.0_DP/( eem*eem + sa*sa )  )               
                  endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_degen(iw) = sa * aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End degeneracies contribution
 

      ! Inter bands contribution
      allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace_inter', &
                                                                      ABS(ierr))

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnd
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = 1, nbnd

                  if ( ib2 == ib1 ) cycle

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <= de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  aux2 = aux2                                                  &
                            + ( dfde                                           &
                                * (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                                   *    psi_grad_psi( ix1,ib2,ibb1,ik )  )   ) &
                                     * 1.0_DP/( eem*eem + sa*sa )            

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

        enddo ! ix1

        call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
        call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

        sigma1_atrace_inter(iw) = sa * aux2 / ( 3.0_DP * omega )

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      sigma1_atrace = sigma1_atrace_intra + sigma1_atrace_degen &
                                                         + sigma1_atrace_inter

      sigma1_dc_atrace       = sigma1_atrace(0)
      sigma1_dc_atrace_intra = sigma1_atrace_intra(0)
      sigma1_dc_atrace_degen = sigma1_atrace_degen(0)
      sigma1_dc_atrace_inter = sigma1_atrace_inter(0)

   end subroutine sigma1_atrace_exact_decomp_1lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_decomp_2lorentzian

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant

      sa   = 0.5_dp * deltawidth / AUTOEV     ! Lorentzian half-width in Ha
      aux  = 0.5_dp * sa                      ! Prefactor including the 1/2 from
                                              ! ( 1/( (e-w)^2 + sa^2/4 ) 
                                              !   + 1/( (e+w)^2 + sa^2/4 ) )/2

      ! Intra bands contribution
      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgcond:4','allocating sigma1_atrace', &
                                                                      ABS(ierr))
      do iw = 0, nw
         eem =   wgrid(iw)                       ! in Ha
         aux2 = 0.0_DP 
 
         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc = 1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP  )
                  dfde = -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  aux2 = aux2                                                  &
                         + dfde                                                &
                           *  (conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )        &
                               *       psi_grad_psi( ix1,ib1,ibb1,ik )        ) &
                                 * ( 1.0_DP/( eem*eem + sa*sa ) )

               enddo    ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_intra(iw) = sa * aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End intra band contributions


      ! Degeneracies contribution
      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))
      aux = 2.0_DP * aux ! Factor of 2 to sum over ib1, ib2=ib1+1

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1+1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  if( abs(ee) <=  de ) then
                     focc = 1.0_DP/( dexp( (et(ib2,ik)-e_f)/degauss ) + 1.0_DP )
                     dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                     aux2 = aux2                                                &
                            + ( dfde                                            &
                              *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )      &
                               *       psi_grad_psi( ix1,ib2,ibb1,ik )  )     ) &
                                * (   1.0_DP/( eem*eem + sa*sa )                &               
                                    + 1.0_DP/( eep*eep + sa*sa )  )               
                  endif

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_degen(iw) = aux * aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End degeneracies contribution

      ! Inter bands contribution
      allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace_inter', &
                                                                      ABS(ierr))

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnd
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

               do ib2 = ib1+1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                  if ( abs(ee) <= de ) cycle

                  eem = ee - wgrid(iw)                       ! in Ha
                  eep = ee + wgrid(iw)                       ! in Ha

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                  aux2 = aux2                                                  &
                            + ( dfde                                           &
                                * (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                                   *    psi_grad_psi( ix1,ib2,ibb1,ik )  )   ) &
                                     * ( 1.0_DP/( eem*eem + sa*sa )            &
                                          + 1.0_DP/( eep*eep + sa*sa ) )

               enddo ! ib2
               enddo ! ib1

            enddo ! ik

        enddo ! ix1

        call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
        call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

        sigma1_atrace_inter(iw) = aux * aux2 / ( 3.0_DP * omega )

      enddo ! iw

      allocate( sigma1_atrace(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

      sigma1_atrace = sigma1_atrace_intra + sigma1_atrace_degen &
                                                         + sigma1_atrace_inter

      sigma1_dc_atrace       = sigma1_atrace(0)
      sigma1_dc_atrace_intra = sigma1_atrace_intra(0)
      sigma1_dc_atrace_degen = sigma1_atrace_degen(0)
      sigma1_dc_atrace_inter = sigma1_atrace_inter(0)

   end subroutine sigma1_atrace_exact_decomp_2lorentzian

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_decomp_lorentzian_DC

      ! Lorentzian delta function
      ! (sa / 2 Pi) / ( (ei - ej - omega)^2 + sa^2/4 ), 
      ! defined between -infinity and infinity
      ! The Pi cancels out with the 2 Pi / etc. constant in KG formula
      ! The factor of 2 in KG goes into the wg factors

      sa   = 0.5_dp * deltawidth / AUTOEV  ! Lorentzian half-width in Ha

      ! Intra bands contributions

      aux2 = 0.0_DP
      do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
                  focc =1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss)+1.0_DP)
                  dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP

                  aux2 = aux2                                                   &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib1,ibb1,ik)) &
                                      *          psi_grad_psi(ix1,ib1,ibb1,ik) )
                                        
               enddo ! ib1

            enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_dc_atrace_intra = aux2 / ( 3.0_DP * omega * sa)

      ! Degeneracies contributions
       
      aux = 2.0_DP * sa ! Factor of 2 to sum over ib1, ib2=ib1+1

      aux2 = 0.0_DP
      do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = ib1+1, nbnd

                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if( abs(ee) >  de ) cycle

                  focc =1.0_DP/(dexp((et(ib2,ik)-e_f)/degauss)+1.0_DP)
                  dfde =-wk(ik)*focc*( focc-1.0_DP )/degauss*2.0_DP
 
                  aux2 = aux2                                                   &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix1,ib2,ibb1,ik) )&
                                        /( ee*ee + sa*sa )
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

      sigma1_dc_atrace_degen = aux * aux2 / ( 3.0_DP * omega )

      ! Inter band contributions

      aux2 = 0.0_DP
      do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group
       
               do ib2 = ib1+1, nbnd
                  
                  ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                  if ( abs(ee) <= de ) cycle

                  dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee    

                  aux2 = aux2                                                   &
                                 + dfde                                         &
                                   * real( conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                      *          psi_grad_psi(ix1,ib2,ibb1,ik) )&
                                        /( ee*ee + sa*sa )
               enddo ! ib2
               enddo ! ib1

            enddo ! ik

      enddo ! ix1

      call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
      call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)


      sigma1_dc_atrace_inter = aux * aux2 / ( 3.0_DP * omega )

      sigma1_dc_atrace   =   sigma1_dc_atrace_intra   &
                           + sigma1_dc_atrace_degen   & 
                           + sigma1_dc_atrace_inter

   end subroutine sigma1_atrace_exact_decomp_lorentzian_DC

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_decomp_1gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )
          
      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg             ! pi * 1/ (sg * sqrt(pi) )

      ! Intra bands contribution
      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgcond:5','allocating sigma1_atrace_intra', &
                                                                      ABS(ierr))

      do iw = 0, nw

         eem =  wgrid(iw)                       ! in Ha
         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP  )
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  aux2 = aux2                                                  &
                         +  dfde                                               &
                                *  (conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )   &
                                    *       psi_grad_psi( ix1,ib1,ibb1,ik )  ) &
                                            * ( exp(-eem*eem/(sg*sg)) )

               enddo    ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_intra(iw) = aux * aux2 / (3.0_DP * omega)

      enddo ! iw
      ! End intra bands contribution

      ! Degeneracies contribution
      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                do ib2 = 1, nbnd

                  if ( ib2 == ib1 ) cycle

                   ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                   eem = ee - wgrid(iw)                       ! in Ha

                   if( abs(ee) <= de ) then
                      focc = 1.0_DP /( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                      dfde =  -wk(ik) *focc *( focc - 1.0_DP ) / degauss *2.0_DP

                      aux2 = aux2                                             &
                             +   dfde                                         &
                                 * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                                   *      psi_grad_psi( ix1,ib2,ibb1,ik )      &
                                     * ( exp(-eem*eem/(sg*sg)) )

                   endif

                enddo ! ib2
                enddo ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_degen(iw) = aux * aux2 / (3.0_DP * omega)

         enddo ! iw
         ! End degeneracies contribution

         ! Inter band contributions
         allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
         if (ierr/=0) call errore('kgcond:6','allocating sigma1_atrace_inter',&
                                                                      ABS(ierr))

         do iw = 0, nw

            aux2 = 0.0_DP

            do ix1 = 1, 3

               do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  do ib2 = 1, nbnd

                     if ( ib2 == ib1 ) cycle

                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     if ( abs(ee) <= de ) cycle

                     eem = ee - wgrid(iw)                       ! in Ha
                     eep = ee + wgrid(iw)                       ! in Ha

                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                     aux2 = aux2                                               &
                            +   dfde                                           &
                                *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                                     *      psi_grad_psi( ix1,ib2,ibb1,ik )   ) &
                            * ( exp(-eem*eem/(sg*sg)) )

                  enddo ! ib2
                  enddo ! ib1

               enddo ! ik

            enddo ! ix1

            call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
            call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

            sigma1_atrace_inter(iw) = aux * aux2 / (3.0_DP * omega)

         enddo ! iw
         ! End inter band contributions

         allocate( sigma1_atrace(0:nw), STAT=ierr )
         if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

         sigma1_atrace = sigma1_atrace_intra + sigma1_atrace_degen &
                                                         + sigma1_atrace_inter

         sigma1_dc_atrace       = sigma1_atrace(0)
         sigma1_dc_atrace_intra = sigma1_atrace_intra(0)
         sigma1_dc_atrace_degen = sigma1_atrace_degen(0)
         sigma1_dc_atrace_inter = sigma1_atrace_inter(0)


   end subroutine sigma1_atrace_exact_decomp_1gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_decomp_2gaussian

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )
     
      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      !aux  =  sqrt(pi) / sg              ! pi / (sg * sqrt(pi) ) 
      !aux  =  0.5_dp * sqrt(pi) / sg     ! 1/2 from (s(w)+s(-w))/2 
                                         ! Factor of two to sum over
      aux  = sqrt(pi) / sg               ! ib1, ib2=ib1+1


      ! Intra bands contribution
      allocate( sigma1_atrace_intra(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgcond:7','allocating sigma1_atrace_intra', &
                                                                      ABS(ierr))

      do iw = 0, nw

         eem =  wgrid(iw)                       ! in Ha
         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP  )
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  aux2 = aux2                                                  &
                         +  dfde                                               &
                                *  (conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )   &
                                    *       psi_grad_psi( ix1,ib1,ibb1,ik )  ) &
                                            * ( exp(-eem*eem/(sg*sg)) )

               enddo    ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_intra(iw) = aux * aux2 / ( 3.0_DP * omega )

      enddo ! iw
      ! End intra bands contribution

      ! Degeneracies contribution
      allocate( sigma1_atrace_degen(0:nw), STAT=ierr )
      if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace_degen', &
                                                                      ABS(ierr))

      do iw = 0, nw

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                do ib2 = ib1+1, nbnd

                   ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                   eem = ee - wgrid(iw)                       ! in Ha
                   eep = ee + wgrid(iw)                       ! in Ha

                   if( abs(ee) <= de ) then
                      focc = 1.0_DP /( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                      dfde =  -wk(ik) *focc *( focc - 1.0_DP ) / degauss *2.0_DP

                      aux2 = aux2                                             &
                             +   dfde                                         &
                                 * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )   &
                                   *      psi_grad_psi( ix1,ib2,ibb1,ik )     &
                                     * (   exp(-eem*eem/(sg*sg))              &
                                         + exp(-eep*eep/(sg*sg)) )

                   endif

                enddo ! ib2
                enddo ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_atrace_degen(iw) = aux * aux2 / ( 3.0_DP * omega )

         enddo ! iw
         ! End degeneracies contribution

         ! Inter band contributions
         allocate( sigma1_atrace_inter(0:nw), STAT=ierr )
         if (ierr/=0) call errore('kgcond:8','allocating sigma1_atrace_inter',&
                                                                      ABS(ierr))

         do iw = 0, nw

            aux2 = 0.0_DP

            do ix1 = 1, 3

               do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  do ib2 = ib1+1, nbnd

                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     if ( abs(ee) <= de ) cycle

                     eem = ee - wgrid(iw)                       ! in Ha
                     eep = ee + wgrid(iw)                       ! in Ha

                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                     aux2 = aux2                                                &
                            +   dfde                                            &
                                *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                                     *      psi_grad_psi( ix1,ib2,ibb1,ik )   ) &
                            * ( exp(-eem*eem/(sg*sg)) + exp(-eep*eep/(sg*sg)) )

                  enddo ! ib2
                  enddo ! ib1

               enddo ! ik

            enddo ! ix1

            call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
            call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

            sigma1_atrace_inter(iw) = aux * aux2 / ( 3.0_DP * omega )

         enddo ! iw
         ! End inter band contributions

         allocate( sigma1_atrace(0:nw), STAT=ierr )
         if (ierr/=0) call errore('kgsigma1','allocating sigma1_atrace', &
                                                                      ABS(ierr))

         sigma1_atrace = sigma1_atrace_intra + sigma1_atrace_degen &
                                                         + sigma1_atrace_inter

         sigma1_dc_atrace       = sigma1_atrace(0)
         sigma1_dc_atrace_intra = sigma1_atrace_intra(0)
         sigma1_dc_atrace_degen = sigma1_atrace_degen(0)
         sigma1_dc_atrace_inter = sigma1_atrace_inter(0)


   end subroutine sigma1_atrace_exact_decomp_2gaussian 

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sigma1_atrace_exact_decomp_gaussian_DC

      ! Gaussian delta function: exp(-x*x/sg*sg ) / ( sg * sqrt(pi) )
     
      sg   =  deltawidth / AUTOEV       ! Gaussian width in Ha
      aux  =  sqrt(pi) / sg             ! pi * 1/2 * 1/ (sg * sqrt(pi) )


      ! Intra bands contribution

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  focc =  1.0_DP / ( dexp((et(ib1,ik)-e_f)/degauss) + 1.0_DP  )
                  dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) / degauss * 2.0_DP

                  aux2 = aux2                                                  &
                         +  dfde                                               &
                                *  (conjg( psi_grad_psi( ix1,ib1,ibb1,ik ) )   &
                                    *       psi_grad_psi( ix1,ib1,ibb1,ik )  )

               enddo    ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_dc_atrace_intra = aux * aux2 / ( 3.0_DP * omega )

      ! End intra bands contribution

      ! Degeneracies contribution

         aux = 2.0_DP * aux ! Factor of 2 to sum over ib1, ib2=ib1+1

         aux2 = 0.0_DP

         do ix1 = 1, 3

            do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                do ib2 = ib1+1, nbnd

                   ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha

                   if( abs(ee) <= de ) then
                      focc = 1.0_DP /( dexp((et(ib2,ik)-e_f)/degauss) + 1.0_DP )
                      dfde =  -wk(ik) *focc *( focc - 1.0_DP ) / degauss *2.0_DP

                      aux2 = aux2                                             &
                             +   dfde                                         &
                                 * conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )   &
                                   *      psi_grad_psi( ix1,ib2,ibb1,ik )     &
                                     *    exp(-ee*ee/(sg*sg))              

                   endif

                enddo ! ib2
                enddo ! ib1

            enddo ! ik

         enddo    ! ix1

         call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
         call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

         sigma1_dc_atrace_degen = aux * aux2 / ( 3.0_DP * omega )

         ! End degeneracies contribution

         ! Inter band contributions

            aux2 = 0.0_DP

            do ix1 = 1, 3

               do ik = 1, nks

               do ibb1 = 1, nbnds_local
                  ib1 = ibb1 + nbnds_per_process * my_rank_old &
                             + nbnds_per_group   * my_group

                  do ib2 = ib1+1, nbnd

                     ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
                     if ( abs(ee) <= de ) cycle

                     dfde =  ( wg(ib2,ik) - wg(ib1,ik) )/ ee

                     aux2 = aux2                                                &
                            +   dfde                                            &
                                *  (conjg( psi_grad_psi( ix1,ib2,ibb1,ik ) )    &
                                     *      psi_grad_psi( ix1,ib2,ibb1,ik )   ) &
                            *  exp(-ee*ee/(sg*sg)) 

                  enddo ! ib2
                  enddo ! ib1

               enddo ! ik

            enddo ! ix1

            call mp_sum( aux2, inter_bgrp_comm ) ! reduce on bands (nbnd)
            call mp_sum( aux2, inter_pool_comm ) ! reduce on k (nks)

            sigma1_dc_atrace_inter = aux * aux2 / ( 3.0_DP * omega )

         ! End inter band contributions

         sigma1_dc_atrace =    sigma1_dc_atrace_intra &
                             + sigma1_dc_atrace_degen &
                             + sigma1_dc_atrace_inter   

   end subroutine sigma1_atrace_exact_decomp_gaussian_DC 


!   subroutine tensor_trace(tensor, trace)
!   dou
!   end subroutine tensor_trace

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



end module kgsigma1

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module parallel
use mp
use mp_pools
use mp_bands
use mp_global
use io_global
use qevars,   ONLY : DP, nbnd, nks
use kgecvars, ONLY : nproc_kp, nproc_bands, nproc_pw, &
                     nbnds_per_process, nbnds_per_group, nbnds_local, &
                     my_rank, my_rank_old, my_group, &
                     psi_grad_psi
implicit none


contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine parallel_bands_init

      nproc_kp    = mp_size( inter_pool_comm )
      nproc_bands = mp_size( inter_bgrp_comm )
      nproc_pw    = mp_size( intra_bgrp_comm )

      write(stdout,*) ' '
      write(stdout,*) '    --------------------------------------------------------------'
      write(stdout,*) '                        PARALLEL DISTRIBUTION'
      write(stdout,*) '    --------------------------------------------------------------'
      write(stdout,'(A,i4,4x,A,i4,4x,A,i4)') &
                      '                     nk=', nproc_kp, 'npw=', nproc_pw, 'nb=', nproc_bands
      write(stdout,*) '    --------------------------------------------------------------'

      my_rank           = mp_rank( inter_bgrp_comm )
      nproc_bands       = mp_size( inter_bgrp_comm )
      nbnds_per_process = nbnd / nproc_bands
      nbnds_per_group   = 0
      my_group          = 0
      my_rank_old       = my_rank
    
      if( my_rank /= (nproc_bands -1) ) then
         nbnds_local = nbnds_per_process
      else
         nbnds_local = nbnds_per_process + mod( nbnd, nproc_bands )
      endif

   end subroutine parallel_bands_init

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine recover_processes

      integer :: npwrec
      integer :: groupid, my_rank_world
      integer :: ib1, ib2

      complex(DP), allocatable :: gmaux(:,:,:,:)

      write(stdout,*) ''
      write(stdout,'(A)',advance='no') &
        '     Recovering pw processes for band parallelization ...'


      nproc_kp    = mp_size( inter_pool_comm ) 
      nproc_bands = mp_size( inter_bgrp_comm )
      nproc_pw    = mp_size( intra_bgrp_comm )
      
!      npwrec = mod( nbnd, nproc_pw*nproc_bands )
!      npwrec = mod( nbnds_per_process, nproc_pw )

      npwrec = nbnds_local / nproc_pw
 
      if ( nproc_pw > 1 .and. npwrec > 0 ) then

#ifdef __KGDEBUGPARA
         call parallel_groups_and_comms
#endif

         ! first free groups and communicators
         call mp_comm_group( inter_bgrp_comm, groupid )
         call mp_group_free( groupid )
         call mp_comm_group( intra_bgrp_comm, groupid )
         call mp_group_free( groupid )
         call mp_comm_free( inter_bgrp_comm )
         call mp_comm_free( intra_bgrp_comm )

         ! recreate inter_bgrp and intra_bgrp from world_comm,
         ! but swaping the names of inter and intra

         my_rank_world = mp_rank( world_comm )
         nproc_bands   = nproc_bands * nproc_pw
         my_group      = my_rank_world / nproc_bands
         my_rank       = MOD( my_rank_world, nproc_bands )

         call mp_comm_split( world_comm, my_group, my_rank_world, inter_bgrp_comm )
         call mp_comm_split( world_comm,  my_rank, my_rank_world, intra_bgrp_comm )  

#ifdef __KGDEBUGPARA
         call parallel_groups_and_comms
#endif

         ! Change the size of slices and redistribute the bands
         my_rank     = mp_rank( inter_bgrp_comm )
         my_group    = int( my_rank / nproc_pw )
         my_rank_old = mod( my_rank, nproc_pw )

         ! Bands per group and new number of bands per processes
         nbnds_per_group   = nbnds_per_process
         nbnds_per_process = nbnds_local / nproc_pw 


         ! Indices inside a band group 
         ib1 = nbnds_per_process * my_rank_old + 1
         ib2 = nbnds_per_process * ( my_rank_old + 1 )


         ! nbnds_local and ib2 index taking into account remainders 
         if( mod( (my_rank+1), nproc_pw ) /= 0 ) then
            nbnds_local = nbnds_per_process
         else
            ib2         = ib2 + mod( nbnds_local, nproc_pw )
            nbnds_local = nbnds_per_process + mod( nbnds_local, nproc_pw )
         endif

         allocate( gmaux( 1:3, 1:nbnd, 1:nbnds_local, 1:nks ) )

                gmaux( 1:3, 1:nbnd,   1:nbnds_local, 1:nks ) = &
         psi_grad_psi( 1:3, 1:nbnd, ib1:ib2        , 1:nks   ) 
   
         deallocate( psi_grad_psi )
         allocate( psi_grad_psi(1:3,1:nbnd,1:nbnds_local, 1:nks ) ) 
   
         psi_grad_psi( 1:3, 1:nbnd, 1:nbnds_local, 1:nks ) = &
                gmaux( 1:3, 1:nbnd, 1:nbnds_local, 1:nks )
   
         deallocate( gmaux )

         write(stdout,'(A)') ' done.'

      else
      
         write(stdout,'(A)') ' done.'

         if( nproc_pw == 1 ) then
            write(stdout,*) " "
            write(stdout,*) &
                  '     WARNING: Parallel: np is 1, nothing to recover'
         endif
         
         if( npwrec < 1 ) then
            write(stdout,*) ''
            write(stdout,*) &
                '     WARNING: Parallel: int(nbnd/nb)/np less than one'
            write(stdout,*) &
                '      ( int(nbnd/nb)=',nbnds_per_process,', np=', nproc_pw,')'
            write(stdout,*) &
                '     WARNING: therefore nothing recovered.'
         endif
      
      endif ! recovering of pw cores for bands parallelization

      write(stdout,*) ' '
      write(stdout,*) '--------------------------------------------------------------'
      write(stdout,*) '          PARALLEL DISTRIBUTION AFTER NPW RECOVERY'
      write(stdout,*) '--------------------------------------------------------------'
      write(stdout,'(A,i4,4x,A,i4,4x)') &
                      '                     nk=', nproc_kp,  'nb=', nproc_bands
      write(stdout,*) '--------------------------------------------------------------'


   end subroutine recover_processes

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine parallel_groups_and_comms
!   use mp
!   use mp_global
!   use mp_pools
!   use mp_bands
!   use io_global
!   implicit none
   
      character(20) :: comm_name(5)
      integer :: groupid, groupsize   
      integer :: maxrank, ip, ic
      integer, allocatable :: ranks(:,:)
 

      comm_name(1)= "world_comm"
      comm_name(2)= "inter_pool_comm"
      comm_name(3)= "intra_pool_comm"
      comm_name(4)= "inter_bgrp_comm"
      comm_name(5)= "intra_bgrp_comm"

       if(ionode) then

         write(*,*) "======================================================"
         write(*,*) "Communicators' group"
         write(*,*) "======================================================"
   
         call mp_comm_group( world_comm, groupid )
         groupsize=mp_size( world_comm )
         write(*,*) "world_comm      id and size", groupid, groupsize 
         call mp_comm_group( inter_pool_comm, groupid )
         groupsize=mp_size( inter_pool_comm )
         write(*,*) "inter_pool_comm id and size", groupid, groupsize 
         call mp_comm_group( intra_pool_comm, groupid )
         groupsize=mp_size( intra_pool_comm )
         write(*,*) "intra_pool_comm id and size", groupid, groupsize 
         call mp_comm_group( inter_bgrp_comm, groupid )
         groupsize=mp_size( inter_bgrp_comm )
         write(*,*) "inter_bgrp_comm id and size", groupid, groupsize 
         call mp_comm_group( intra_bgrp_comm, groupid )
         groupsize=mp_size( intra_bgrp_comm )
         write(*,*) "intra_bgrp_comm id and size", groupid, groupsize 
         write(*,*) " "
         write(*,*) " "
   
      endif ! ionode

      maxrank = mp_size( world_comm ) -1 
      allocate( ranks( 0:maxrank,  5) )
      ranks = 0

      do ip=0, maxrank   
         if ( mp_rank(world_comm)==ip ) then
            ranks(ip,1)=mp_rank(      world_comm )
            ranks(ip,2)=mp_rank( inter_pool_comm )
            ranks(ip,3)=mp_rank( intra_pool_comm )
            ranks(ip,4)=mp_rank( inter_bgrp_comm )
            ranks(ip,5)=mp_rank( intra_bgrp_comm )
          endif
      enddo

      call mp_sum( ranks, world_comm )

      if(ionode) then

         write(*,*) "======================================================"
         write(*,*) "Processes' ranks in each communicator"
         write(*,*) "======================================================"
         do ic=1,5
            write(*,'(1x,a18,64i4)'), comm_name(ic), ((ranks(ip,ic)),ip=0,maxrank)
         enddo

      endif

   end subroutine parallel_groups_and_comms      

end module parallel

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module kgecgradient
use qevars
use kgecvars
use kgsigma1
use kgsigma2
use parallel
implicit none

private

   integer :: ip1, ip2 ! Consecutive counters for the projectors


   integer :: iw                          ! Frequency index

   integer :: ik, ig                      ! counter on k-points and plane waves
                                          ! always local 
                                          ! (parallelization is hidden) 
                                         
   integer :: ib1,  ib2                   ! global counters on bands
   integer :: ibb1, ibb2                  ! local counters on bands

   integer :: ix1, ix2                    ! labels x, y an z

   real(DP)    :: aux, ee
   complex(DP) :: caux, psi_grad_psi_aux(3), cvaux(1:3)
   
   complex(DP), allocatable :: grad_paw_correction(:,:,:,:), psi_psi(:,:)

   real(DP) :: sumrulef, sumruleintegral

public :: kgec_gradient, psi_grad_psi, psi_psi, kgec_gradient_paw_correction, &
          sumrule_exact, sumrulef, sumrule_integral, sumruleintegral


contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine kgec_gradient

   my_rank = mp_rank( inter_bgrp_comm )

   !============================================================================
   !  Gradient matrix elements over the 'solid' pseudo wave function \Psi_{n,k}
   !                                 psi_grad_psi
   !============================================================================

   write(stdout,*) ''
   write(stdout,'(A)',advance='no') &
    '     Calculating the gradient matrix elements over pseudo \Psi_{n,k} ..'


   allocate( psi_grad_psi(1:3, 1:nbnd, 1:nbnds_local, 1:nks), STAT=ierr )
   if (ierr/=0) call errore('kgec','allocating psi_grad_psi', abs(ierr) )

   do ik = 1, nks

      ! Get the G vectors for the current k-vector
#if defined(__QE512) || defined(__QE54)
          call gk_sort (xk(1,ik), ngm, g, ecutwfc / tpiba2, npw, igk, g2kin )
#elif defined(__QE6) || defined(__QE62)
          npw = ngk(ik)
#endif

      ! Read the wave function for the given k-vector
      call davcio (evc, 2*nwordwfc, iunwfc, ik, - 1)

#if defined (__KGDEBUG)
      write(*,*) "evc:", ik, iunwfc, evc
#endif

      ! write(*,*) ik,nbnd,npw,ecutwfc

      !
      ! Calculate gradient matrix elements
      !
      do ibb2=1, nbnds_local
         ib2 = ibb2 + nbnds_per_process * my_rank
         
         do ib1=1, nbnd

            psi_grad_psi_aux = cmplx( 0.0_dp, 0.0_dp )

            do  ig=1, npw
                caux= conjg( evc(ig,ib1) ) * evc(ig,ib2)
#if defined (__KGDEBUG)
                write(*,*) "caux", ib1, ig, caux
#endif

#if defined (__QE6) || defined(__QE62) || defined(__QE64)
                psi_grad_psi_aux(1:3) = psi_grad_psi_aux(1:3) &
                                   + ( xk(1:3,ik) + g(1:3,igk_k(ig,ik)) ) * caux
#elif defined (__QE512) || defined(__QE54)
                psi_grad_psi_aux(1:3) = psi_grad_psi_aux(1:3) &
                                        + ( xk(1:3,ik) + g(1:3,igk(ig)) ) * caux
#endif
            enddo
            
            call mp_sum( psi_grad_psi_aux, intra_bgrp_comm ) ! reduce on G (npw)
            
            psi_grad_psi(1:3,ib1,ibb2,ik) = &
                         cmplx( 0.0_dp, 1.0_dp ) * tpiba * psi_grad_psi_aux(1:3)

#if defined (__KGDEBUG)
           write(*,*) "psi_grad_psi:", psi_grad_psi(1:3,ib1,ibb2,ik)
#endif
         enddo
      enddo

   enddo

#if defined (__QE6) || defined(__QE62) || defined(__QE64)
   deallocate( evc, g, igk_k )
#elif defined (__QE512) || defined(__QE54)
   deallocate( evc, g, igk )
#endif

   write(stdout,'(A)') ' done. '

   
   end subroutine kgec_gradient


!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


   subroutine kgec_gradient_paw_correction

   !===========================================================================
   !          Calculate PAW correction to the gradient matrix elements
   !                           ( Grad_paw_correction )
   !===========================================================================

   use kgecpaw
   use apawgm
   use qe_p_psi, ONLY: becp

     my_rank = mp_rank( inter_bgrp_comm )
   
     write(stdout,*) ''
     write(stdout,*) &
        '    Calculating the gradient matrix elements over atomic orbitals'
     write(stdout,'(A)',advance='no') &
        '     and pseudo-orbitals and PAW correction ..'

     ! < \phi | \nabbla | \phi > and < psphi|\nabla\ psphi> = DG

     call diff_awfc_grad_awfc

     ! Grad_paw_correction(1:3,ib2,ib1,ik)=
     ! \sum_{ia,l,m,l',mp'} <\Psi_{ib1}_{ik}| p_{ia,l,m} > \times
     ! (    < \phi_{ia,l,m} |\nabla| \phi_{ia,l',m'}> 
     !   -  < \hat{\phi}_{ia,l,m} |\nabla| \hat{\phi_{ia},l',m'}>) \times
     ! < p_{ia,l,m} |\Psi_{ib2}_{ik}>

     allocate( grad_paw_correction( 1:3, 1:nbnd, 1:nbnds_local,1:nks),STAT=ierr)
     if (ierr/=0) call errore('kgec:main','allocating grad_paw_correction',&
                                                                      ABS(ierr))

     grad_paw_correction( 1:3, 1:nbnd, 1:nbnds_local, 1:nks) = &
                                                         cmplx( 0.0_DP, 0.0_DP )

     do ik  = 1, nks
     
     do ibb1 = 1, nbnds_local
        ib1  = ibb1 + nbnds_per_process * my_rank
         
     do ib2 = 1, nbnd

        cvaux(1:3)=cmplx(0.0_dp, 0.0_dp)

        do ip1 = 1, n_pro_tot
!        do ip2 = 1, n_pro_tot
        do ip2 = p_index_row_start(ip1), p_index_row_end(ip1)  
            cvaux(1:3) = cvaux(1:3) &
                         + conjg( becp(ik)%k(ip2,ib2) ) &
                           * DG( 1:3, p_index(ip2), p_index(ip1) ) &
                            * becp(ik)%k(ip1,ib1)
        enddo
        enddo

        grad_paw_correction(1:3,ib2,ibb1,ik) = &
                                   cvaux(1:3) * psi_norm_factor(ib1,ik) &
                                              * psi_norm_factor(ib2,ik)

        psi_grad_psi(1:3,ib2,ibb1,ik) = ( psi_grad_psi(1:3,ib2,ibb1,ik) &
                                                         + cvaux(1:3) ) &
                                              * psi_norm_factor(ib1,ik) &
                                                * psi_norm_factor(ib2,ik)
#if defined (__KGDEBUG)
        write(*,*) ""
        write(*,*) "cvaux", cvaux(1:3)
        write(*,*) "psi_norm_factor:", psi_norm_factor(ib1,ik), psi_norm_factor(ib2,ik)
        write(*,*) "grad_paw_correction:", grad_paw_correction(1:3,ib2,ibb1,ik)
        write(*,*) "psi_grad_psi added:", psi_grad_psi(1:3,ib2,ibb1,ik)
#endif

     enddo
     enddo
     enddo

     call mp_barrier( inter_pool_comm )

     write(stdout,*) " done."

#if defined (__KGDEBUG)
     write (fname, "('grad_paw_correction-k', i0,'_b', i0, '.dat')") &
                                                             my_pool_id, me_pool
     fname=trim(tmp_dir)//fname
      open(121, file=fname,action='write')
     do ik=1, nks
     do ibb1=1, nbnds_local
        ib1 = ibb1 + nbnds_per_process * my_rank
        
     do ib2=1, nbnd
        write(121,*) ik, ib2, ib1, grad_paw_correction(1,ib2,ibb1,ik), &
                                   grad_paw_correction(2,ib2,ibb1,ik), &
                                   grad_paw_correction(3,ib2,ibb1,ik)
     enddo
     enddo
     enddo
     close(121)
#endif
   
     deallocate( grad_paw_correction )
     deallocate( psi_norm_factor )
     deallocate( becp )
     call agm_free_memory

   end subroutine kgec_gradient_paw_correction

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sumrule_exact
   real(DP) :: sum1, dfde

      write(stdout,*) ""
      write(stdout,*) &
        '    Calculating the exact sum (independents of frequencies):'

      sum1 = 0.0_DP
      
      do ik = 1, nks

      do ibb1 = 1, nbnds_local 
      
         ib1 = ibb1 + nbnds_per_process * my_rank_old &
                    + nbnds_per_group   * my_group

         do ib2 = 1, nbnd

           if ( sigma1_notintra .and. ib1 == ib2 ) cycle    ! No intra bands

           ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
           if ( abs(ee) <= de ) cycle ! No degeneracies

           dfde = ( wg(ib2,ik) - wg(ib1,ik) ) / ee

           aux = 0.0_DP
           do ix1 = 1, 3
              aux = aux + conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
                                 * psi_grad_psi(ix1,ib2,ibb1,ik)
           enddo

           sum1 = sum1 + aux * dfde

      enddo ! ib2
      enddo ! ib1
      enddo ! ik

      call mp_sum( sum1, inter_bgrp_comm ) ! reduce over bands (nbnd)
      call mp_sum( sum1, inter_pool_comm ) ! reduce over k-points (nks)

      sumrulef      = sum1 / ( 3.0_dp * nelec )

!      write(stdout,*) "      Sum rule (f)           :", sumrulef
!      write(stdout,*) ""
         
   end subroutine sumrule_exact

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

   subroutine sumrule_integral
   real(DP) :: sum1, sum2
   
   ! 
   ! Sum rule via Simpson's integration (with delta function)
   ! 
   
   sum1 = 0.0_dp
   sum2 = 0.0_dp

   select case ( AC )
   case( .true. )
      select case ( calculation )
      case( 'tensor' )

         do iw=2, nw-2, 2
            sum1 = sum1 + (sigma1(1,1,iw) + sigma1(2,2,iw) + sigma1(3,3,iw))
         enddo

         do iw=1, nw-1, 2
            sum2 = sum2 + (sigma1(1,1,iw) + sigma1(2,2,iw) + sigma1(3,3,iw))
         enddo

         sum1 = 2.0_dp * sum1 + 4.0_dp * sum2
         sum1 = sum1 + (sigma1(1,1,0) + sigma1(2,2,0) + sigma1(3,3,0))
         sum1 = (sum1 +(sigma1(1,1,nw)+sigma1(2,2,nw)+sigma1(3,3,nw)))*dw/3.0_dp

         sumruleintegral = 2.0_dp * omega * sum1 / ( 3.0_dp * pi * nelec )

      case( 'atrace' )

         do iw=2, nw-2, 2
            sum1 = sum1 + sigma1_atrace(iw)
         enddo

         do iw=1, nw-1, 2
            sum2 = sum2 + sigma1_atrace(iw)
         enddo

         sum1 = 2.0_dp * sum1 + 4.0_dp * sum2
         sum1 =   sum1 + sigma1_atrace(0)
         sum1 = ( sum1 + sigma1_atrace(nw) )*dw / 3.0_dp

         sumruleintegral = 2.0_dp * omega * sum1 / ( pi * nelec )

      end select
   end select
   
   end subroutine sumrule_integral


end module kgecgradient

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Saved subroutine with various forms of 'sum rules'
!   subroutine sumrule_exact
!   real(DP) :: sum1, sum2, sum3, sum4, focc, dfde, &
!               sumrulefintra, sumrulep, sumrulepf
!
!      write(stdout,*) ""
!      write(stdout,*) &
!        '    Calculating some sum rules (independents of frequencies):'
!
!
!      sum1 = 0.0_DP
!      sum2 = 0.0_DP
!      sum3 = 0.0_DP
!      sum4 = 0.0_DP
!      
!      do ik = 1, nks
!
!      do ibb1 = 1, nbnds_local 
!      
!         ib1 = ibb1 + nbnds_per_process * my_rank_old &
!                    + nbnds_per_group   * my_group
!
!         do ib2 = 1, nbnd
!
!!           if ( ib1 == ib2 ) cycle
!
!           ee  = ( et(ib1,ik) - et(ib2,ik) ) * 0.5_DP ! in Ha
!!           if ( abs(ee) <= de ) cycle
!
!
!           if( (intra .and. ib2==ib1) .or. abs(ee)<=de ) then
!              focc =  1.0_DP/(dexp((et(ib1,ik)-e_f)/degauss)+1.0_DP)
!              dfde =  -wk(ik) * focc * ( focc - 1.0_DP ) /degauss* 2.0_DP
!           else
!              dfde = ( wg(ib2,ik) - wg(ib1,ik) ) / ee
!           endif
!
!           aux = 0.0_DP
!           do ix1 = 1, 3
!              aux = aux + conjg(psi_grad_psi(ix1,ib2,ibb1,ik)) &
!                                 * psi_grad_psi(ix1,ib2,ibb1,ik)
!           enddo
!
!           sum2 = sum2 + aux * dfde
!
!           if( ib2 /= ib1 .and. abs(ee) > de ) then
!             if( (et(ib2,ik)-e_f) >= 0.0_dp) then
!               sum1 = sum1 + aux * ( wg(ib2,ik) - wg(ib1,ik) ) / ee
!             else
!               sum1 = sum1 - aux *                                          &
!                      (   1.0_DP/(dexp(-(et(ib2,ik)-e_f)/degauss)+1.0_DP)   &
!                        - 1.0_DP/(dexp(-(et(ib1,ik)-e_f)/degauss)+1.0_DP) ) &
!                      / ee 
!             endif
!             sum3 = sum3 - aux / ee
!             sum4 = sum4 - aux * wg(ib1,ik) / ee
!           endif
!
!
!
!      enddo ! ib2
!      enddo ! ib1
!      enddo ! ik
!
!      call mp_sum( sum1, inter_bgrp_comm ) ! reduce over bands (nbnd)
!      call mp_sum( sum1, inter_pool_comm ) ! reduce over k (nks)
!      call mp_sum( sum2, inter_bgrp_comm ) ! reduce over bands (nbnd)
!      call mp_sum( sum2, inter_pool_comm ) ! reduce over k (nks)
!      call mp_sum( sum3, inter_bgrp_comm ) ! reduce over bands (nbnd)
!      call mp_sum( sum3, inter_pool_comm ) ! reduce over k (nks)
!      call mp_sum( sum4, inter_bgrp_comm ) ! reduce over bands (nbnd)
!      call mp_sum( sum4, inter_pool_comm ) ! reduce over k (nks)
!
!      sumrulef      = sum1 / ( 3.0_dp * nelec )
!      sumrulefintra = sum2 / ( 3.0_dp * nelec )
!      sumrulep      = sum3 * 2.0_dp / 3.0_dp
!      sumrulepf     = sum4 * 2.0_dp / ( 3.0_dp * nelec )
!
!      write(stdout,*) "      Sum rule (f)           :", sumrulef
!      write(stdout,*) "      Sum rule (f with intra):", sumrulefintra
!      write(stdout,*) "      Sum rule (p)           :", sumrulep
!      write(stdout,*) "      Sum rule (pf)          :", sumrulepf
!      write(stdout,*) ""
!         
!   end subroutine sumrule_exact
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 

program kgec

! Kubo Greenwood Electron Conductivity (KGEC) code
! Post-processing tool for Quantum Espresso

use qevars
use qe_p_psi, ONLY: p_psi

use apawgm,   ONLY: use_real_spherical_harm, awfc_grad_awfc, &
                    check_p_pswfc, diff_awfc_grad_awfc,       &
                    psi_norm_correction_paw_at,               &
                    agm_free_memory
use kgecvars
use kgecchecks
use kgecpaw
use kgecgradient
use kgsigma1
use kgsigma2
use kgsigma2_w
use parallel
use kgecout
use kgepsilon1
use kgepsilon2
use kgrrae

implicit none

   NAMELIST / kgecpp / outdir, prefix, calculation,          &
                       sigma1_exact, decomposition,           &
                       calculate_sigma2,                      &
                       deltarep, deltawidth, wmin, wmax, nw,  &
                       use_real_spherical_harm,               &
                       check_wfc, check_delta,                &
                       non_local, yessym, yesinv, readgm, de, &
                       npwrecover, writegm, dc, ac,           &
                       sigma1_notintra, sigma2_notintra,      &
                       calculate_epsilon1, calculate_epsilon2,& 
                       calculate_rrae

   ! Initialization
   call mp_startup ( )
   ! 
   ! Get the starting header according to QE
   ! 
   
   call environment_start ( 'KGEC FOR QE' )
   
   
   write(stdout,'(A)') ''
   write(stdout,'(A)') &
'=------------------------------------------------------------------------------='
   write(stdout,*) &
     '                                  KGEC v.2.3.5'
   write(stdout,'(A)') &
'=------------------------------------------------------------------------------='


   ! Main reference
   write(stdout,'(A)') ''
   write(stdout,'(A)') &
   "     Please cite:"
   write(stdout,'(A)') &
   "                L. Calderin, V. V. Karasiev and S. B. Trickey," 
   write(stdout,'(A)') &
   "                 Comput Phys Commun 221  (2017), p. 118-142."  
   
   ! 
   ! Read the KGEC input file
   ! 
   ios=0
   if ( ionode )  then
      !call input_from_file TODO: this has not been needed for a while
      read(5, kgecpp, IOSTAT=ios)
      tmp_dir = trim(outdir)
   endif

   call mp_bcast( ios, ionode_id, world_comm )
   if( ios/=0 ) call errore('kgec', 'reading namelist KGECPP', ABS(ios))

   ! Broadcast and check KGEC specific input variables
   call kgecvars_check

   ! 
   ! Read QE files
   !
   if ( .not. readgm ) call read_file
   if (       readgm ) call read_file_nowfc

   ! wf_collect is now set to false always even if it was true
   ! twfcollect is set to true if that is the case during read_file but is
   ! defined back to false in openfil_pp
   ! so we have to check for collection of wavefunctions right here
#if defined(__QE64)
   if( ( .not. wf_collect ) .and. ( .not. readgm ) ) &
#else
   if( ( .not. twfcollect ) .and. ( .not. readgm ) ) &
#endif
      call errore( 'kgec:','Wave functions not collected',           3 )

   if ( .not. readgm ) call openfil_pp

   ! Check if KGEC requirements for the QE calculation were met and print out
   call kgec_check_requirements

   ! Print KGEC variables
   call kgecvars_print

   ! Get the frequency grid in Ha
   call frequency_grid()

   ! Initialization for bands parallelization
   call parallel_bands_init

   write(stdout,*) ' '
   write(stdout,*) &
         '    --------------------------------------------------------------'
   write(stdout,*) &
         "                           Calculations "
   write(stdout,*) &
         '    --------------------------------------------------------------'

   READGMATRIX: SELECT CASE ( readgm )
   CASE ( .false. ) 

      !
      ! Calculate wave function re-normalization factors in case of PAW sets
      !
      select case ( only_paw  )
      case( .true. )

         call kgec_paw_renorm

      end select

      !
      ! Checking ortho-normalization of the (pseudo) wave functions
      !
      CHECKORTHO: SELECT CASE ( check_wfc )
      CASE (.true.)

         select case( only_paw ) ! According to pseudopotentials
         case( .false. )         ! Norm conserving pseudos

            call kgec_check_orthonormalization_nc

         case(.true.) ! PAW sets

            call kgec_check_orthonormalization_paw

         end select 

      END SELECT CHECKORTHO

      !============================================================================
      ! Gradient matrix elements over the 'solid' pseudo wave function \Psi_{n,k}
      !                                    psi_grad_psi
      !============================================================================

      call kgec_gradient

      !=========================================================================
      !           Calculate PAW correction to the gradient matrix elements
      !                          ( Grad_paw_correction )
      !=========================================================================

      select case ( only_paw )
      case( .true. )

         call kgec_gradient_paw_correction

      end select ! PAW correction

   CASE ( .true. )

      call kgec_readgm

   END SELECT READGMATRIX


   ! Write gradient matrix elements
   select case ( writegm )
   case( .true. )
      
     call kgec_writegm

   end select


   call mp_barrier( inter_pool_comm )

   ! There is no more parallelization over G from this point on, so
   ! the -np cores would be wasted. Instead we recover them for use 
   ! in the bands parallelization with two caveat: the name of the comm
   ! must be inter_bgrp_comm but it must be an intra comm. The first 
   ! condition is to keep the same name for the comm of bands 
   ! parallelization and the second to be
   ! able to communicate with all process of one band group.

   select case( npwrecover )
   case(.true.)

     call recover_processes

   end select

   ! 
   ! Calculate the exact sum rule ( no dirac Delta function involved ) 
   ! 
   if ( .not. readgm ) call sumrule_exact

   ! check delta function representation
   
   select case ( check_delta )
   case( .true. )

      write(stdout,*) ''
      write(stdout,'(A)',advance='no') &
                          '     Calculating checks for delta function rep. ... '
      call check_delta_sub

      write(stdout,*) 'done.'

   end select

   write(stdout,*) ' '
   write(stdout,'(A)',advance='no') '     Calculating sigma1 ... '

   SIGMA1AC: SELECT CASE ( ac )
   CASE(.true.)  

   SIGMA1TENSORORTRACE: SELECT CASE ( calculation )
   CASE ( 'tensor' )

      SIGMAONEEXACT: SELECT CASE ( sigma1_exact )

      CASE ( .false. ) ! Approximated formulas

         select case ( deltarep )
         case ( '1l' )
            call sigma1_approx_1lorentzian
         case ( '2l' )
            call sigma1_approx_2lorentzian
         case ( '1g'  )
            call sigma1_approx_1gaussian
         case ( '2g'  )
            call sigma1_approx_2gaussian
         end select

      CASE ( .true. ) ! Exact formulas

         select case ( decomposition )
         case( .false. )

            select case ( deltarep )  ! Exact formulas
            case ('1l')
               call sigma1_exact_1lorentzian
            case ('2l')
               call sigma1_exact_2lorentzian
            case ('1g')
               call sigma1_exact_1gaussian
            case ('2g')
               call sigma1_exact_2gaussian
            end select

         case(.true.) ! Separate degenerate, intra and inter band contributions

            select case ( deltarep )  ! Exact formula
            case ('1l')
               call sigma1_exact_decomp_1lorentzian
            case ('2l')
               call sigma1_exact_decomp_2lorentzian
            case ('1g')
               call sigma1_exact_decomp_1gaussian
            case ('2g')
               call sigma1_exact_decomp_2gaussian
            end select

         end select

      END SELECT SIGMAONEEXACT

    CASE( 'atrace' )

      SIGMAONETRACEEXACT: SELECT CASE ( sigma1_exact )
      CASE ( .false. ) ! Approximated formula

         select case ( deltarep )
         case ('1l')
            call sigma1_atrace_approx_1lorentzian
         case ('2l')
            call sigma1_atrace_approx_2lorentzian
         case ('1g')
            call sigma1_atrace_approx_1gaussian
         case ('2g')
            call sigma1_atrace_approx_2gaussian
         end select

      CASE ( .true. ) ! Exact formula

         select case ( decomposition )
         case( .false. )

            select case ( deltarep )
            case ('1l')
               call sigma1_atrace_exact_1lorentzian
            case ('2l')
               call sigma1_atrace_exact_2lorentzian
            case ('1g')
               call sigma1_atrace_exact_1gaussian
            case ('2g')
               call sigma1_atrace_exact_2gaussian
            end select ! Delta function representation 

         case(.true.) ! Separate degenerate, intra and inter band contributions

            select case ( deltarep )  ! Exact formula
            case ('1l')
               call sigma1_atrace_exact_decomp_1lorentzian
            case ('2l')
               call sigma1_atrace_exact_decomp_2lorentzian
            case ('1g')
               call sigma1_atrace_exact_decomp_1gaussian   
            case ('2g')
               call sigma1_atrace_exact_decomp_2gaussian   
            end select ! Delta function representation 

         end select ! Decomposition

      END SELECT SIGMAONETRACEEXACT

   END SELECT SIGMA1TENSORORTRACE

   END SELECT SIGMA1AC
   
   write(stdout,'(A)') 'done.'


   SIGMA1DC: SELECT CASE ( dc )
   CASE( .true. )

   SIGMA1TENSORORTRACEDC: SELECT CASE ( calculation )
   CASE ( 'tensor' )

      SIGMAONEEXACTDC: SELECT CASE ( sigma1_exact )

      CASE ( .false. ) ! Approximated formulas

         select case ( deltarep )
         case ( '1l' )
            write(stdout, '(A)') &
            '    WARNING: Not possible to calculate the DC component with & 
            &the approximated formula and one Lorentzian, using two instead.'
            call sigma1_approx_2lorentzian_DC
         case ( '2l' )
            call sigma1_approx_2lorentzian_DC
         case ( '1g'  )
            write(stdout, '(A)') &
            '    WARNING: Not possible to calculate the DC component with & 
            &the approximated formula and one Gaussian, using two instead.'
            call sigma1_approx_2gaussian_DC
         case ( '2g'  )
            call sigma1_approx_2gaussian_DC
         end select

      CASE ( .true. ) ! Exact formulas

         select case ( decomposition )
         case( .false. )

            select case ( deltarep )  ! Exact formulas
            case ('1l','2l')
               call sigma1_exact_lorentzian_DC
            case ('1g','2g')
               call sigma1_exact_gaussian_DC
            end select

         case(.true.) ! Separate degenerate, intra and inter band contributions

            select case ( deltarep )  ! Exact formula
            case ('1l', '2l')
               call sigma1_exact_decomp_lorentzian_DC
            case ('1g', '2g')
               call sigma1_exact_decomp_gaussian_DC
            end select

         end select

      END SELECT SIGMAONEEXACTDC

    CASE( 'atrace' )

      SIGMAONETRACEEXACTDC: SELECT CASE ( sigma1_exact )
      CASE ( .false. ) ! Approximated formula

         select case ( deltarep )
         case ('1l')
            write(stdout, '(A)') &
            '    WARNING: Not possible to calculate the DC component with & 
            &the approximated formula and one Lorentzian, using two instead.'
            call sigma1_atrace_approx_2lorentzian_DC
         case ('2l')
            call sigma1_atrace_approx_2lorentzian_DC
         case ('1g')
            write(stdout, '(A)') &
            '    WARNING: Not possible to calculate the DC component with & 
            &the approximated formula and one Gaussian, using two instead.'
            call sigma1_atrace_approx_2gaussian_DC
         case ('2g')
            call sigma1_atrace_approx_2gaussian_DC
         end select

      CASE ( .true. ) ! Exact formula

         select case ( decomposition )
         case( .false. )

            select case ( deltarep )
            case ('1l','2l')
               call sigma1_atrace_exact_lorentzian_DC
            case ('1g','2g')
               call sigma1_atrace_exact_gaussian_DC
            end select 

         case(.true.) ! Separate degenerate, intra and inter band contributions

            select case ( deltarep )  ! Exact formula
            case ('1l','2l')
               call sigma1_atrace_exact_decomp_lorentzian_DC
            case ('1g','2g')
               call sigma1_atrace_exact_decomp_gaussian_DC
            end select 
            
         end select ! Decomposition

      END SELECT SIGMAONETRACEEXACTDC

   END SELECT SIGMA1TENSORORTRACEDC
   
   
   END SELECT SIGMA1DC


! To implement
!   SELECT CASE ( dc_all )
!   CASE( 'w', 'f', 'a' )
!      write(stdout,*) ' '
!      write(stdout,'(A)',advance='no') &
!   '     Calculating the DC using both the exact and approx sigma1 formula ...'
!!      call sigma1_dc_all_deltarep
!      write(stdout,'(A)') 'done.'
!   END SELECT

   !===========================================================================
   !                          Conductivity tensor (sigma2)
   !===========================================================================

   SIGMA2CALCULATION: SELECT CASE ( calculate_sigma2 )
   CASE(.true.)
   write(stdout,'(A)',advance='no') '     Calculating sigma2 ... '

      SIGMA2TENSORORTRACE: SELECT CASE ( calculation )
      CASE ( 'tensor' )
 
         select case ( decomposition )
         case( .false. )
            call sigma2_sub
         case(.true.) ! Separate degenerate, intra and inter-band contributions
            call sigma2_decomp
         end select 

      CASE( 'atrace' )

         select case ( decomposition )
         case( .false. )
            call sigma2_atrace_sub
         case(.true.) ! Separate degenerate, intra and inter-band contributions
            call sigma2_atrace_decomp
         end select ! Decomposition

      END SELECT SIGMA2TENSORORTRACE

      write(stdout,'(A)') 'done.'

   END SELECT SIGMA2CALCULATION
   
   IF(IONODE) THEN

   !
   ! Sum rules
   !

   ! Sum rule (no delta function)
   if ( .not. readgm ) then
      write(stdout,*) ' ' 
      write(stdout,'(A,f10.3)') "     Sum rule (exact)          :", sumrulef
   endif

   ! Sum rule (with delta function)
   if ( AC ) then
     call sumrule_integral
     write(stdout,'(A,f10.3)') "     Sum rule (int. over freq.):", sumruleintegral
     write(stdout,*)
   endif

   !
   ! SIGMA OUTPUT
   !
   if ( .not. sigma2_via_eps1mod ) call kgec_output_sigma

   ENDIF ! IONODE

   !===========================================================================
   !                Real Part of Dielectric tensor (epsilon_1)
   !===========================================================================
   EPSILON1CALCULATION: SELECT CASE ( calculate_epsilon1 )
   CASE(.true.)
      write(stdout,'(A)') ' '
      if( .not. sigma2_via_eps1mod ) then
           write(stdout,'(A)',advance='no') '     Calculating epsilon1 ... '
      else
           write(stdout,'(A)',advance='no') '     Calculating sigma2 and epsilon1 ... '
      endif
 
      EPSILON1TENSORORTRACE: SELECT CASE ( calculation )
      CASE ( 'tensor' )

         select case ( ac )
         case(.true.) 
            select case ( decomposition )
            case( .false. )
               call epsilon1_tensor
               if ( sigma2_via_eps1mod ) call epsilon1_tensor_sub_sigma2
            case(.true.) ! Separate degenerate, intra and inter-band contributions
               call epsilon1_tensor_decomp
               if ( sigma2_via_eps1mod ) call epsilon1_tensor_decomp_sigma2
            end select 

         end select ! ac

         select case ( dc )
         case(.true.) 

            select case ( decomposition )
            case( .false. )
               call epsilon1_dc_tensor
            case(.true.) ! Separate degenerate, intra and inter-band contributions
               call epsilon1_dc_tensor_decomp
            end select 

         end select ! dc

      CASE( 'atrace' )

         select case ( ac )
         case( .true. )

            select case ( decomposition )
            case( .false. )
               call epsilon1_atrace_sub
               if ( sigma2_via_eps1mod ) call epsilon1_atrace_sub_sigma2
            case(.true.) ! Separate degenerate, intra and inter-band contributions
               call epsilon1_atrace_decomp
               if ( sigma2_via_eps1mod ) call epsilon1_atrace_decomp_sigma2
            end select ! Decomposition

         end select ! ac

         select case ( dc )
         case( .true. )

            select case ( decomposition )
            case( .false. )
print*,"KGEC"
               call epsilon1_dc_atrace_sub
            case(.true.) ! Separate degenerate, intra and inter-band contributions
               call epsilon1_dc_atrace_decomp
            end select ! Decomposition

         end select ! dc

      END SELECT EPSILON1TENSORORTRACE

      write(stdout,'(A)') 'done.'

      if ( IONODE .and. sigma2_via_eps1mod ) then
         calculate_sigma2=.true. ! This is to print out sigma2
         call kgec_output_sigma
      endif

       
   END SELECT EPSILON1CALCULATION


   !===========================================================================
   !               Imaginary Part of Dielectric tensor (epsilon_2)
   !===========================================================================

   EPSILON2CALCULATION: SELECT CASE ( calculate_epsilon2 )
   CASE(.true.)
   write(stdout,*) ' '
   write(stdout,'(A)',advance='no') '     Calculating epsilon2 ... '

      EPSILON2TENSORORTRACE: SELECT CASE ( calculation )
      CASE ( 'tensor' )
 
         select case ( ac )
         case( .true. )

            select case ( decomposition )
            case( .false. )
               call epsilon2_tensor
            case( .true. ) ! Separate degenerate, intra and inter-band contributions
               call epsilon2_tensor_decomp
            end select 
         end select ! ac

         ! Epsilon2 DC is infinity for all components
 
      CASE( 'atrace' )

         select case ( ac )
         case( .true. )
 
            select case ( decomposition )
            case( .false. )
               call epsilon2_atrace_sub
            case( .true. ) ! Separate degenerate, intra and inter-band contributions
               call epsilon2_atrace_decomp
            end select     ! Decomposition

         end select ! ac

         ! Epsilon2 DC is infinity for all components

      END SELECT EPSILON2TENSORORTRACE

      write(stdout,'(A)') 'done.'

   END SELECT EPSILON2CALCULATION

   !
   ! EPSILON OUTPUT
   !

   if ( IONODE .and. calculate_epsilon1 .or. calculate_epsilon2 ) &
       call kgec_output_epsilon

   !
   ! Refraction, Reflection and Absorption Coefficients 
   !

   select case( calculate_rrae )
   case( .true. )
      write(stdout,*) ''
      write(stdout,'(A)',advance='no') &
      '     Calculating refraction, reflection and absorption coeffs. ... '

      if ( AC ) call rrae

      write(stdout,'(A)') 'done.'

      call kgec_output_rrae

   end select




   write(stdout,*) ""
   write(stdout,*) &
          '    ----------------------------------------------------------------'
   write(stdout,*) &
          '           Kubo Greenwood conductivity calculation finished'
   write(stdout,*) &
          '    ----------------------------------------------------------------'

   call environment_end("KGEC FOR QE")

   call mp_global_end()

end program kgec

!
! Copyright (C) 2017- Orbital-free DFT group at University of Florida
!
! This program is free software; you can redistribute it and/or modify 
! it under the terms of the GNU General Public License as published by 
! the Free Software Foundation; either version 2 of the License, or 
! any later version. See the file LICENSE in the root directory of the 
! present distribution, or http://www.gnu.org/copyleft/gpl.txt ,
! or contact developers via e-mail: calderin@lcalderin.net, or paper mail:
!
! Quantum Theory Project
! University of Florida
! P.O. Box 118435
! Gainesville, FL 32611
!
! This program is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
! GNU General Public License for more details.
! 
! Authors: Lazaro Calderin and Valentin Karasiev
!-----------------------------------------------------------------------
! 


module qe_p_psi
!
! Get the <p_i|psi> or <beta_i|psi> from Quantum Espresso
! Get the mapping of the projectors index
!
use kinds,                ONLY : dp
use ions_base,            ONLY : nat, ityp, ntyp => nsp
use cell_base,            ONLY : at, tpiba2
use constants,            ONLY : rytoev
use gvect,                ONLY : g, ngm
use lsda_mod,             ONLY : nspin
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
use klist,                ONLY : xk, nks, nkstot, ngk, igk_k
#elif defined(__QE512) || defined(__QE54)
use klist,                ONLY : xk, nks, nkstot
#endif
use io_files,             ONLY : iunpun, nwordwfc, iunwfc
#if defined(__QE6) || defined(__QE62) || defined(__QE64)
use wvfct,                ONLY : nbnd, et, npw, npwx, g2kin
use gvecw,                ONLY : ecutwfc
#elif defined(__QE54)
use wvfct,                ONLY : nbnd, et, igk, npw, npwx, g2kin
use gvecw,                ONLY : ecutwfc
#elif defined(__QE512)
use wvfct,                ONLY : nbnd, et, ecutwfc, igk, npw, npwx, g2kin
#endif
use uspp,                 ONLY : nkb, vkb !, qq
use uspp_param,           ONLY : upf, nh, nhm, nbetam
use noncollin_module,     ONLY : noncolin, npol
#if defined(__QE64)
use wavefunctions,        ONLY : evc
#else
use wavefunctions_module, ONLY : evc
#endif
use io_global,            ONLY : ionode, ionode_id, stdout
use becmod,               ONLY : calbec, bec_type, allocate_bec_type, deallocate_bec_type

!   use mp,                   ONLY : mp_bcast
!   use mp_world,             ONLY : world_comm

implicit none
!   integer, allocatable, public :: p_index(:,:) ! QE projector index mapping back to atom and lm

   type(bec_type), public, allocatable :: becp(:)  ! <p|\psi>
   public                 :: p_psi ! Subroutine

private
contains

   subroutine p_psi()
   implicit none

      integer :: ik

      allocate( becp(1:nks) )

      do ik = 1, nks
         call allocate_bec_type(nkb, nbnd, becp(ik))
         !
         ! get the k+G vectors for the ik k-point
         !
#if defined(__QE512) || defined(__QE54)
         call gk_sort (xk (1, ik), ngm, g, ecutwfc / tpiba2, npw, igk, g2kin)
#else
         npw = ngk(ik)
#endif

         !
         !   read eigenfunctions
         !
         call davcio (evc, 2*nwordwfc, iunwfc, ik, - 1)

         !
         ! calculate becp = <psi|beta>
         !

#if defined(__QE512) || defined(__QE54)
         call init_us_2 (npw, igk, xk (1, ik), vkb)
#else
         call init_us_2 (npw, igk_k(1,ik), xk(1,ik), vkb)
#endif
         call calbec ( npw, vkb, evc, becp(ik) )

!        IF (noncolin) &
!           CALL compute_sigma_avg(sigma_avg(1,1,ik),becp%nc,ik,lsigma)

      enddo

   !
   ! Mapping of indexes l and m for each type of atom nt -> nh(nt) in the following way:
   !
   !do it = 1, ntyp
   !   ih = 1
   !   do ib = 1, upf(it)%nbeta
   !      do im = 1, 2 * upf(it)%lll (ib) + 1
   !         ih = ih + 1
   !      enddo
   !enddo
   !enddo

   !
   ! Mapping of all atoms projectors index nh index into a jkb index continously and
   ! ordered by type of atom.
   ! Recalculating that here and storing it
   !

   !jkb = 7*nbetam
   !allocate( p_index( 1:nat, 1:jkb ) )

   !jkb = 0
   !do it=1, ntyp
   !   do ia=1, nat
   !      if ( ityp(ia) .eq. it ) then
   !         do ih = 1, nh (it)
   !            jkb = jkb + 1
   !            p_index(ia,ih) = jkb  ! Projectors
   !         enddo
   !     endif
   !  enddo
   !enddo

   end subroutine p_psi

end module qe_p_psi
